﻿using System;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Resources;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Threading;


public partial class EmployeePanel : Base.BasePage
{
    #region Variable Declaration
    ResourceManager rm;
    cls_Common objCommon = new cls_Common();
    EmployeeEventData ObjEmployeeEventData = new EmployeeEventData();
    userRightsEventData objUserRight = new userRightsEventData();
    Dashboard objDash = new Dashboard();
    DataSet dstMyCalendar = new DataSet();
    DataSet dstMyCalendarTeam = new DataSet();
    CultureInfo ci;
    GetReports rptEmp = new GetReports();
    Rpt_Common rptcommon = new Rpt_Common();
    DataSet ds_Checkuser = new DataSet();
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    string testing = null;
    #endregion
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        if (!Page.IsPostBack)
        {
            objCommon.menu("Dashboard", "246");
        }
        if (Session["Session_ActiveLanguage"] == null)
        {
            Response.Redirect("Index.aspx");
        }
        grvAttendancelast7Days.Styles.CssFilePath = Convert.ToString(Session["GridCSS"]);
        //  string source_Language = string.Empty;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        UserRights();
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        LoadStrings(ci);
        if (Session["Session_ActiveLanguage"] != null)
        {
            source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
            rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
            ci = Thread.CurrentThread.CurrentCulture;
        }
        //dstMyCalendar = objDash.GetMyCalendarData(Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["EmpAutoID"]));
        //string MyCalendarDataString = Convert.ToString(dstMyCalendar.Tables[0].Rows[0]["MyCalendarOutput"]);
        string strSetAlert = "";
        //strSetAlert = strSetAlert + "<script language='javascript'>";
        //strSetAlert = strSetAlert + "MyCalendarData('" + MyCalendarDataString + "');";
        //strSetAlert = strSetAlert + "</script>";
        //Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        DataSet dsIsSanction = new DataSet();
        dsIsSanction = objDash.GetIsSanctionUser(Convert.ToString(Session["EmpAutoID"]));
        if (dsIsSanction.Tables.Count > 0)
        {
            if (dsIsSanction.Tables[0].Rows.Count > 0)
            {
                liTeamcalendar.Visible = true;
            }
        }
        if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin")
        {
            liTeamcalendar.Visible = true;
            if (Convert.ToString(Session["EmployeeCodeId"]) == "18000000")
            {
                liUserMycalendar.Visible = false;
            }
        }
        //dstMyCalendarTeam = objDash.GetMyCalendarDataTeam(Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["EmpAutoID"]));
        //MyCalendarDataString = Convert.ToString(dstMyCalendarTeam.Tables[0].Rows[0]["MyCalendarOutput"]);
        strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        //strSetAlert = strSetAlert + "MyCalendarDataTeam('" + MyCalendarDataString + "');clickTeamcalendar();clickUserMycalendar();";
        strSetAlert = strSetAlert + "clickTeamcalendar();GetTeamCalendar();clickUserMycalendar();GetIndividualCalendar();";
        strSetAlert = strSetAlert + "</script>";
        //Session["MyData"] = MyCalendarDataString;
        Page.RegisterStartupScript("CallCalendar", strSetAlert);

        if (!IsPostBack)
        {
            string strdate = DateTime.Now.ToString("yyyy-MM-dd");
            strSetAlert = "";
            strSetAlert = strSetAlert + "<script language='javascript'>";
            strSetAlert = strSetAlert + "ajaxGetmyCalendar('" + strdate + "');";
            strSetAlert = strSetAlert + "</script>";
            Page.RegisterStartupScript("CallCalendarDataLoad", strSetAlert);
        }
        monthlyAttendance();
    }
    #region UserDefinedFunctions

    private void LoadStrings(CultureInfo ci)
    {
        lblLeave.Text = rm.GetString("LeaveApplication_Leave", ci);
        lblAbsent.Text = rm.GetString("Dash_Absent", ci);
        lblHoliday.Text = rm.GetString("Masters_Holidays_Holidays", ci);
        lblWeeklyOff.Text = rm.GetString("MyCalendar_WeekOff", ci);
        lbl_Header.Text = rm.GetString("Menu_Master_MyCalendar_Title", ci);
        lblPresent.Text = rm.GetString("AttendanceCode_Present", ci);
    }

    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(246, Convert.ToInt32(Session["userGroup_Id"]), "");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {

        }
        else
        {
            Response.Redirect("Landing.aspx");
        }
    }
    private void monthlyAttendance()
    {
        DataSet dsEmp = new DataSet();
        string strFromdate, gstrDateFormat, strTodate;
        gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
        string Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));

        strFromdate = objCommon.DateConvertion(gstrDateFormat, DateTime.Now.AddDays(-7).AddYears(-1).ToString());
        strTodate = objCommon.DateConvertion(gstrDateFormat, DateTime.Now.AddDays(0).ToString());

        dsEmp = rptEmp.RawData(strFromdate, strTodate, "", "", 
            Convert.ToString(Session["UserGroupName"]), Convert.ToInt16(Session["parentLevelId"]), 
            0, 0, Convert.ToInt32(0), "Both", 0, 
            Convert.ToInt32(0));

        if (dsEmp.Tables.Count > 0)
        {
            if (dsEmp.Tables[0].Rows.Count > 0)
            {
                grvAttendancelast7Days.DataSource = dsEmp;
                grvAttendancelast7Days.DataBind();
            }
        }
    }
    #endregion
}