using System;
using System.Data;
using System.Globalization;
using System.IO;
using System.Resources;
using System.Text.RegularExpressions;
using System.Threading;
using System.Web.UI;
public partial class Masters_TA_UI_BulkEmployeeConfiguration : Base.BasePage
{
    #region Variable Declaration
    ResourceManager rm;
    CultureInfo ci;
    FileStream aFile;
    String strScript = String.Empty;
    EmployeeEventData objempEvent = new EmployeeEventData();
    userRightsEventData usrRights = new userRightsEventData();
    ManualEntryEventData objManualEntry = new ManualEntryEventData();
    cls_Common objcommon = new cls_Common();
    ImportData ObjImportData = new ImportData();
    public const string MatchEmailPattern =
            @"^(([\w-]+\.)+[\w-]+|([a-zA-Z]{1}|[\w-]{2,}))@"
     + @"((([0-1]?[0-9]{1,2}|25[0-5]|2[0-4][0-9])\.([0-1]?
				[0-9]{1,2}|25[0-5]|2[0-4][0-9])\."
     + @"([0-1]?[0-9]{1,2}|25[0-5]|2[0-4][0-9])\.([0-1]?
				[0-9]{1,2}|25[0-5]|2[0-4][0-9])){1}|"
     + @"([a-zA-Z0-9]+[\w-]+\.)+[a-zA-Z]{1}[a-zA-Z0-9-]{1,23})$";
    #endregion
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking
        base.Page_Load(sender, e);
        //get the culture info to set the language        
        string source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        if (!IsPostBack)
        {
            LoadStrings(ci);
            objcommon.menu("EmployeeMaster", "18");
            bindCategory();
        }
        if (Convert.ToString(Session["UserGroupName"]) != "SuperAdmin" && Convert.ToString(Session["HasSpecialRights"]) != "True")
            Response.Redirect("MasterLandingPage.aspx");
    }
    public string Export(DataSet ds)
    {
        string columnnames = "", body = "", record = "";
        foreach (DataColumn col in ds.Tables[0].Columns)
        {
            columnnames = columnnames + " " + col.ColumnName + " " + ",";
        }
        columnnames = columnnames.Substring(0, columnnames.Length - 1);
        foreach (DataRow row in ds.Tables[0].Rows)
        {
            object[] arr = row.ItemArray;
            for (int i = 0; i <= arr.Length - 1; i++)
            {
                if (arr[i].ToString().IndexOf(",") > 0)
                    record = record + " " + arr[i].ToString() + " " + ",";
                else
                    record = record + arr[i].ToString() + ",";
            }
            body = body + record.Substring(0, record.Length - 1) + System.Environment.NewLine;
            record = "";
        }
        return (columnnames + System.Environment.NewLine + body);
    }
    protected void btn_Template_Click(object sender, EventArgs e)
    {
        try
        {
            string strPath = Server.MapPath("Uploads/EmployeeBulkConfiguration.xls");
            if (File.Exists(strPath))
            {
                DataSet ds = new DataSet();
                FileInfo fileInfo = new System.IO.FileInfo(strPath);
                ds = ObjImportData.ReadExcelSheet(fileInfo);
                string strData = Export(ds);
                byte[] data = System.Text.ASCIIEncoding.ASCII.GetBytes(strData);
                Response.Clear();
                Response.AddHeader("Content-Type", "application/Excel");
                Response.AddHeader("Content-Disposition", "attachment;filename=EmployeeBulkConfiguration.csv");
                Response.BinaryWrite(data);
                Response.End();
            }
            else
            {
                Message(rm.GetString("Alert_Templatefileisnotavailedinthesourcefile", ci));
                return;
            }
        }
        catch
        {
            Message("The Microsoft.Jet.OLEDB.4.0 provider is not registered on the local machine.So Enable 32-bit Applications setting to True, in the Advanced Settings for the Application Pool.");
        }
    }
    protected void btn_Upload_Click(object sender, EventArgs e)
    {
        try
        {
            if (fup_BulkImport.HasFile)
            {
                string filename = fup_BulkImport.FileName.Substring(fup_BulkImport.FileName.LastIndexOf("\\") + 1);
                string fileType = System.IO.Path.GetExtension(filename);
                if (fileType == ".csv")
                {
                    string strFilePath = Server.MapPath("Uploads");
                    FileInfo fileInfo = new System.IO.FileInfo(strFilePath + "\\" + fup_BulkImport.FileName);
                    fup_BulkImport.SaveAs(strFilePath + "\\" + fup_BulkImport.FileName);
                    if (fup_BulkImport.PostedFile.ContentLength == fileInfo.Length)
                    {
                        if (ddlchange.SelectedValue == "0")
                        {
                            Message(rm.GetString("Alert_SelectCategory", ci));
                            return;
                        }
                        if (ddlchange.SelectedValue != "7" && ddlchange.SelectedValue != "8")
                        {
                            if (rdby2n.Checked != true && rdbn2y.Checked != true)
                            {
                                Message(rm.GetString("Alert_Selectchangethestatusfromoption", ci));
                                return;
                            }
                        }
                        int updated = ImportShiftData(fileInfo);
                        if (updated > 0)
                        {
                            ddlchange.SelectedValue = "0";
                            rdbn2y.Checked = false;
                            rdby2n.Checked = false;
                            Message(rm.GetString("Alert_Fileisimportedsuccessfully", ci));
                            return;
                        }
                    }
                    else
                        Message(rm.GetString("Alert_ErrorinShiftImporting", ci));
                }
                else
                    Message(rm.GetString("Alert_TheUploadedfileisnotCsvfile", ci));
            }
            else
                Message(rm.GetString("Alert_Youhavenotspecifiedafile", ci));
        }
        catch (Exception ex)
        {
            string strErr = Convert.ToString(ex.Message);
            Message(strErr.Replace("\r", "").Replace("\n", ""));
            if (aFile != null) aFile.Dispose();
        }
        finally
        {
            try
            {
                if (fup_BulkImport.HasFile)
                {
                    string StrFilePath = Convert.ToString(Server.MapPath("Uploads")) + "\\" + fup_BulkImport.FileName;
                    System.IO.File.Delete(StrFilePath);
                }
            }
            catch (Exception Ex)
            {
            }
            if (aFile != null) aFile.Dispose();
        }
    }
    #region User Define Functions
    private int ImportShiftData(FileInfo fileInfo)
    {
        int Updated = 0;
        try
        {
            string strLine;
            string validationMsg = string.Empty;
            string[] strArray;
            char[] charArray = new char[] { ',' };
            DataSet dsBulkImport = new DataSet("Dst_bulkimport");
            DataTable dtBulkImport = dsBulkImport.Tables.Add("EmployeeBulkImport");
            dtBulkImport.Columns.Add("Employee_Id");
            dtBulkImport.Columns.Add("UserGroup");
            dtBulkImport.Columns.Add("EmailID");
            aFile = new FileStream(fileInfo.FullName.ToString(), FileMode.Open);
            StreamReader sr = new StreamReader(aFile);
            strLine = sr.ReadLine();
            strArray = strLine.Split(charArray);
            if (strArray.Length != 3)
            {
                Message(rm.GetString("Alert_ImportthevalidCSVfile", ci));
                return 0;
            }
            if (strArray.Length != dtBulkImport.Columns.Count)
            {
                Message(rm.GetString("Alert_ImportthevalidCSVfile", ci));
                return 0;
            }
            strLine = sr.ReadLine();
            strArray = null;
            if (strLine == null)
            {
                Message(rm.GetString("Alert_Thereisnorecordinthefile", ci));
                return 0;
            }
            else
            {
                while (strLine != null)
                {
                    strArray = strLine.Split(charArray);
                    if (strArray[0].Trim().Replace("\"", "") == string.Empty)
                    {
                        validationMsg = rm.GetString("Alert_PleasefillEmployeeCodeforallemployees", ci);
                        Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                        sr.Dispose();
                        aFile.Dispose();
                        return 0;
                    }
                    else
                    {
                        DataSet dsEmpAutoId = new DataSet();
                        dsEmpAutoId = objManualEntry.getEmployeeAutoIdForImport(Convert.ToString(strArray[0]));
                        if (dsEmpAutoId.Tables[0].Rows.Count == 0)
                        {
                            validationMsg = "Invalid Employee ID - " + Convert.ToString(strArray[0]) + ". Kindly remove and import the file once again.";
                            Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                            sr.Dispose();
                            aFile.Dispose();
                            return 0;
                        }
                    }
                    if (ddlchange.SelectedValue != "0")
                    {
                        if (ddlchange.SelectedValue == "7")
                        {
                            if (strArray[1].Trim().Replace("\"", "") == string.Empty)
                            {
                                validationMsg = "Please fill User Group for all employees";
                                Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                                sr.Dispose();
                                aFile.Dispose();
                                return 0;
                            }
                            else
                            {
                                //validate usergroup is available or not.
                                DataSet ds = new DataSet();
                                ds = usrRights.checkDuplication(Convert.ToString(strArray[1]).Trim().Replace("'", "''"));
                                if (ds.Tables[0].Rows.Count == 0)
                                {
                                    validationMsg = "Invalid Usergroup Name - " + Convert.ToString(strArray[1]) + ". Kindly remove and import the file once again.";
                                    Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                                    sr.Dispose();
                                    aFile.Dispose();
                                    return 0;
                                }
                            }
                        }
                        if (ddlchange.SelectedValue == "8")
                        {
                            if (strArray[2].Trim().Replace("\"", "") == string.Empty)
                            {
                                validationMsg = "Please fill Email ID for all employees";
                                Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                                sr.Dispose();
                                aFile.Dispose();
                                return 0;
                            }
                            else
                            {
                                if (IsEmail(strArray[2].Trim().Replace("\"", "")) == false)
                                {
                                    validationMsg = "Invalid Email ID - " + Convert.ToString(strArray[2]) + ". Kindly remove and import the file once again.";
                                    Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                                    sr.Dispose();
                                    aFile.Dispose();
                                    return 0;
                                }
                            }
                        }
                    }
                    dtBulkImport.Rows.Add(strArray);
                    strLine = sr.ReadLine();
                }
            }
            StringWriter strShiftAlloc = new StringWriter();
            dsBulkImport.WriteXml(strShiftAlloc);
            aFile.Dispose();
            objempEvent.EmployeeBulkConfiguration(Convert.ToString(strShiftAlloc), Convert.ToInt16(ddlchange.SelectedValue), (rdby2n.Checked == true) ? 1 : 0);
            Updated = 1;
        }
        catch
        {
            Updated = 0;
        }
        return Updated;
    }
    public static bool IsEmail(string email)
    {
        if (email != null) return Regex.IsMatch(email, MatchEmailPattern);
        else return false;
    }
    private void LoadStrings(CultureInfo ci)
    {
        lbl_Header.Text = rm.GetString("btn_BulkConfiguration", ci);
        lblMandatoryFields.Text = rm.GetString("IndicatesMandatoryFields", ci);
        lblImportFilePath.Text = rm.GetString("SelectFile", ci);
        lblEligible.Text = rm.GetString("lblCategory", ci);
        lblChange.Text = rm.GetString("lblChangethestatus", ci);
        rdby2n.Text = rm.GetString("ShiftSetting_Yes", ci);
        rdbn2y.Text = rm.GetString("ShiftSetting_No", ci);
        btn_Template.Text = "&nbsp;&nbsp;" + rm.GetString("strDownloadTemplate", ci);
        btn_Upload.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Upload", ci);
        btnBack.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
        lblImportNote.Text = rm.GetString("Field_ImportantNote", ci);
    }
    #endregion
    protected void btnBack_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Master_Employee.aspx");
    }
    private void bindCategory()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("ID", typeof(int));
        dt.Columns.Add("Text", typeof(string));
        dt.Rows.Add(0, "-Select-");
        dt.Rows.Add(1, "Over Time Eligible");
        dt.Rows.Add(2, "Comp off  Eligible");
        dt.Rows.Add(3, "Over Time & Comp off  Eligible");
        dt.Rows.Add(4, "Report Exclude");
        dt.Rows.Add(6, "Hostel");
        dt.Rows.Add(7, "User Group");
        dt.Rows.Add(8, "Email ID");
        ddlchange.DataSource = dt;
        ddlchange.DataBind();
        if (dt.Rows.Count > 0)
        {
            ddlchange.DataSource = dt;
            ddlchange.DataTextField = "Text";
            ddlchange.DataValueField = "ID";
            ddlchange.DataBind();
        }
        dt.Dispose();
        foreach (System.Web.UI.WebControls.ListItem item in ddlchange.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
}
