﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Globalization;
using System.Linq;
using System.Resources;
using System.Threading;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
public partial class Masters_TA_UI_Master_DashboardRights : Base.BasePage
{
    #region VariableDeclaration
    ResourceManager rm;
    userRightsEventData objUserRight = new userRightsEventData();
    cls_Common objCommon = new cls_Common();
    DataSet ds = new DataSet();
    int employeeId = 0;
    CultureInfo ci;
    string strSetAlert = string.Empty;
    LeaveEventData objLeave = new LeaveEventData();
    #endregion
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!Page.IsPostBack)
            objCommon.menu("Previlege", "21");
        //get the culture info to set the language        
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        // LoadStrings Function fills the Label from the Resource File
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_Are_you_sure_to_Save", ci) + "','" + rm.GetString("Alert_Selectanyonedisplayoption", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        grv_EmpDetails.Styles.CssFilePath = grdviewAllEmployees.Styles.CssFilePath = Convert.ToString(Session["GridCSS"]);
        if (Convert.ToString(ViewState["AssignedEmployees"]) != string.Empty)
        {
            DataTable dt = (DataTable)ViewState["AssignedEmployees"];
            dt.DefaultView.RowFilter = "Assigned=1";
            grv_EmpDetails.DataSource = dt;
            grv_EmpDetails.DataBind();
        }
        if (Convert.ToString(ViewState["UnAssignedEmployees"]) != string.Empty)
        {
            DataTable dt = (DataTable)ViewState["UnAssignedEmployees"];
            dt.DefaultView.RowFilter = "Assigned=0 and Employee_Status=1";
            grdviewAllEmployees.DataSource = dt;
            grdviewAllEmployees.DataBind();
        }
        if (!IsPostBack)
        {
            if (Convert.ToString(Request.QueryString["frm"]) == "dash")
            {
                lblDashboardRights.Text = rm.GetString("lblDashboardRights", ci);
                divDash.Visible = true;
                divAssign.Visible = false;
                divUnAssign.Visible = false;
            }
            else if (Convert.ToString(Request.QueryString["frm"]) == "Assign")
            {
                lblDashboardRights.Text = rm.GetString("AssignedTo", ci);
                divDash.Visible = false;
                divAssign.Visible = true;
                divUnAssign.Visible = true;
            }
            BindBoardDetails();
        }
    }
    private void BindBoardDetails()
    {
        DataSet ds = new DataSet();
        ds = objUserRight.SelectDashboardRights(Convert.ToInt16(Request.QueryString["gId"]));
        int firstlistItemcount = 0;
        int secondlistItemcount = 0;
        int ThirdlistItemcount = 0;
        if (ds.Tables.Count > 0)
        {
            if (Convert.ToString(Request.QueryString["frm"]) == "Assign")
            {
                if (ds.Tables[5].Rows.Count > 0)
                {
                    ds.Tables[5].DefaultView.RowFilter = "Assigned=1";
                    ds.AcceptChanges();
                    ViewState["AssignedEmployees"] = ds.Tables[5];
                    grv_EmpDetails.DataSource = ds.Tables[5];
                    grv_EmpDetails.DataBind();
                }
                else
                {
                    grv_EmpDetails.DataSource = "";
                    grv_EmpDetails.DataBind();
                    ViewState["AssignedEmployees"] = "";
                }
                if (ds.Tables[6].Rows.Count > 0)
                {
                    ds.Tables[6].DefaultView.RowFilter = "Assigned=0 and Employee_Status=1";
                    ViewState["UnAssignedEmployees"] = ds.Tables[6];
                    grdviewAllEmployees.DataSource = ds.Tables[6];
                    grdviewAllEmployees.DataBind();
                }
                else
                {
                    grdviewAllEmployees.DataSource = "";
                    grdviewAllEmployees.DataBind();
                    ViewState["UnAssignedEmployees"] = "";
                }
            }
            else
            {
                if (ds.Tables[0].Rows.Count > 0)
                {
                    chklstAttendance.DataSource = ds.Tables[0];
                    chklstAttendance.DataValueField = "DataId";
                    chklstAttendance.DataTextField = "BoardChildName";
                    chklstAttendance.DataBind();
                    foreach (ListItem list in chklstAttendance.Items)
                    {
                        switch (list.Text)
                        {
                            case "Present":
                                list.Text = rm.GetString("AttendanceCode_Present", ci);
                                break;
                            case "Absent":
                                list.Text = rm.GetString("Dash_Absent", ci);
                                break;
                            case "Leave Taken":
                                list.Text = rm.GetString("BonusLeaveAllocation_LeaveTaken", ci);
                                break;
                            case "OnDuty":
                                list.Text = rm.GetString("Dash_OnDuty", ci);
                                break;
                            case "Punctuality":
                                list.Text = rm.GetString("Dash_Punctuality", ci);
                                break;
                            case "Attendance Summary":
                                list.Text = rm.GetString("Dashboard_AttSum", ci);
                                break;
                            case "Approved Leave":
                                list.Text = rm.GetString("Dash_ApprovedLeave", ci);
                                break;
                            case "Approved Onduty":
                                list.Text = rm.GetString("Dash_ApprovedOnDuty", ci);
                                break;
                            default:
                                break;
                        }
                    }
                    for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
                    {
                        ListItem AttendanceListItem = chklstAttendance.Items.FindByValue(Convert.ToString(ds.Tables[0].Rows[i]["DataId"]));
                        if (AttendanceListItem != null)
                        {
                            if (Convert.ToString(ds.Tables[0].Rows[i]["ViewPrev"]) == "1")
                            {
                                AttendanceListItem.Selected = true;
                                firstlistItemcount += 1;
                            }
                        }
                    }
                    if (firstlistItemcount == chklstAttendance.Items.Count)
                        cbAttendanceAll.Checked = true;
                }
                if (ds.Tables[1].Rows.Count > 0)
                {
                    chklstApproval.DataSource = ds.Tables[1];
                    chklstApproval.DataValueField = "DataId";
                    chklstApproval.DataTextField = "BoardChildName";
                    chklstApproval.DataBind();
                    foreach (ListItem list in chklstApproval.Items)
                    {
                        switch (list.Text)
                        {
                            case "Leave":
                                list.Text = rm.GetString("LeaveApplication_Leave", ci);
                                break;
                            case "Onduty":
                                list.Text = rm.GetString("Dash_OnDuty", ci);
                                break;
                            case "Permission":
                                list.Text = rm.GetString("Dash_Permission", ci);
                                break;
                            default:
                                break;
                        }
                    }
                    for (int i = 0; i < ds.Tables[1].Rows.Count; i++)
                    {
                        ListItem ApprovalListItem = chklstApproval.Items.FindByValue(Convert.ToString(ds.Tables[1].Rows[i]["DataId"]));
                        if (ApprovalListItem != null)
                        {
                            if (Convert.ToString(ds.Tables[1].Rows[i]["ViewPrev"]) == "1")
                            {
                                ApprovalListItem.Selected = true;
                                secondlistItemcount += 1;
                            }
                        }
                    }
                    if (secondlistItemcount == chklstApproval.Items.Count)
                        cbApprovalAll.Checked = true;
                }
                if (ds.Tables[2].Rows.Count > 0)
                {
                    chklstException.DataSource = ds.Tables[2];
                    chklstException.DataValueField = "DataId";
                    chklstException.DataTextField = "BoardChildName";
                    chklstException.DataBind();
                    foreach (ListItem list in chklstException.Items)
                    {
                        switch (list.Text)
                        {
                            case "Late Entry":
                                list.Text = rm.GetString("Dashboard_Late", ci);
                                break;
                            case "Early Exit":
                                list.Text = rm.GetString("Dash_EarlyExit", ci);
                                break;
                            case "Less Hours Worked":
                                list.Text = rm.GetString("Dash_LessHoursWorked", ci);
                                break;
                            case "Overtime":
                                list.Text = rm.GetString("Menu_Reports_OverTime", ci);
                                break;
                            case "Discrepancy":
                                list.Text = rm.GetString("Report_Discrepancy", ci);
                                break;
                            case "Approved Overtime":
                                list.Text = rm.GetString("lbl_ApprovedOvertime", ci);
                                break;
                            case "Non Processed Record":
                                list.Text = rm.GetString("Dash_NonProcessedRecord", ci);
                                break;
                            default:
                                break;
                        }
                    }
                    for (int i = 0; i < ds.Tables[2].Rows.Count; i++)
                    {
                        ListItem ExceptionListItem = chklstException.Items.FindByValue(Convert.ToString(ds.Tables[2].Rows[i]["DataId"]));
                        if (ExceptionListItem != null)
                        {
                            if (Convert.ToString(ds.Tables[2].Rows[i]["ViewPrev"]) == "1")
                            {
                                ExceptionListItem.Selected = true;
                                ThirdlistItemcount += 1;
                            }
                        }
                    }
                    if (ThirdlistItemcount == chklstException.Items.Count)
                    {
                        cbExcepAll.Checked = true;
                    }
                }
                if (ds.Tables[3].Rows.Count > 0)
                {
                    if (Convert.ToInt16(ds.Tables[3].Rows[0][0]) == 1)
                        chkbxDash.Checked = true;
                    if (Convert.ToInt16(ds.Tables[3].Rows[0][1]) == 1)
                        chkbxGrid.Checked = true;
                    if (Convert.ToInt16(ds.Tables[3].Rows[0][2]) == 1)
                        chkbxChart.Checked = true;
                }
            }
            if (ds.Tables[4].Rows.Count > 0)
                this.lblGroupName.Text = Convert.ToString(ds.Tables[4].Rows[0]["groupName"]);
        }
    }
    private void LoadStrings(CultureInfo ci)
    {
        lbl_HeaderUserGroups.Text = rm.GetString("Menu_Masters_UserGroups", ci);
        grdviewAllEmployees.Columns[3].Caption = rm.GetString("UserGroups_UserGroupName", ci);
        lbl_UserGroup.Text = rm.GetString("UserGroups_UserGroupName", ci) + " :";
        lnkbtnRemove.Text = "&nbsp;&nbsp;" + rm.GetString("AssignedEmployees_Remove", ci);
        lnkbtnBack1.Text = lnkbtnback.Text = btn_cancel.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
        btn_save.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Save", ci);
        btn_cancel.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
        lblDashboardRights.Text = rm.GetString("lblDashboardRights", ci);
        lblAttendanceBoard.Text = rm.GetString("Dashboard_AttData", ci);
        lblApprovalBoard.Text = rm.GetString("Dashboard_AppData", ci);
        lblExceptionData.Text = rm.GetString("Dashboard_ExcData", ci);
        lblDisplay.Text = rm.GetString("lblDisplay", ci);
        cbAttendanceAll.Text = rm.GetString("cbAll", ci);
        cbApprovalAll.Text = rm.GetString("cbAll", ci);
        cbExcepAll.Text = rm.GetString("cbAll", ci);
        chkbxDash.Text = rm.GetString("Menu_Master_Dashboard", ci);
        chkbxGrid.Text = rm.GetString("Dash_Grid", ci);
        chkbxChart.Text = rm.GetString("Dash_Chart", ci);
        grdviewAllEmployees.Columns[1].Caption = grv_EmpDetails.Columns[1].Caption = rm.GetString("Field_EmployeeID", ci);
        grdviewAllEmployees.Columns[2].Caption = grv_EmpDetails.Columns[2].Caption = rm.GetString("Field_EmployeeName", ci);
        grdviewAllEmployees.Columns[4].Caption = grv_EmpDetails.Columns[3].Caption = rm.GetString("EmployeeMaster_EmployeeStatus", ci);
        lblNote.Text = rm.GetString("AssignedEmpNote", ci);
        lblNotes1.Text = rm.GetString("AssignedEmpNote1", ci);
        lnkbtnAdd.Text = "&nbsp;&nbsp" + rm.GetString("btn_Add", ci);
    }
    protected void btn_cancel_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Master_groupView.aspx");
    }
    protected void btn_save_Click(object sender, EventArgs e)
    {
        string strScript = "";
        if (chkbxDash.Checked == false && chkbxGrid.Checked == false && chkbxChart.Checked == false)
        {
            Message(rm.GetString("Alert_Selectanyonedisplayoption", ci));
            return;
        }
        else
        {
            InsertDashboardRightsDetails(chklstAttendance, "AttendanceData");
            InsertDashboardRightsDetails(chklstApproval, "ApprovalData");
            InsertDashboardRightsDetails(chklstException, "ExceptionData");
            MessageWithreplace(rm.GetString("Alert_DashboardRightssavedsuccessfully", ci), "TA_UI_Master_groupView.aspx");
            return;
        }
    }
    private void InsertDashboardRightsDetails(CheckBoxList chkboxlist, string BoardName)
    {
        for (int i = 0; i < chkboxlist.Items.Count; i++)
        {
            objUserRight.InsertDashboardRightDetails
                (
                Convert.ToString(lblGroupName.Text),
                Convert.ToInt16(chkboxlist.Items[i].Value),
                chkbxDash.Checked == true ? 1 : 0,
                chkbxGrid.Checked == true ? 1 : 0,
                chkbxChart.Checked == true ? 1 : 0,
                Convert.ToInt16(Session["EmpAutoId"]),
                chkboxlist.Items[i].Selected == true ? 1 : 0
                );
        }
    }
    protected void lnkbtnRemove_Click(object sender, EventArgs e)
    {
        if (hdnSelectRow.Value != string.Empty && hdnSelectRow.Value != null)
        {
            string[] ChkBoxIDs;
            ChkBoxIDs = objLeave.commaStringToArray(hdnSelectRow.Value);
            for (int i = 0; i < ChkBoxIDs.Length; i++)
            {
                objUserRight.RemoveEmployee_SelectedUserGroup(Convert.ToInt32(ChkBoxIDs[i]), "R", Convert.ToInt16(Request.QueryString["gId"]));
            }
            hdnSelectRow.Value = "";
            ViewState["UnAssignedEmployees"] = "";
            ViewState["AssignedEmployees"] = "";
            base.Message(rm.GetString("AssignedEmpRemoveAlert", ci).Replace("#", lblGroupName.Text));
            BindBoardDetails();
        }
        else
        {
            Message(rm.GetString("DeletionRecordAlert", ci));
            return;
        }
    }
    protected void lnkbtnAdd_Click(object sender, EventArgs e)
    {
        if (hdnSelectRowAdd.Value != string.Empty && hdnSelectRowAdd.Value != null)
        {
            string[] ChkBoxIDs;
            ChkBoxIDs = objLeave.commaStringToArray(hdnSelectRowAdd.Value);
            for (int i = 0; i < ChkBoxIDs.Length; i++)
            {
                objUserRight.RemoveEmployee_SelectedUserGroup(Convert.ToInt32(ChkBoxIDs[i]), "A", Convert.ToInt16(Request.QueryString["gId"]));
            }
            hdnSelectRowAdd.Value = "";
            ViewState["UnAssignedEmployees"] = "";
            ViewState["AssignedEmployees"] = "";
            base.Message(rm.GetString("AssignedEmpAddAlert", ci).Replace("#", lblGroupName.Text));
            BindBoardDetails();
        }
        else
        {
            Message(rm.GetString("DeletionRecordAlert", ci));
            return;
        }
    }
}