﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Reports_Excel_Export : System.Web.UI.Page
{
    GetReports rptEmp = new GetReports();
    string ReportName = string.Empty;
    string frmDate = string.Empty;
    string toDate = string.Empty;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request.QueryString["ReportName"] != null)
        {
            ReportName = Convert.ToString(Request.QueryString["ReportName"]);
        }
        if (Request.QueryString["FrmDate"] != null)
        {
            frmDate = Convert.ToString(Request.QueryString["FrmDate"]);
        }
        if (Request.QueryString["toDate"] != null)
        {
            toDate = Convert.ToString(Request.QueryString["toDate"]);
        }
        if (Session["Export_ExcelData"] != null)
        {
            try
            {
                ExportToExcel((DataSet)Session["Export_ExcelData"], ReportName, frmDate, toDate);
                Session["Export_ExcelData"] = null;
            }
            catch (Exception ex)
            {
                throw;
            }
        }
    }
    public void ExportToExcel(DataSet dsEmp, string rptName, string frmDate, string toDate)
    {
        string strHead = "";
        strHead = "<HTML xmlns:x='urn:schemas-microsoft-com:office:excel'>";
        strHead += "<HEAD><style>  <!--table";
        strHead += "  @page {mso-header-data:'&CMultiplication Table\\000ADate\\: &D\\000APage &P';mso-page-orientation:landscape;}";
        strHead += "br{mso-data-placement:same-cell;}";
        strHead += ".style0{color:#000000;font-size:11.0pt;font-weight:400;font-style:normal;text-decoration:none;font-family:Calibri;mso-font-charset:134;border:none;mso-protection:locked visible;mso-style-name:'Normal';mso-style-id:0;}";
        strHead += "td{mso-style-parent:style0;padding-top:1px;padding-right:1px;padding-left:1px;mso-ignore:padding;color:#000000;font-size:11.0pt;font-weight:400;font-style:normal;text-decoration:none;font-family:Calibri;mso-font-charset:134;border:none;mso-protection:locked visible;}";
        strHead += ".xl65{mso-style-parent:style0;text-align:center;white-space:normal;font-size:14.0pt;font-weight:700;mso-generic-font-family:auto;mso-font-charset:134;border:.5pt solid windowtext;}";
        strHead += ".xl66{ mso - style - parent:style0; text - align:center; white - space:normal; font - size:16.0pt; mso - font - charset:134; border: .5pt solid windowtext;}";
        strHead += ".xl67{mso-style-parent:style0;text-align:center;white-space:normal;font-size:12.0pt;font-weight:700;mso-generic-font-family:auto;mso-font-charset:134;	border:.5pt solid windowtext;}";
        strHead += ".xl68{ mso - style - parent:style0; text - align:center; white - space:normal; mso - pattern:auto none; background:#00B0F0;color:#F2F2F2;font-size:12.0pt;font-weight:700;mso-font-charset:134;border:.5pt solid windowtext;}";
        strHead += ".xl69{mso-style-parent:style0; text - align:center;white-space:normal;mso-pattern:autonone;background:#00B0F0;color:#F2F2F2;font-size:12.0pt;font-weight:700;mso-font-charset:134;border:.5ptsolidwindowtext;}";
        strHead += ".xl70{mso-style-parent:style0;white-space:normal;mso-font-charset:134;border:.5pt solid windowtext;}";
        strHead += ".xl71{mso-style-parent:style0;mso-number-format:'dd\\-mm\\-yyyy';white-space:normal;mso-font-charset:134;border:.5pt solid windowtext;}";
        strHead += "td{ mso - style - parent:style0; padding - top:1px; padding - right:1px; padding - left:1px; mso - ignore:padding; color:#000000;font-size:11.0pt;font-weight:400;font-style:normal;text-decoration:none;font-family:Calibri;mso-font-charset:134;border:none;mso-protection:locked visible;}";
        strHead += "--></style>";
        strHead += "<!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet>";
        strHead += "<x:Name>" + rptName + " Report</x:Name><x:WorksheetOptions><x:Print><x:ValidPrinterInfo/>";
        strHead += "</x:Print></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook>";
        strHead += "</xml><![endif]--></HEAD><body><table width='868' style='width:651.00pt;border-collapse:collapse;table-layout:fixed;' border='0' cellspacing='0' cellpadding='0'><colgroup><col width='45' style='mso-width-source:userset;mso-width-alt:1645;'><col width='90' style='mso-width-source:userset;mso-width-alt:3291;'><col width='200' style='mso-width-source:userset;mso-width-alt:7314;'><col width='171' style='mso-width-source:userset;mso-width-alt:6253;'><col width='55' style='mso-width-source:userset;mso-width-alt:2011;'><col width='78' style='mso-width-source:userset;mso-width-alt:2852;'><col width='32' style='mso-width-source:userset;mso-width-alt:1170;'><col width='88' style='mso-width-source:userset;mso-width-alt:3218;'><col width='109' style='mso-width-source:userset;mso-width-alt:3986;'></colgroup>";

        dsEmp.Tables[0].TableName = "Sheet 1";
        DataTable dt = dsEmp.Tables[0];
        dt.TableName = "Sheet 1";
        string saveAsFileName = string.Format(rptName + "Report-{0:d}", DateTime.Now).Replace("/", "-").Replace(" ", "");
        string attachment = "attachment; filename=" + saveAsFileName + ".xls";
        Response.ClearContent();
        Response.AddHeader("content-disposition", attachment);
        Response.ContentType = "application/vnd.ms-excel";
        Response.Write(strHead);
        DataTable dtLevelName = new DataTable();
        int colspan = GetColspanValue(rptName);

        if (Convert.ToInt16(Session["parentLevelId"]) != 0)
        {
            dtLevelName = rptEmp.getHeader(Convert.ToInt16(Session["parentLevelId"]));
            if (dtLevelName.Rows.Count > 0)
            {
                Response.Write("<tr height='28' style='height:21.00pt;'>");
                Response.Write("<td width = '1060.47' height = '28' class='xl65' style='height:21.00pt;width:795.35pt;border-right:.5pt solid windowtext;border-bottom:.5pt solid windowtext;' colspan=" + colspan + ">" + Convert.ToString(dtLevelName.Rows[0][0]) + "</td>");
                Response.Write("</tr>");
            }
        }
        Response.Write("<tr height='25' style='height:19.50pt;'>");


        Response.Write("<td height='26' class='xl67' style='height: 19.50pt; border - right:.5pt solid windowtext; border - bottom:.5pt solid windowtext;' colspan=" + colspan + " x:str>" + rptName + " Report From - " + frmDate + " To " + toDate + "</td>");
        Response.Write("</tr>");
        Response.Write("<tr height='21' style='height:15.75pt;mso-height-source:userset;mso-height-alt:315;'>");
        int increment = 1;
        Response.Write("<td height='21' class='xl69' style='height: 15.75pt;' x:str>Sl.No.</td>");
        foreach (DataColumn dc in dt.Columns)
        {
            GenerateExcelHeaders(dt, increment, dc);
        }
        Response.Write("</tr><tr height='40' style='height:16.00pt;'>");

        foreach (DataRow dr in dt.Rows)
        {
            Response.Write("<td height='20' class='xl70' style='height: 16.00pt;' x:num>" + increment + "</td>");
            for (int i = 0; i < dt.Columns.Count; i++)
            {
                if (rptName == "General Monthly" && i > 13)
                    break;
                else if (rptName == "Raw Data" && i > 6)
                    break;
                else if (rptName == "Monthly Attendance" && i > 15)
                    break;
                else if (rptName == "Punctuality" && i > 8)
                    break;
                else if (rptName == "Worked Days" && i > 5)
                    break;
                switch (i)
                {
                    case 5:
                        Response.Write("<td class='xl70'>" + dr[i].ToString() + "</td>");
                        break;
                    case 3:
                        Response.Write("<td class='xl70'>" + dr[i].ToString() + "</td>");
                        break;
                    default:
                        Response.Write("<td class='xl70'>" + dr[i].ToString() + "</td>");
                        break;
                }
            }
            increment += 1;
            Response.Write("</tr>");
        }
        Response.Write("</BODY></HTML>");
        Response.End();
        return;
    }

    private static int GetColspanValue(string rptName)
    {
        int colspan = 9;
        switch (rptName)
        {
            case "Absent":
                colspan = 10;
                break;
            case "All Swipes":
                colspan = 17;
                break;
            case "All Swipes First and Last Punch Details":
            case "All Swipes Report With Matched Punches":
            case "Other All Swipes Details":
                colspan = 14;
                break;
            case "All Swipes Report Without Matched Punches":
                colspan = 16;
                break;
            case "Monthly Attendance":
                colspan = 17;
                break;
            case "General Monthly":
                colspan = 15;
                break;
            case "Raw Data":
                colspan = 8;
                break;
            case "Punctuality":
                colspan = 10;
                break;
            case "Worked Days":
                colspan = 7;
                break;
            default:
                break;
        }

        return colspan;
    }

    private void GenerateExcelHeaders(DataTable dt1, int increment, DataColumn dc)
    {
        string fieldName = "";
        switch (dc.ColumnName)
        {
            case "SlNo":
                fieldName = " Sl.No.";
                break;
            case "Employee Name":
            case "empName":
            case "EmployeeName":
            case "EMPNAME":
            case "Employee_FirstName":
                fieldName = " Employee Name";
                break;
            case "Employee ID":
            case "Employee_Id":
            case "EMPLOYEE_ID":
            case "Employee_Code_Id":
                fieldName = " Employee ID";
                break;
            case "Designation":
            case "DESIGNATION":
            case "TitleName":
                fieldName = " Designation";
                break;
            case "Level Name":
            case "BRANCHNAME":
            case "BranchName":
                fieldName = " Level Name";
                break;
            case "Gender":
                fieldName = "Gender";
                break;
            case "Total Days Worked":
                fieldName = "Total Days Worked (Present)";
                break;
            case "Shift_ShortName":
            case "ShftShrtName":
            case "SHIFT_SHORTNAME":
            case "shift_shortName":
                fieldName = "SSN";
                break;
            case "Date":
            case "DATE":
                fieldName = "Date";
                break;
            case "First Session":
                fieldName = "First Session";
                break;
            case "Second Session":
                fieldName = "Second Session";
                break;
            case "In Reader ID":
                fieldName = "In ReaderID";
                break;
            case "In Date":
            case "Indate":
                fieldName = "In Date";
                break;
            case "In Time":
            case "InTime":
            case "INTIME":
                fieldName = "In Time";
                break;
            case "In Punch Type":
            case "Clk_InPunchType":
                fieldName = "In Punch Type";
                break;
            case "Out Punch Type":
            case "Clk_OutPunchType":
                fieldName = "Out Punch Type";
                break;
            case "Out Reader ID":
                fieldName = "Out ReaderID";
                break;
            case "Out Date":
            case "Outdate":
                fieldName = "Out Date";
                break;
            case "Out Time":
            case "OutTime":
            case "OUTTIME":
                fieldName = "Out Time";
                break;
            case "Remarks":
                fieldName = "Remarks";
                break;
            case "HrsWork":
            case "HRSWORK":
                fieldName = "Hrs Work";
                break;
            case "Excess":
                fieldName = "Excess / Discrepancy Hours(hh:mm)";
                break;
            case "Terminal_Name":
                fieldName = "Terminal ID";
                break;
            case "PunchDate":
                fieldName = "Punch Date";
                break;
            case "PunchTime":
                fieldName = "Punch Time";
                break;
            case "PunchType":
                fieldName = "Punch Type (Value)";
                break;
            case "Process":
                fieldName = "Status";
                break;
            case "BREAKHOURS":
                fieldName = "TBH";
                break;
            case "LUNCHHOURS":
                fieldName = "TLH";
                break;
            case "OVERTIMEHours":
                fieldName = "OT";
                break;
            case "LATEIN":
                fieldName = "Late In";
                break;
            case "EARLYOUT":
                fieldName = "Early Out";
                break;
            case "FIRSTSESSION":
                fieldName = "First Session";
                break;
            case "SECONDSESSION":
                fieldName = "Second Session";
                break;
            case "shiftIn":
                fieldName = "Allocated Shift InTime";
                break;
            case "Outpunch":
            case "Inpunch":
                fieldName = "Punch Type";
                break;
        }
        if (fieldName != "")
            Response.Write("<td class='xl68'> " + fieldName + "</td>");
    }
}