using System;
using System.Data;
using System.Globalization;
using System.Resources;
using System.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;
public partial class Reports_TA_UI_Report_Employee : Base.BasePage
{
    #region Variable Declaration
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    HeaderInformation hdrTable = new HeaderInformation();
    GetReports rptEmp = new GetReports();
    Rpt_Common rptcommon = new Rpt_Common();
    LeaveEventData objLeave = new LeaveEventData();
    ResourceManager rm;
    CultureInfo ci;
    cls_Common objCommon = new cls_Common();
    EmployeeEventData objEmployee = new EmployeeEventData();
    string strFromdate, gstrDateFormat, strTodate;
    int intIndividualUser = 0;
    int intOTCompOff = 0;
    int intEmailAvail = 0;
    #endregion
    #region PageLoad
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking
        int otApprovalExists = 0;
        int leaveSanctionExists = 0;
        int manualEntryExists = 0;
        base.Page_Load(sender, e);
        //get the culture info to set the language        
        if (!Page.IsPostBack)
        {
            base.CheckPages(0);
            objCommon.menu("EmployeeReports", "42");
        }
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_EnterToDate", ci) + "');";
        strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validmonthdatefourdigit", ci) + "','" + rm.GetString("Alert_Validdatemonthfourdigit", ci) + "','" + rm.GetString("Alert_Invalidyearentry", ci) + "','" + rm.GetString("Alert_Invalidmonthentry", ci) + "','" + rm.GetString("Alert_Invaliddateentry", ci) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", ci) + "','" + rm.GetString("Alert_Entertime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "','" + rm.GetString("Alert_Invalidtimeformat1", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        //Set UserRights
        UserRights();
        if (!Page.IsPostBack)
        {
            Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
            // Bindings the employee category and type.
            BindingEmployeeCategoryandType();
            FillDesignation();
            ddlDesignation.PreRender += LB_PreRender;
            txtFromDate.Text = (Convert.ToDateTime(objCommon.CurrentMonthStartDate())).ToString(Convert.ToString(Session["MDateFormat"]));
            txtToDate.Text = (Convert.ToDateTime(System.DateTime.Now.ToShortDateString())).ToString(Convert.ToString(Session["MDateFormat"]));
            if (Session["parentLevelId"] != null || Convert.ToInt16(Session["parentLevelId"]) != 0)
            {
                Session["parentLevelId"] = null;
            }
            GetUserGroupDetails();
            fillLeavePolicyddl();
            fillReportingddl();
        }
        //Check whether the employee is Individual User
        intIndividualUser = objCheckUser.CheckIndividualUser(Convert.ToString(Session["UserGroupName"]));
        if (intIndividualUser >= 1)
        {
            PlaceHolderEmployees.Controls.Clear();
            divEmployeeDetails.Visible = false;
            lblEmpSwipeCard.Visible = false;
            txtSwipeCard.Visible = false;
        }
        //Convert date time to MM/dd/YYYY format
        gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
        strFromdate = txtFromDate.Text;
        strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
        strTodate = txtToDate.Text;
        strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
        otApprovalExists = objCommon.CheckPageExistsInLicense(97);
        leaveSanctionExists = objCommon.CheckPageExistsInLicense(248);
        manualEntryExists = objCommon.CheckPageExistsInLicense(98);
        if (otApprovalExists == 0 && leaveSanctionExists == 0 && manualEntryExists == 0)
        {
            trStatus.Style.Add("display", "none");
        }
    }
    #endregion
    #region User Defined function
    /// <summary>
    /// Fills the designation in the drop down
    /// </summary>
    private void FillDesignation()
    {
        DataSet ds_designation = new DataSet();
        ds_designation = objEmployee.select_CommonDesignation();
        if (ds_designation != null)
        {
            if (ds_designation.Tables[0].Rows.Count > 0)
            {
                ddlDesignation.DataSource = ds_designation;
                ddlDesignation.DataTextField = "TitleName";
                ddlDesignation.DataValueField = "TitleId";
                ddlDesignation.DataBind();
            }
            ds_designation.Dispose();
            foreach (ListItem item in ddlDesignation.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
    }
    /// <summary>
    /// Bindings the employee category and type.
    /// </summary>
    private void BindingEmployeeCategoryandType()
    {
        // employee category binding
        DataSet dsCategory = new DataSet();
        dsCategory = objEmployee.SelectCategoryDetailsEmployee("");
        if (dsCategory != null)
        {
            if (dsCategory.Tables[0].Rows.Count > 0)
            {
                ddlEmpCatagory.DataSource = dsCategory;
                ddlEmpCatagory.DataTextField = "CategoryName";
                ddlEmpCatagory.DataValueField = "CategoryId";
                ddlEmpCatagory.DataBind();
            }
            dsCategory.Dispose();
            foreach (ListItem item in ddlEmpCatagory.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
        // employee type binding
        DataSet dsType = new DataSet();
        dsType = objEmployee.SelectTypeDetailsEmployee("");
        if (dsType != null)
        {
            if (dsType.Tables[0].Rows.Count > 0)
            {
                ddlEmpType.DataSource = dsType;
                ddlEmpType.DataTextField = "TypeName";
                ddlEmpType.DataValueField = "TypeId";
                ddlEmpType.DataBind();
            }
            dsType.Dispose();
            foreach (ListItem item in ddlEmpType.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
    }
    /// <summary>
    /// Getting Information from resource file and display it in label
    /// </summary>
    /// <param name="ci"></param>
    private void LoadStrings(CultureInfo ci)
    {
        lblFilter.Text = rm.GetString("lblFilter", ci);
        btn_View.Text = "&nbsp;&nbsp;" + rm.GetString("btn_View", ci);
        lblEmployeeDetailsReport.Text = rm.GetString("Report_Employee_Details", ci);
        lblStatus.Text = rm.GetString("EmployeeMaster_EmployeeStatus", ci);
        lblEmployeeName.Text = rm.GetString("Field_EmployeeName", ci);
        lblEmployeeId.Text = rm.GetString("Field_EmployeeID", ci);
        lblEmpCategory.Text = rm.GetString("Master_Category", ci);
        lblEmpType.Text = rm.GetString("Master_Type", ci);
        lblTimePeriod.Text = rm.GetString("Reports_TimePeriod", ci);
        lblFrom.Text = rm.GetString("email_FromDate", ci);
        lblTo.Text = rm.GetString("email_ToDate", ci);
        lblEmpSwipe.Text = rm.GetString("TerminalDataType_Card_No", ci);
        lblEmpSwipeCard.Text = rm.GetString("TerminalDataType_Card_No", ci);
        ddlStatus.Items[0].Text = rm.GetString("ExportData_All", ci);
        ddlStatus.Items[1].Text = rm.GetString("rbtn_EmployeeMaster_Active", ci);
        ddlStatus.Items[2].Text = rm.GetString("rbtn_EmployeeMaster_InActive", ci);
        ddlSwipeOpt.Items[0].Text = rm.GetString("Select", ci);
        ddlSwipeOpt.Items[1].Text = rm.GetString("ExportData_All", ci);
        ddlSwipeOpt.Items[2].Text = rm.GetString("Report_Exists", ci);
        ddlSwipeOpt.Items[3].Text = rm.GetString("Report_NotExists", ci);
        ddlEmpCatagory.Items[0].Text = rm.GetString("Select", ci);
        ddlEmpType.Items[0].Text = rm.GetString("Select", ci);
        lblDesignation.Text = rm.GetString("EmployeeMaster_Designation", ci);
        lblGender.Text = rm.GetString("EmployeeMaster_Gender", ci);
        ddlGender.Items[0].Text = rm.GetString("Caption_Both", ci);
        ddlGender.Items[1].Text = rm.GetString("rbtn_EmployeeMaster_Male", ci);
        ddlGender.Items[2].Text = rm.GetString("rbtn_EmployeeMaster_Female", ci);
        ddlDesignation.Items[0].Text = rm.GetString("ExportData_All", ci);
        lblDateFilter.Text = rm.GetString("Field_DataFilter", ci);
        rbCustom.Text = rm.GetString("Field_Custom", ci);
        rbpreviousMonth.Text = rm.GetString("Field_PrevoiuseWeek", ci);
        rbpreviousweek.Text = rm.GetString("Field_ThisWeek", ci);
        rbThisMonth.Text = rm.GetString("Field_PrevoiuseMonth", ci);
        rbThisweek.Text = rm.GetString("Field_ThisMonth", ci);
        //Added by mahi
        lblOTCompoff.Text = rm.GetString("Menu_OTCOMPOff", ci);
        ckb_Compoff.Text = rm.GetString("Emp_CompOff", ci);
        ckb_OT.Text = rm.GetString("Emp_OverTime", ci);
        lblUserGroup.Text = rm.GetString("EmployeeMaster_UserGroup", ci);
        lblLeavepolicy.Text = rm.GetString("Employee_LeavePolicy", ci);
        lbl_ReportingTo.Text = rm.GetString("EmployeeMaster_ReportingTo", ci);
        lbl_LeaveSanctioninguthority.Text = rm.GetString("EmployeeMaster_LeaveSanctioningAuthority", ci);
        //
    }
    /// <summary>
    /// To check rights for the logged in user
    /// </summary>
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(42, Convert.ToInt32(Session["userGroup_Id"]), "viewPrv");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["viewPrv"] == DBNull.Value || Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) == 1)
            {
                btn_View.Visible = true;
            }
            else
            {
                btn_View.Visible = false;
            }
        }
        else
        {
            Response.Redirect("ReportsLandingPage.aspx");
        }
    }
    /// <summary>
    /// To apply tooltip for the designation in the drop down
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void LB_PreRender(object sender, System.EventArgs e)
    {
        foreach (ListItem item in ddlDesignation.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }

    /// <summary>
    /// Compare ToDate with FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void CompareDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            strTodate = txtToDate.Text;
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            DateTime dtToDate = DateTime.Parse(strTodate);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan diff = dtToDate.Subtract(dtFromDate);
            int day = diff.Days;
            if (day >= 0)
                e.IsValid = true;
            else
            {
                base.Message(rm.GetString("Msg_SelectvaliddatecomparewithFromdate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    /// <summary>
    /// Validate the FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateFromDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            //strCurrentDate = objCommon.DateConvertion(gstrDateFormat,DateTime.Today.Date.ToString());
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            //strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            //DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date.ToString("MM/dd/yyyy")); ;
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day <= 0)
                e.IsValid = true;
            else
            {
                // base.Message("Select valid From Date");  
                base.Message(rm.GetString("Alert_SelectvalidFromDate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    /// <summary>
    /// Validate the ToDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateToDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            //strCurrentDate = objCommon.DateConvertion(gstrDateFormat, DateTime.Today.Date.ToString());
            strTodate = txtToDate.Text;
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            //DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date.ToString("MM/dd/yyyy"));
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date);
            DateTime dtFromDate = DateTime.Parse(strTodate);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day <= 0)
                e.IsValid = true;
            else
            {
                // base.Message("Select valid To Date");  
                base.Message(rm.GetString("Alert_SelectvalidToDate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    #endregion
    #region Button Event
    /// <summary>
    /// Load the Employee report
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btn_View_Click(object sender, EventArgs e)
    {
        int employeeCategory = 0, employeeType = 0;
        try
        {
            if (Page.IsValid == true)
            {
                DataTable dtHdr = new DataTable();
                dtHdr = hdrTable.CreateHeader();
                string filter = "";

                if (Convert.ToInt32(ddlEmpCatagory.SelectedValue) != 0)
                {
                    employeeCategory = Convert.ToInt32(ddlEmpCatagory.SelectedValue);
                    filter = filter + "Employee Category : " + Convert.ToString(ddlEmpCatagory.SelectedItem.Text) + "->";
                }
                else
                {
                    employeeCategory = 0;
                }
                if (Convert.ToInt32(ddlEmpType.SelectedValue) != 0)
                {
                    employeeType = Convert.ToInt32(ddlEmpType.SelectedValue);
                    filter = filter + "Employee Type : " + Convert.ToString(ddlEmpType.SelectedItem.Text) + "->";
                }
                else
                {
                    employeeType = 0;
                }

                DataSet dsEmp = new DataSet();
                string Level = string.Empty;
                string employeeName = string.Empty;
                string empName = string.Empty;
                string empId = string.Empty;
                if (intIndividualUser >= 1)
                {
                    empName = string.Empty;
                    Level = string.Empty;
                    empId = Convert.ToString(Session["EmployeeCodeId"]);
                }
                else
                {
                    empName = Convert.ToString(txtEmployeeName.Text);
                    empId = Convert.ToString(txtEmployeeId.Text.Trim());
                    employeeName = this.txtEmployeeName.Text.Replace("'", "''");
                    employeeName = employeeName.Replace(' ', '%');
                    Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
                }
                string EmployeeStatus = Convert.ToString(ddlStatus.SelectedValue);
                string strSwipOpt = "";
                if (ddlSwipeOpt.SelectedIndex != 0)
                {
                    strSwipOpt = ddlSwipeOpt.SelectedValue;
                }
                if (Convert.ToInt32(ddlDesignation.SelectedValue) != 0)
                    filter = filter + "Designation : " + Convert.ToString(ddlDesignation.SelectedItem.Text) + "->";
                if (Convert.ToString(ddlGender.SelectedValue) != "Both")
                    filter = filter + "Gender : " + Convert.ToString(ddlGender.SelectedItem.Text) + "->";
                if (Convert.ToString(ddlStatus.SelectedValue) != "All")
                    filter = filter + "Employee Status : " + Convert.ToString(ddlGender.SelectedItem.Text) + "->";

                string strSwipeCard = "";
                strSwipeCard = Convert.ToString(txtSwipeCard.Text).Trim().Replace("'", "''");

                if (ckb_Compoff.Checked == true && ckb_OT.Checked == false)
                {
                    intOTCompOff = 1;
                    filter = filter + " Over Time / Comp Off : Over Time";
                }
                else if (ckb_Compoff.Checked == false && ckb_OT.Checked == true)
                {
                    intOTCompOff = 2;
                    filter = filter + " Over Time / Comp Off : Comp Off";
                }
                else if (ckb_Compoff.Checked == true && ckb_OT.Checked == true)
                {
                    intOTCompOff = 3;
                    filter = filter + " Over Time / Comp Off : Over Time / Comp Off";
                }
                else if (ckb_Compoff.Checked == false && ckb_OT.Checked == false)
                    intOTCompOff = 0;



                int intUserGroupID, intLeavePolicyID, intReportingto, intSanctionTo;
                if (Convert.ToInt32(ddl_UserGroup.SelectedValue) != 0)
                {
                    intUserGroupID = Convert.ToInt32(ddl_UserGroup.SelectedValue);
                    filter = filter + "User Group : " + Convert.ToString(ddl_UserGroup.SelectedItem.Text) + "->";
                }
                else
                {
                    intUserGroupID = 0;
                }
                if (Convert.ToInt32(ddl_LeavePolicy.SelectedValue) != 0)
                {
                    intLeavePolicyID = Convert.ToInt32(ddl_LeavePolicy.SelectedValue);
                    filter = filter + "Leave Policy : " + Convert.ToString(ddl_LeavePolicy.SelectedItem.Text) + "->";
                }
                else
                {
                    intLeavePolicyID = 0;
                }
                if (Convert.ToInt32(ddl_ReportingTo.SelectedValue) != 0)
                {
                    intReportingto = Convert.ToInt32(ddl_ReportingTo.SelectedValue);
                    filter = filter + "Reporting To : " + Convert.ToString(ddl_ReportingTo.SelectedItem.Text) + "->";
                }
                else
                {
                    intReportingto = 0;
                }
                if (Convert.ToInt32(ddl_LeaveSancAuthority.SelectedValue) != 0)
                {
                    intSanctionTo = Convert.ToInt32(ddl_LeaveSancAuthority.SelectedValue);
                    filter = filter + "Approval Authority : " + Convert.ToString(ddl_LeaveSancAuthority.SelectedItem.Text) + "->";
                }
                else
                {
                    intSanctionTo = 0;
                }
                if (ckb_EmailAvail.Checked == true && ckb_EmailNotAvail.Checked == false)
                {
                    intEmailAvail = 1;
                    filter = filter + " Email ID : Available";
                }
                else if (ckb_EmailAvail.Checked == false && ckb_EmailNotAvail.Checked == true)
                {
                    intEmailAvail = 2;
                    filter = filter + " Email ID : Not Available";
                }
                dtHdr.TableName = "Header";
                //Add the Header information
                DataRow drHdr = dtHdr.NewRow();
                drHdr["Link"] = 1;
                drHdr["Hdr1"] = "";
                drHdr["Hdr2"] = "";
                drHdr["Address1"] = "";
                drHdr["Address2"] = "";
                drHdr["ReportName"] = "Form 25 Report";
                if (txtFromDate.Text != "")
                {
                    DateTime tmpFrom = DateTime.Parse(strFromdate);
                    drHdr["FromDate"] = tmpFrom.ToString("dd-MMM-yyyy");
                }
                else
                    drHdr["FromDate"] = "";
                if (txtToDate.Text != "")
                {
                    DateTime tmpTo = DateTime.Parse(strTodate);
                    drHdr["ToDate"] = tmpTo.ToString("dd-MMM-yyyy");
                }
                else
                    drHdr["ToDate"] = "";
                dtHdr.Rows.Add(drHdr);
                string dtFrom = "", dtTo = "";
                if (txtFromDate.Text != "")
                    dtFrom = strFromdate;
                if (txtToDate.Text != "")
                    dtTo = strTodate;
                base.EncryptandRedirect("TA_UI_Report_ReportViewer.aspx", "EmployeeDetailedReport", dtFrom, dtTo, empId,0, employeeName, Level, employeeCategory, employeeType, Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), null, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 0, 0, 0, null, null, null, null, null, null, 0, null, null, null, null, null, 0, null, 0, null, null, null, intEmailAvail,intOTCompOff,intUserGroupID,intLeavePolicyID,intReportingto,intSanctionTo, EmployeeStatus,filter, null, null, null, null, null, null, null, null, null, null, null);

                //string strScript = "";
                //strScript = strScript + "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>";
                //strScript = strScript + "<meta http-equiv='X-UA-Compatible' content='IE=edge' />";
                //strScript = strScript + "<script language='javascript'>";
                //strScript = strScript + "window.open('TA_UI_Report_ReportViewer.aspx?ReportName=EmployeeDetailedReport&empid=" + empId + "&dtFrom=" + dtFrom + "&dtTo=" + dtTo + "&EmpName=" + employeeName + "&EmailAvail=" + Convert.ToString(intEmailAvail) + "&OTCompOff=" + Convert.ToString(intOTCompOff) + "&UserGroupID=" + Convert.ToString(intUserGroupID) + "&LeavePolicyID=" + Convert.ToString(intLeavePolicyID) + "&ReportingTo=" + Convert.ToString(intReportingto) + "&SanctionTo=" + Convert.ToString(intSanctionTo) + "&EmpCategory=" + employeeCategory + "&EmpType=" + employeeType + "&ParentLevelId=" + Convert.ToInt16(Session["parentLevelId"]) + "&UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + "&GradeLevel=" + Convert.ToString(Session["GradeLevel"]) + "&EmpStatus=" + EmployeeStatus + "&Designation=" + Convert.ToInt32(ddlDesignation.SelectedValue) + "&Gender=" + ddlGender.SelectedValue + "&PageFilter=" + filter + "','','left=10px, top=60px, width=1000px, height=600px, scrollbars=yes, status=no, resizable=yes');";
                //strScript = strScript + "</script>";
                //Response.Write(strScript);
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex);
            //
        }
    }
    #endregion
    #region "Fills UserGroup dropdown"
    private void GetUserGroupDetails()
    {
        DataSet ds_Usergroup = new DataSet();
        ds_Usergroup = objEmployee.select_Usergroupdetails();
        if (ds_Usergroup != null)
        {
            if (ds_Usergroup.Tables[0].Rows.Count > 0)
            {
                ddl_UserGroup.DataSource = ds_Usergroup;
                ddl_UserGroup.DataTextField = "groupName";
                ddl_UserGroup.DataValueField = "groupId";
                ddl_UserGroup.DataBind();
            }
            ds_Usergroup.Dispose();
        }
        foreach (ListItem item in ddl_UserGroup.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
    #endregion
    #region "function fills Leave policy ddl"
    private void fillLeavePolicyddl()
    {
        DataSet ds_leavepolicy = new DataSet();
        ds_leavepolicy = objLeave.SelectAllLeavePolicy(string.Empty);
        if (ds_leavepolicy != null)
        {
            if (ds_leavepolicy.Tables[0].Rows.Count > 0)
            {
                ddl_LeavePolicy.DataSource = ds_leavepolicy;
                ddl_LeavePolicy.DataTextField = "PolicyName";
                ddl_LeavePolicy.DataValueField = "Policy_Id";
                ddl_LeavePolicy.DataBind();
            }
            ds_leavepolicy.Dispose();
        }
        foreach (ListItem item in ddl_LeavePolicy.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
    #endregion
    #region fillReportingddl
    private void fillReportingddl()
    {
        DataSet ds_Reporting = new DataSet();
        ds_Reporting = objEmployee.SelectReportingPersonReport();
        if (ds_Reporting != null)
        {
            if (ds_Reporting.Tables[0].Rows.Count > 0)
            {
                ddl_ReportingTo.DataSource = ds_Reporting;
                ddl_ReportingTo.DataTextField = "Employee_FirstName";
                ddl_ReportingTo.DataValueField = "Employee_Id";
                ddl_ReportingTo.DataBind();
                ddl_LeaveSancAuthority.DataSource = ds_Reporting;
                ddl_LeaveSancAuthority.DataTextField = "Employee_FirstName";
                ddl_LeaveSancAuthority.DataValueField = "Employee_Id";
                ddl_LeaveSancAuthority.DataBind();
            }
        }
        foreach (ListItem item in ddl_LeaveSancAuthority.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
        foreach (ListItem item in ddl_ReportingTo.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
    #endregion
}
