using System;
using System.Collections;
using System.Data;
using System.Data.OleDb;
using System.Globalization;
using System.IO;
using System.Resources;
using System.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;
/*
 * Modified By      :   Manjula.P
 * Modified On      :   07-OCt-2013
 * Descriptions     :   Adding alert for import file when try to import yes/no entry in eligible columns in both CSV and XLS Files and its functions
 * Modified By      :   Manjula.P
 * Modified On      :   09-Oct-2013
 * Descriptions     :   Added by Manjula.P on 09-Oct-2013 for getting another datetime values while inserting Mantis : 0019383
 * */
public partial class System_Settings_ImportEmployee : Base.BasePage
{
    #region Variable Declaration.
    ImportData ObjImportData = new ImportData();
    ResourceManager rm;
    CultureInfo ci;
    string strDateOfBirth, gstrDateFormat = "dd/MM/yyyy", strDateOfJoining, Afterbirth_Record = "", isEnterprise = "0", strScript = "";
    cls_Common objCommon = new cls_Common();
    char chrImportDelimiter = ',';
    cls_master_levels class1 = new cls_master_levels(); int noOfEmployeeLicFile;
    FileStream aFile;
    #endregion
    #region Page Load.
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        ObjImportData = new ImportData();
        gvImportMaster.AllowPaging = false;
        string source_Language = string.Empty;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        //grv_ImportMaster.Styles.CssFilePath = Convert.ToString(Session["GridCSS"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        if (Convert.ToString(System.Configuration.ConfigurationManager.AppSettings["ImportDelimiter"]) != "")
            chrImportDelimiter = Convert.ToChar(System.Configuration.ConfigurationManager.AppSettings["ImportDelimiter"]);
        if (!IsPostBack)
        {
            objCommon.menu("EmployeeMaster", "104");
            loadGridData();
        }
        if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin")
        {
            licDetails.Visible = true;
            licenseBalanceDetails();
        }
        else licDetails.Visible = false;
    }
    private void UserRights()
    {
        Cls_CheckUser objCheckUser = new Cls_CheckUser();
        DataSet ds_Checkuser = new DataSet();
        ds_Checkuser = objCheckUser.checkRights(104, Convert.ToInt32(Session["userGroup_Id"]), "addPrv");
        if (ds_Checkuser.Tables[0].Rows.Count == 0)
        {
            Response.Redirect("SystemLandingPage.aspx");
        }
    }
    private void loadGridData()
    {
        DataSet ds = new DataSet();
        ds = ObjImportData.SelectImportErrorData();
        if (ds.Tables.Count > 0)
        {
            if (ds.Tables[0].Rows.Count > 0)
            {
                btn_UploadGrid.Visible = true;
                btnDelete.Visible = true;
                ViewState["ImportMasterData"] = ds;
                gvImportMaster.DataSource = ds;
                gvImportMaster.DataBind();
                if (Convert.ToString(Session["Demo"]) == "Enterprise")
                    gvImportMaster.Columns[35].Visible = gvImportMaster.Columns[34].Visible = true;
                else
                    gvImportMaster.Columns[35].Visible = gvImportMaster.Columns[34].Visible = false;
                lbl_Mag.Visible = true;
            }
            else
            {
                btn_UploadGrid.Visible = false;
                btnDelete.Visible = false;
                lbl_Mag.Visible = false;
            }
        }
        else
        {
            btn_UploadGrid.Visible = false;
            btnDelete.Visible = false;
        }
    }
    public override void VerifyRenderingInServerForm(Control control)
    {
    }
    #endregion
    #region Button Events
    /// <summary>
    /// Handles the Click event of the btn_Upload control.
    /// </summary>
    /// <param name="sender">The source of the event.</param>
    /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
    protected void btn_Upload_Click(object sender, EventArgs e)
    {
        try
        {
            if (fp_ImportFilePath.HasFile)
            {
                ObjImportData.deleteImportMasterData();
                string filename = fp_ImportFilePath.FileName;
                filename = filename.Substring(filename.LastIndexOf("\\") + 1);
                string fileType;
                fileType = System.IO.Path.GetExtension(filename);
                //if(fp_ImportFilePath.PostedFile.ContentLength>2048)
                if (fileType.ToLower() == ".xls" || fileType.ToLower() == ".csv")
                {
                    string strFilePath = Server.MapPath("Uploads").ToString();
                    FileInfo fileInfo = new System.IO.FileInfo(strFilePath + "\\" + fp_ImportFilePath.FileName);
                    fp_ImportFilePath.SaveAs(strFilePath + "\\" + fp_ImportFilePath.FileName);
                    if (fp_ImportFilePath.PostedFile.ContentLength == fileInfo.Length)
                    {
                        int val = 0;
                        if (fileType == ".csv")
                            val = ImportMasterDataForCSV(fileInfo);
                        else
                            val = ImportMasterDataForXls(fileInfo);
                        if (val == 1)
                        {
                            Message(rm.GetString("Alert_FileUploadedandDataareimportedSucessfully", ci).Replace("\r", "").Replace("\n", ""));
                            if (aFile != null) aFile.Dispose();
                            loadGridData();
                        }
                    }
                    else
                    {
                        Message(rm.GetString("Alert_ErrorinImportingEmployee", ci).Replace("\r", "").Replace("\n", ""));
                        if (aFile != null) aFile.Dispose();
                    }
                }
                else
                {
                    Message(rm.GetString("Alert_TheUploadedfileisnotExcelfile", ci).Replace("\r", "").Replace("\n", ""));
                    if (aFile != null) aFile.Dispose();
                }
            }
            else
                Message(rm.GetString("Alert_Youhavenotspecifiedafile", ci).Replace("\r", "").Replace("\n", ""));
        }
        catch (Exception ex)
        {
            string strErr = Convert.ToString(ex.Message);
            Message(strErr.Replace("\r", "").Replace("\n", ""));
        }
        finally
        {
            try
            {
                if (fp_ImportFilePath.HasFile)
                {
                    string StrFilePath = Convert.ToString(Server.MapPath("Uploads")) + "\\" + fp_ImportFilePath.FileName;
                    System.IO.File.Delete(StrFilePath);
                }
            }
            catch (Exception Ex)
            {
            }
            if (aFile != null)
                aFile.Dispose();
        }
    }
    protected void btnTemplate_Click(object sender, EventArgs e)
    {
        DataSet dsLevels = new DataSet();
        levelsEventData objClass = new levelsEventData();
        DataSet ds = new DataSet();
        string strFilePath = string.Empty;
        try
        {
            strFilePath = (Convert.ToString(Session["Demo"]) == "Enterprise") ? (rblType.SelectedValue == "1") ? Server.MapPath("Uploads/TimecheckMasterDataTemplateEnterPrise.xls") : Server.MapPath("Uploads/TimecheckMasterDataTemplateSimple.xls") : (rblType.SelectedValue == "1") ? Server.MapPath("Uploads/TimecheckMasterDataTemplateStandard.xls") : Server.MapPath("Uploads/TimecheckMasterDataTemplateSimple.xls");
            if (File.Exists(strFilePath))
            {
                Afterbirth_Record = "DateOfBirth_Record";
                isEnterprise = (Convert.ToString(Session["Demo"]) == "Enterprise") ? "1" : "0";
                FileInfo fileInfo = new System.IO.FileInfo(strFilePath);
                ds = ObjImportData.ReadExcelSheet(fileInfo);
                if (ds.Tables.Count > 0)
                {
                    dsLevels = objClass.selectLevels();
                    if (dsLevels.Tables.Count > 0 && dsLevels.Tables[0].Rows.Count > 0)
                    {
                        for (int i = 0; i < dsLevels.Tables[0].Rows.Count; i++)
                        {
                            if (i == 0)
                                ds.Tables[0].Columns.Add("*" + Convert.ToString(dsLevels.Tables[0].Rows[i]["levelName"]));
                            else
                                ds.Tables[0].Columns.Add(Convert.ToString(dsLevels.Tables[0].Rows[i]["levelName"]));
                        }
                    }
                    if (ds.Tables[0].Rows.Count == 0)
                    {
                        DataRow row = DemoData(ds);
                        ds.Tables[0].Rows.Add(row);
                    }
                    string strData = Export(ds);
                    byte[] data = System.Text.ASCIIEncoding.ASCII.GetBytes(strData);
                    Response.Clear();
                    Response.AddHeader("Content-Type", "application/Excel");
                    Response.AddHeader("Content-Disposition", "attachment;filename=TimecheckMasterData.csv");
                    Response.BinaryWrite(data);
                    Response.End();
                }
            }
            else
                Message("Template file is missing in download template folder.Please contact stake holder");
        }
        catch (InvalidOperationException ex)
        {
            Message("The Microsoft.Jet.OLEDB.4.0 provider is not registered on the local machine.So Enable 32-bit Applications setting to True, in the Advanced Settings for the Application Pool.");
        }
    }
    private DataRow DemoData(DataSet ds)
    {
        gstrDateFormat = "dd-MMM-yyyy";
        Random rnmNumber = new Random();
        int Number = rnmNumber.Next(1, 10000);
        DataRow row = ds.Tables[0].NewRow();
        row["*Emp_FirstName"] = "Manikandan";
        row["*DateOfJoining"] = DateTime.Parse("2011/03/21").ToString(gstrDateFormat);
        row["*Designation"] = "Developer";
        row["Sl#No"] = "1";
        if (rblType.SelectedValue == "1")
        {
            row["Emp_MiddleName"] = "";
            row["Father_Name"] = row["Emp_LastName"] = "Arivazhagan";
            row["Mother_Name"] = "Priya";
            row[Afterbirth_Record] = row["*DateOfBirth"] = DateTime.Parse("1990/06/02").ToString(gstrDateFormat);
            row["Blood_Group"] = "B-ve";
            row["Personal_EmailID"] = row["Email_Id"] = "manikandan.rr@angleritech.com";
            row["Permanent_Address"] = row["*Contact_Address"] = "Vadapazhani-Chennai";
            row["Mobile_Number"] = row["Phone_Number"] = "9175555555";
            row["*Gender(Male | Female)"] = "Female";
            row["Marital_Status(Single | Married)"] = "Single";
            row["Nationality"] = "Indian";
            row["Religion(Religion Name)"] = "Hindu";
            row["Visa_No"] = row["Passport_No"] = "31195855";
            row["Visa_ExpiryDate"] = row["Passport_ExpiryDate"] = DateTime.Parse("2020/09/01").ToString(gstrDateFormat);
            row["*Employee_Code"] = Number;
            row["Qualification_Employement"] = row["Qualification_joiningtime"] = "BE";
            row["Hostel"] = row["IsDeleted(0 | 1)"] = row["Report_Exclude(0 | 1)"] = row["OT_Eligible(0 | 1)"] = row["CompOff_Eligible(0 | 1)"] = 0;
            row["Employee_Status(0 | 1)"] = 1;
            if (isEnterprise == "1")
            {
                row["*Grade(Grade Name)"] = "Grade 4";
                row["*GradeNo(Grade Level)"] = "4";
            }
            row["*Employee_Type"] = "Permanant";
            row["*Employee_Category"] = "Programmer";
            row["BasicSalary"] = "12000";
        }
        else
        {
            row["*Card_Number"] = "787";
            row["*Employee_ID(LoginID)"] = "787";
        }
        if (Session["UserGroupName"] != null)
        {
            DataSet dsLevels = class1.getOrgLevelUpdated(0, Convert.ToString(Session["LevelRights"]), 0, Convert.ToString(Session["UserGroupName"]));
            DataTable dtFirstLevel = new DataTable();
            dsLevels.Tables[0].DefaultView.RowFilter = "ParentId = 0";
            dtFirstLevel = dsLevels.Tables[0].DefaultView.ToTable();
            if (dtFirstLevel.Rows.Count > 0)
            {
                if (Convert.ToString(dtFirstLevel.Rows[0]["name"]) != string.Empty)
                {
                    if (rblType.SelectedValue == "1")
                    {
                        if (isEnterprise == "1")
                            row[39] = Convert.ToString(dtFirstLevel.Rows[0]["name"]);
                        else if (isEnterprise == "0")
                            row[37] = Convert.ToString(dtFirstLevel.Rows[0]["name"]);
                    }
                    else
                    {
                        if (Convert.ToString(dtFirstLevel.Rows[0]["name"]) != string.Empty)
                            row[6] = Convert.ToString(dtFirstLevel.Rows[0]["name"]);
                        else
                            row[6] = "Default First Level Hierarchy";
                    }
                }
                else
                {
                    if (rblType.SelectedValue == "1")
                    {
                        if (isEnterprise == "1")
                            row[39] = "Default First Level Hierarchy";
                        else if (isEnterprise == "0")
                            row[37] = "Default First Level Hierarchy";
                    }
                    else
                        row[6] = "Default First Level Hierarchy";
                }
            }
            else
            {
                if (rblType.SelectedValue == "1")
                {
                    if (isEnterprise == "1")
                        row[39] = "Default First Level Hierarchy";
                    else if (isEnterprise == "0")
                        row[37] = "Default First Level Hierarchy";
                }
                else
                    row[6] = "Default First Level Hierarchy";
            }
        }
        return row;
    }
    protected void btn_UploadGrid_Click(object sender, EventArgs e)
    {
        try
        {
            foreach (GridViewRow grv in gvImportMaster.Rows)
            {
                Label txt_ID = (Label)grv.FindControl("lbl_Id");
                TextBox txt_Emp_FirstName = (TextBox)grv.FindControl("txt_Emp_FirstName");
                TextBox txt_Emp_MiddleName = (TextBox)grv.FindControl("txt_Emp_MiddleName");
                TextBox txt_Emp_LastName = (TextBox)grv.FindControl("txt_Emp_LastName");
                TextBox txt_Father_Name = (TextBox)grv.FindControl("txt_Father_Name");
                TextBox txt_Mother_Name = (TextBox)grv.FindControl("txt_Mother_Name");
                TextBox txt_DateOfBirth = (TextBox)grv.FindControl("txt_DateOfBirth");
                TextBox txt_DateOfBirth_Record = (TextBox)grv.FindControl("txt_DateOfBirth_Record");
                TextBox txt_Blood_Group = (TextBox)grv.FindControl("txt_Blood_Group");
                TextBox txt_Email_Id = (TextBox)grv.FindControl("txt_Email_Id");
                TextBox txt_Contact_Address = (TextBox)grv.FindControl("txt_Contact_Address");
                TextBox txt_Permanent_Address = (TextBox)grv.FindControl("txt_Permanent_Address");
                TextBox txt_Phone_Number = (TextBox)grv.FindControl("txt_Phone_Number");
                TextBox txt_Mobile_Number = (TextBox)grv.FindControl("txt_Mobile_Number");
                TextBox txt_Gender = (TextBox)grv.FindControl("txt_Gender");
                TextBox txt_Marital_Status = (TextBox)grv.FindControl("txt_Marital_Status");
                TextBox txt_Nationality = (TextBox)grv.FindControl("txt_Nationality");
                TextBox txt_Religion = (TextBox)grv.FindControl("txt_Religion");
                TextBox txt_Personal_EmailID = (TextBox)grv.FindControl("txt_Personal_EmailID");
                TextBox txt_Passport_No = (TextBox)grv.FindControl("txt_Passport_No");
                TextBox txt_Passport_ExpiryDate = (TextBox)grv.FindControl("txt_Passport_ExpiryDate");
                TextBox txt_Visa_No = (TextBox)grv.FindControl("txt_Visa_No");
                TextBox txt_Visa_ExpiryDate = (TextBox)grv.FindControl("txt_Visa_ExpiryDate");
                TextBox txt_Employee_Code = (TextBox)grv.FindControl("txt_Employee_Code");
                TextBox txt_DateOfJoining = (TextBox)grv.FindControl("txt_DateOfJoining");
                TextBox txt_Qualification_joiningtime = (TextBox)grv.FindControl("txt_Qualification_joiningtime");
                TextBox txt_Qualification_Employement = (TextBox)grv.FindControl("txt_Qualification_Employement");
                TextBox txt_CompOff_Eligible = (TextBox)grv.FindControl("txt_CompOff_Eligible");
                TextBox txt_OT_Eligible = (TextBox)grv.FindControl("txt_OT_Eligible");
                TextBox txt_Report_Exclude = (TextBox)grv.FindControl("txt_Report_Exclude");
                TextBox txt_Employee_Status = (TextBox)grv.FindControl("txt_Employee_Status");
                TextBox txt_IsDeleted = (TextBox)grv.FindControl("txt_IsDeleted");
                TextBox txt_Hostel = (TextBox)grv.FindControl("txt_Hostel");
                TextBox txt_Designation = (TextBox)grv.FindControl("txt_Designation");
                TextBox txt_Grade = (TextBox)grv.FindControl("txt_Grade");
                TextBox txt_GradeNo = (TextBox)grv.FindControl("txt_GradeNo");
                TextBox txt_Employee_Type = (TextBox)grv.FindControl("txt_Employee_Type");
                TextBox txt_Employee_Category = (TextBox)grv.FindControl("txt_Employee_Category");
                TextBox txt_BasicSalary = (TextBox)grv.FindControl("txt_BasicSalary");
                TextBox txt_Level1 = (TextBox)grv.FindControl("txt_Level1");
                TextBox txt_Level2 = (TextBox)grv.FindControl("txt_Level2");
                TextBox txt_Level3 = (TextBox)grv.FindControl("txt_Level3");
                TextBox txt_Level4 = (TextBox)grv.FindControl("txt_Level4");
                TextBox txt_Level5 = (TextBox)grv.FindControl("txt_Level5");
                TextBox txt_Level6 = (TextBox)grv.FindControl("txt_Level6");
                TextBox txt_Level7 = (TextBox)grv.FindControl("txt_Level7");
                TextBox txt_Level8 = (TextBox)grv.FindControl("txt_Level8");
                TextBox txt_Level9 = (TextBox)grv.FindControl("txt_Level9");
                TextBox txt_Level10 = (TextBox)grv.FindControl("txt_Level10");
                string GradeName = string.Empty;
                string GradeCode = string.Empty;
                //3435
                if (Convert.ToString(Session["Demo"]) == "Enterprise")
                {
                    if (txt_Grade != null)
                    {
                        GradeName = txt_Grade.Text;
                    }
                    if (txt_GradeNo != null)
                    {
                        GradeCode = txt_GradeNo.Text;
                    }
                }
                else
                {
                    GradeName = "0";
                    GradeCode = "0";
                }
                ObjImportData.EditImportErrorData(txt_ID.Text, txt_Emp_FirstName.Text, txt_Emp_MiddleName.Text, txt_Emp_LastName.Text, txt_Father_Name.Text, txt_Mother_Name.Text, txt_DateOfBirth.Text, txt_DateOfBirth_Record.Text, txt_Blood_Group.Text, txt_Email_Id.Text, txt_Contact_Address.Text, txt_Permanent_Address.Text, txt_Phone_Number.Text, txt_Mobile_Number.Text, txt_Gender.Text, txt_Marital_Status.Text, txt_Nationality.Text, txt_Religion.Text, txt_Personal_EmailID.Text, txt_Passport_No.Text, txt_Passport_ExpiryDate.Text, txt_Visa_No.Text, txt_Visa_ExpiryDate.Text, txt_Employee_Code.Text, txt_DateOfJoining.Text, txt_Qualification_joiningtime.Text, txt_Qualification_Employement.Text, txt_CompOff_Eligible.Text, txt_OT_Eligible.Text, txt_Report_Exclude.Text, txt_Employee_Status.Text, txt_IsDeleted.Text, txt_Hostel.Text, txt_Designation.Text, GradeName, GradeCode, txt_Employee_Type.Text, txt_Employee_Category.Text, txt_BasicSalary.Text, txt_Level1.Text, txt_Level2.Text, txt_Level3.Text, txt_Level4.Text, txt_Level5.Text, txt_Level6.Text, txt_Level7.Text, txt_Level8.Text, txt_Level9.Text, txt_Level10.Text);
            }
            DataSet ds = new DataSet();
            ds = ObjImportData.SelectImportErrorData();
            ds.Tables[0].TableName = "TheData";
            StringWriter strWriteXML = new StringWriter();
            ds.WriteXml(strWriteXML);
            string strDataXML = Convert.ToString(strWriteXML);
            //Session["Demo"]
            ObjImportData.InsertGridMasterData(strDataXML, Convert.ToString(Session["Demo"]), 0);
            Message(rm.GetString("Alert_FileUploadedandDataareimportedSucessfully", ci).Replace("\r", "").Replace("\n", ""));
            if (aFile != null) aFile.Dispose();
            loadGridData();
        }
        catch (Exception ex)
        {
            Message(ex.Message.ToString());
        }
    }
    #endregion
    #region User Defined Functions
    /// <summary>
    /// Imports the data.
    /// </summary>
    /// <param name="fileInfo">The file info.</param>
    private int ImportMasterDataForCSV(FileInfo fileInfo)
    {
        string strScript = string.Empty;
        string validationMsg = string.Empty;
        string strLine;
        string[] strArray;
        char[] charArray = new char[] { chrImportDelimiter };
        DataSet ds = new DataSet();
        DataTable dt = ds.Tables.Add("TheData");
        aFile = new FileStream(fileInfo.FullName.ToString(), FileMode.Open);
        StreamReader sr = new StreamReader(aFile);
        strLine = sr.ReadLine();
        strLine = strLine.Replace(";", ",");
        strArray = strLine.Split(charArray);
        int totalColumnCount = strArray.Length;
        if (totalColumnCount > 16)
        {
            if (rblType.SelectedValue == "0")
            {
                validationMsg = "Please select the simple import type templete file";
                Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                sr.Dispose();
                aFile.Dispose();
                return 0;
            }
        }
        else
        {
            if (rblType.SelectedValue == "1")
            {
                validationMsg = "Please select the advanced import type templete file";
                Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                sr.Dispose();
                aFile.Dispose();
                return 0;
            }
        }
        string firstLevelColumnName = string.Empty;
        if (rblType.SelectedValue == "0")
        {
            for (int x = 0; x <= strArray.GetUpperBound(0); x++)
            {
                dt.Columns.Add(strArray[x].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Replace(";", ",").Split('(')[0]);
                if (x > 0 && strArray[x - 1].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Split('(')[0] == "BasicSalary")
                    firstLevelColumnName = strArray[x].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Split('(')[0];
            }
        }
        else
        {
            if (Convert.ToString(Session["Demo"]) == "Enterprise")
                for (int x = 0; x <= 38; x++)
                {
                    dt.Columns.Add(strArray[x].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Replace(";", ",").Split('(')[0]);
                    if (x > 0 && strArray[x - 1].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Split('(')[0] == "BasicSalary")
                        firstLevelColumnName = strArray[x].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Split('(')[0];
                }
            else
                for (int x = 0; x <= 36; x++)
                {
                    dt.Columns.Add(strArray[x].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Replace(";", ",").Split('(')[0]);
                    if (x > 0 && strArray[x - 1].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Split('(')[0] == "BasicSalary")
                        firstLevelColumnName = strArray[x].Trim().Replace("\"", "").Replace("*", "").Replace(" ", "").Split('(')[0];
                }
        }
        if (rblType.SelectedValue == "1")
        {
            firstLevelColumnName = "Level1";
            if (Convert.ToString(Session["Demo"]) == "Enterprise")
                for (int i = 38; i <= 47; i++)
                {
                    dt.Columns.Add("Level" + (i - 37));
                }
            else
                for (int i = 36; i <= 45; i++)
                {
                    dt.Columns.Add("Level" + (i - 35));
                }
        }
        else
        {
            for (int i = strArray.GetUpperBound(0) + 1; i <= 51; i++)
            {
                dt.Columns.Add("Field" + i);
            }
        }
        strLine = sr.ReadLine();
        //This Line Is Finished
        if (rblType.SelectedValue == "1")
        {
            while (strLine != null)
            {
                strLine = strLine.Replace(";", ",");
                strArray = strLine.Split(charArray);
                gstrDateFormat = "dd-MMM-yyyy";
                if (strArray.Length > totalColumnCount)
                {
                    validationMsg = rm.GetString("Alert_Commashouldnotbeusedinanyofthedata", ci);
                    Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                    sr.Dispose();
                    aFile.Dispose();
                    return 0;
                }
                if (strArray.Length <= 1)
                {
                    validationMsg = rm.GetString("ImportFiles_Separation", ci);
                    Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                    sr.Dispose();
                    aFile.Dispose();
                    return 0;
                }
                DataRow dr = dt.NewRow();
                for (int i = 0; i <= strArray.GetUpperBound(0); i++)
                {
                    dr[i] = strArray[i].Trim().Replace("\"", "");
                }
                if (Convert.ToString(Session["Demo"]) == "Enterprise")
                {
                    for (int i = strArray.GetUpperBound(0) + 1; i <= 47; i++)
                    {
                        dr[i] = "";
                    }
                }
                else
                {
                    for (int i = strArray.GetUpperBound(0) + 1; i <= 45; i++)
                    {
                        dr[i] = "";
                    }
                }
                dt.Rows.Add(dr);
                strLine = sr.ReadLine();
            }
            sr.Dispose();
            aFile.Dispose();
            // get active count from ta_tbl_employee     // add with ds row count and this sum  // will check against lic no of employee count
            if (ds.Tables[0].Rows.Count == 0)
            {
                validationMsg = rm.GetString("Alert_ThereisnorecordintheImportfile", ci);
                Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                sr.Dispose();
                aFile.Dispose();
                return 0;
            }
            StringWriter strWriteXML = new StringWriter();
            ds.WriteXml(strWriteXML);
            string strDataXML = Convert.ToString(strWriteXML);
            ObjImportData.InsertGridMasterData(strDataXML, Convert.ToString(Session["Demo"]), 0);
            return 1;
        }
        else
        {
            while (strLine != null)
            {
                gstrDateFormat = "dd-MMM-yyyy";
                strLine = strLine.Replace(";", ",");
                strArray = strLine.Split(charArray);
                if (Session["MDateFormat"] != null)
                    gstrDateFormat = "dd-MMM-yyyy";
                else
                    gstrDateFormat = "dd/MM/yyyy";
                if (strArray.Length > totalColumnCount)
                {
                    validationMsg = rm.GetString("Alert_Commashouldnotbeusedinanyofthedata", ci);
                    Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                    sr.Dispose();
                    aFile.Dispose();
                    return 0;
                }
                if (strArray.Length <= 1)
                {
                    validationMsg = rm.GetString("ImportFiles_Separation", ci);
                    Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                    sr.Dispose();
                    aFile.Dispose();
                    return 0;
                }
                try
                {
                    if (strArray[4].Trim().Replace("\"", "") != string.Empty)
                    {
                        strDateOfJoining = objCommon.DateConvertion(gstrDateFormat, strArray[4].Trim().Replace("\"", "").Replace(";", "").Replace("'", ""));
                        DateTime dateOfJoining = Convert.ToDateTime(strDateOfJoining);
                    }
                }
                catch (Exception ex)
                {
                    if (rblType.SelectedValue == "1")
                    {
                        validationMsg = rm.GetString("Alert_PleasechecktheDateOfjoiningFormat", ci);
                        Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                        sr.Dispose();
                        aFile.Dispose();
                        return 0;
                    }
                    else
                    {
                        validationMsg = rm.GetString("Alert_PleasechecktheDateOfjoiningFormat1", ci);
                        Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                        sr.Dispose();
                        aFile.Dispose();
                        return 0;
                    }
                }
                DataRow dr = dt.NewRow();
                for (int i = 0; i <= strArray.GetUpperBound(0); i++)
                {
                    if (i == 4)
                    {
                        dr[i] = strDateOfJoining;
                    }
                    else
                    {
                        dr[i] = strArray[i].Trim().Replace("\"", "");
                    }
                }
                for (int i = strArray.GetUpperBound(0) + 1; i <= 51; i++)
                {
                    dr[i] = "";
                }
                dt.Rows.Add(dr);
                strLine = sr.ReadLine();
            }
            sr.Dispose();
            aFile.Dispose();
            // get active count from ta_tbl_employee     // add with ds row count and this sum  // will check against lic no of employee count
            if (ds.Tables[0].Rows.Count == 0)
            {
                validationMsg = rm.GetString("Alert_ThereisnorecordintheImportfile", ci);
                Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                sr.Dispose();
                aFile.Dispose();
                return 0;
            }
            bool isAllowAdd = CheckNoOfEmployeeForLicense(ds, "import");
            if (isAllowAdd)
            {
                //TOdo: Add Insert Functionality
                ds.Tables[0].DefaultView.RowFilter = "Emp_FirstName IS NULL OR Emp_FirstName = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillEmployeeFirstNameforallemployees", ci);
                }
                ds.Tables[0].DefaultView.RowFilter = "Card_Number IS NULL OR Card_Number = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillEmployeeCardIDforallemployees", ci);
                }
                ds.Tables[0].DefaultView.RowFilter = "Employee_Id IS NULL OR Employee_Id = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillEmployeeIDforallemployees", ci);
                }
                ds.Tables[0].DefaultView.RowFilter = "DateOfJoining IS NULL OR DateOfJoining = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillDateOfJoiningforallemployees", ci);
                }
                ds.Tables[0].DefaultView.RowFilter = "Designation IS NULL OR Designation = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillDesignationforallemployees", ci);
                }
                firstLevelColumnName = ds.Tables[0].Columns[6].ColumnName.ToString();
                ds.Tables[0].DefaultView.RowFilter = firstLevelColumnName.Trim() + " IS NULL OR " + firstLevelColumnName.Trim() + " = ''";
                if (ds.Tables[0].DefaultView.Count > 0 && validationMsg == string.Empty)
                {
                    validationMsg = rm.GetString("Alert_Pleasefill", ci) + " " + firstLevelColumnName + " " + rm.GetString("Alert_forallemployees", ci);
                }
                if (validationMsg != string.Empty)
                {
                    Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                    sr.Dispose();
                    aFile.Dispose();
                    return 0;
                }
                foreach (DataRow dr in ds.Tables[0].Rows)
                {
                    //if (dr[6].ToString() == string.Empty)
                    //{
                    //    strScript = "<script language='javascript' type='text/javascript'>alert('" + rm.GetString("Aleart_Fill_Organization", ci) + "');</script>";
                    //    this.RegisterStartupScript("AlertErrorMsg", strScript);
                    //    sr.Dispose();
                    //    aFile.Dispose();
                    //    return 0;
                    //}
                    //if (dr["Employee_ID"] == string.Empty)
                    //{
                    //    dr["Employee_ID"] = dr["Card_Number"].ToString();
                    //}
                    ds.Tables[0].DefaultView.RowFilter = "Card_Number = '" + dr["Card_Number"].ToString() + "'";
                    if (ds.Tables[0].DefaultView.Count > 1)
                    {
                        Message("Card Number " + dr["Card_Number"] + " is duplicated");
                        sr.Dispose();
                        aFile.Dispose();
                        return 0;
                    }
                    ds.Tables[0].DefaultView.RowFilter = "Employee_ID = '" + dr["Employee_ID"].ToString() + "'";
                    if (ds.Tables[0].DefaultView.Count > 1)
                    {
                        Message("Employee ID " + dr["Employee_ID"] + " is duplicated");
                        return 0;
                    }
                }
                //Get Employee Details for the check employee code is already exits or not in employee master table. This line added by karthikeyan.r
                DataSet dsEmployeeDetails = new DataSet();
                dsEmployeeDetails = ObjImportData.GetEmployeeInformation();
                foreach (DataRow dr in ds.Tables[0].Rows)
                {
                    dsEmployeeDetails.Tables[0].DefaultView.RowFilter = "SwipeCardNo = '" + dr["Card_Number"].ToString() + "'";
                    if (dsEmployeeDetails.Tables[0].DefaultView.Count > 0)
                    {
                        Message("Card Number " + dr["Card_Number"] + " is duplicated");
                        sr.Dispose();
                        aFile.Dispose();
                        return 0;
                    }
                    dsEmployeeDetails.Tables[0].DefaultView.RowFilter = "Employee_Code_Id = '" + dr["Employee_ID"].ToString() + "'";
                    if (dsEmployeeDetails.Tables[0].DefaultView.Count > 0)
                    {
                        Message("Employee ID " + dr["Employee_ID"] + " is duplicated");
                        sr.Dispose();
                        aFile.Dispose();
                        return 0;
                    }
                }
                ObjImportData.InsertMasterDataEnterPrise(ds, Convert.ToBoolean(Session["ApplnMode"]), Convert.ToInt32(rblType.SelectedValue));
                return 1;
            }
            else
            {
                return 0;
            }
        }
    }
    private int ImportMasterDataForXls(FileInfo fileInfo)
    {
        string strScript = string.Empty;
        string validationMsg = string.Empty;
        DataSet ds = new DataSet();
        ds = ObjImportData.ReadExcelSheet(fileInfo);
        string firstLevelColumnName = string.Empty;
        if (ds.Tables[0].Rows.Count == 0)
        {
            validationMsg = rm.GetString("Alert_ThereisnorecordintheImportfile", ci);
            Message(validationMsg.Replace("\r", "").Replace("\n", ""));
            return 0;
        }
        DataTable dt = new DataTable();
        dt = ds.Tables[0];
        char TrimChar = '*';
        int intCount = 0;
        for (int incrementValue = 0; incrementValue < ds.Tables[0].Columns.Count; incrementValue++)
        {
            if (ds.Tables[0].Columns[incrementValue].ColumnName.ToString().Trim().Contains("*"))
            {
                ds.Tables[0].Columns[incrementValue].ColumnName = ds.Tables[0].Columns[incrementValue].ColumnName.ToString().Trim().TrimStart(TrimChar).Split('(')[0];
            }
            else
            {
                ds.Tables[0].Columns[incrementValue].ColumnName = ds.Tables[0].Columns[incrementValue].ColumnName.ToString().Trim().Split('(')[0];
            }
            if (rblType.SelectedValue == "1")
            {
                if (Convert.ToString(Session["Demo"]) == "Enterprise")
                {
                    if (incrementValue > 38)
                    {
                        intCount = intCount + 1;
                        ds.Tables[0].Columns[incrementValue].ColumnName = "Level" + Convert.ToString(intCount);
                    }
                }
                else
                {
                    if (incrementValue > 36)
                    {
                        intCount = intCount + 1;
                        ds.Tables[0].Columns[incrementValue].ColumnName = "Level" + Convert.ToString(intCount);
                    }
                }
            }
        }
        if (rblType.SelectedValue == "1")
        {
            firstLevelColumnName = "Level1";
            int intColumnCount = 49 - ds.Tables[0].Columns.Count;
            if (intColumnCount > 0)
            {
                for (int i = 0; i <= intColumnCount; i++)
                {
                    ds.Tables[0].Columns.Add("Level " + (intCount + i));
                }
            }
        }
        else
        {
            int intColumnCount = 52 - ds.Tables[0].Columns.Count;
            if (intColumnCount > 0)
            {
                for (int i = 0; i <= intColumnCount; i++)
                {
                    ds.Tables[0].Columns.Add("Column " + i);
                }
            }
        }
        bool isAllowAdd = CheckNoOfEmployeeForLicense(ds, "import");
        if (rblType.SelectedValue == "1")
        {
            StringWriter strWriteXML = new StringWriter();
            ds.WriteXml(strWriteXML);
            string strDataXML = Convert.ToString(strWriteXML);
            ObjImportData.InsertGridMasterData(strDataXML, Convert.ToString(Session["Demo"]), 1);
            return 1;
        }
        else
        {
            if (isAllowAdd)
            {
                //TOdo: Add Insert Functionality
                ds.Tables[0].DefaultView.RowFilter = "Emp_FirstName IS NULL OR CONVERT(Emp_FirstName, System.String)  = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillEmployeeFirstNameforallemployees", ci);
                }
                ds.Tables[0].DefaultView.RowFilter = "Card_Number IS NULL OR CONVERT(Card_Number, System.String) = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillEmployeeCardIDforallemployees", ci);
                }
                ds.Tables[0].DefaultView.RowFilter = "Employee_Id IS NULL OR CONVERT(Employee_Id, System.String) = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillEmployeeIDforallemployees", ci);
                }
                ds.Tables[0].DefaultView.RowFilter = "DateOfJoining IS NULL OR CONVERT(DateOfJoining,System.String) = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillDateOfJoiningforallemployees", ci);
                }
                ds.Tables[0].DefaultView.RowFilter = "Designation IS NULL OR CONVERT(Designation,System.String) = ''";
                if (ds.Tables[0].DefaultView.Count > 0)
                {
                    validationMsg = rm.GetString("Alert_PleasefillDesignationforallemployees", ci);
                }
                firstLevelColumnName = ds.Tables[0].Columns[6].ColumnName.ToString();
                ds.Tables[0].DefaultView.RowFilter = firstLevelColumnName.Trim() + " IS NULL OR CONVERT( " + firstLevelColumnName.Trim() + " ,System.String) = ''";
                if (ds.Tables[0].DefaultView.Count > 0 && validationMsg == string.Empty)
                {
                    validationMsg = rm.GetString("Alert_Pleasefill", ci) + " " + firstLevelColumnName + " " + rm.GetString("Alert_forallemployees", ci).Replace("\r", "").Replace("\n", "");
                }
                if (validationMsg != string.Empty)
                {
                    Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                    return 0;
                }
                foreach (DataRow dr in ds.Tables[0].Rows)
                {
                    try
                    {
                        gstrDateFormat = "dd-MMM-yyyy";
                        if (Session["MDateFormat"] != null)
                            gstrDateFormat = "dd-MMM-yyyy";
                        else
                            gstrDateFormat = "dd/MM/yyyy";
                        strDateOfJoining = objCommon.DateConvertion(gstrDateFormat, dr["DateOfJoining"].ToString());
                    }
                    catch (Exception ex)
                    {
                        if (rblType.SelectedValue == "1")
                        {
                            validationMsg = rm.GetString("Alert_PleasechecktheDateOfjoiningFormat", ci);
                            Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                            return 0;
                        }
                        else
                        {
                            validationMsg = rm.GetString("Alert_PleasechecktheDateOfjoiningFormat1", ci);
                            Message(validationMsg.Replace("\r", "").Replace("\n", ""));
                            return 0;
                        }
                    }
                    //if (dr["Employee_ID"] == string.Empty || dr["Employee_ID"].ToString() == "")
                    //{
                    //    dr["Employee_ID"] = dr["Card_Number"].ToString();
                    //}
                    ds.Tables[0].DefaultView.RowFilter = "Card_Number = '" + dr["Card_Number"].ToString() + "'";
                    if (ds.Tables[0].DefaultView.Count > 1)
                    {
                        strScript = "<script language='javascript' type='text/javascript'>alert('Card Number " + dr["Card_Number"] + " is duplicated');</script>";
                        this.RegisterStartupScript("AlertErrorMsg", strScript);
                        return 0;
                    }
                    ds.Tables[0].DefaultView.RowFilter = "Employee_ID = '" + dr["Employee_ID"].ToString() + "'";
                    if (ds.Tables[0].DefaultView.Count > 1)
                    {
                        strScript = "<script language='javascript' type='text/javascript'>alert('Employee ID " + dr["Employee_ID"] + " is duplicated');</script>";
                        this.RegisterStartupScript("AlertErrorMsg", strScript);
                        return 0;
                    }
                }
                ObjImportData.InsertMasterDataEnterPrise(ds, Convert.ToBoolean(Session["ApplnMode"]), Convert.ToInt32(rblType.SelectedValue));
                return 1;
            }
            else
            {
                return 0;
            }
        }
    }
    private void licenseBalanceDetails()
    {
        DemoVersion objdemo = new DemoVersion();
        DataSet dslicbalance = new DataSet();
        dslicbalance = objdemo.RemainingLicenseLeftCountDetails();
        if (dslicbalance.Tables[0].Rows.Count > 0)
        {
            lblempAddedvalue.Text = Convert.ToString(dslicbalance.Tables[0].Rows[0]["TotalEmployeesAdded"]);
            lblempActivevalue.Text = Convert.ToString(dslicbalance.Tables[0].Rows[0]["TotalActiveEmployees"]);
            lblempInActivevalue.Text = Convert.ToString(dslicbalance.Tables[0].Rows[0]["TotalInActiveEmployees"]);
            bool allowEmployeeAdd = true;
            allowEmployeeAdd = CheckNoOfEmployeeForLicense(null, "");
            int balance = 0;
            if (noOfEmployeeLicFile > 0)
            {
                balance = noOfEmployeeLicFile - Convert.ToInt16(dslicbalance.Tables[0].Rows[0]["TotalActiveEmployees"]) - Convert.ToInt16(dslicbalance.Tables[0].Rows[0]["TotalInActiveEmployees"]);
                if (balance > 0)
                    lblliccountvalue.Text = balance.ToString();
                else lblliccountvalue.Text = "0";
            }
            else lblliccountvalue.Text = "0";
        }
        else lblempAddedvalue.Text = lblliccountvalue.Text = lblempInActivevalue.Text = lblempActivevalue.Text = "0";
    }
    private bool CheckNoOfEmployeeForLicense(DataSet dsImport, string requestFrm)
    {
        DemoVersion objDemoVersion = new DemoVersion();
        bool allowEmployeeAdd = true;
        int importEmployee = 0;
        int existingEmployee = 0;
        string[] fileArr = Directory.GetFiles(Server.MapPath("../LicenseFile"), "*.lic");
        int arrCount = fileArr.Length;
        if (dsImport != null)
            dsImport.Tables[0].TableName = "TheData";
        if (arrCount > 0)
        {
            string licenseFileName = fileArr[arrCount - 1].ToString();
            FileStream licenseFileStream = new FileStream(licenseFileName, FileMode.Open);
            StreamReader licenseFileStreamReader = new StreamReader(licenseFileStream);
            string encryptedLicFileInfo = licenseFileStreamReader.ReadToEnd();
            licenseFileStreamReader.Close();
            licenseFileStream.Close();
            string decryptedLicFileInfo = string.Empty;
            try
            {
                decryptedLicFileInfo = Encryption.Decrypt(encryptedLicFileInfo, "");
            }
            catch
            {
                if (requestFrm != "")
                {
                    string strScript = "<script language='javascript' type='text/javascript'>";
                    strScript += "alert('" + rm.GetString("Alert_Licenseinformationarenotcorrect", ci) + "');";
                    strScript += "location.href='../Index.aspx';";
                    strScript += " </script>";
                    this.RegisterStartupScript("AlertLicInfoNotCorrect", strScript);
                }
                else
                {
                    noOfEmployeeLicFile = 0;
                }
                return false;
            }
            string[] decryptedLicFileInfoArr = decryptedLicFileInfo.Split('#');
            string basicLicInfo = decryptedLicFileInfoArr[0].ToString();
            string[] basicLicInfoArr = basicLicInfo.Split(',');
            noOfEmployeeLicFile = Convert.ToInt32(basicLicInfoArr[4].ToString());
            existingEmployee = objDemoVersion.DVCheckEmployeeCreationImport("License", noOfEmployeeLicFile);
            if (dsImport != null && dsImport.Tables.Count > 0)
            {
                importEmployee = existingEmployee + dsImport.Tables["TheData"].Rows.Count;
            }
            if (importEmployee > noOfEmployeeLicFile)
            {
                allowEmployeeAdd = false;
            }
            else
            {
                allowEmployeeAdd = true;
            }
            if (allowEmployeeAdd)
            {
                return true;
            }
            else
            {
                if (requestFrm != "")
                {
                    Message(rm.GetString("Alert_LicensenotallowtoImportmoreEmployees", ci));
                    return false;
                }
            }
        }
        return true;
    }
    public string Export(DataSet ds)
    {
        string columnnames = "", body = "", record = "";
        foreach (DataColumn col in ds.Tables[0].Columns)
        {
            columnnames = columnnames + " " + col.ColumnName + " " + ",";
        }
        columnnames = columnnames.Substring(0, columnnames.Length - 1);
        foreach (DataRow row in ds.Tables[0].Rows)
        {
            object[] arr = row.ItemArray;
            for (int i = 0; i <= arr.Length - 1; i++)
            {
                if (arr[i].ToString().IndexOf(",") > 0)
                {
                    record = record + " " + arr[i].ToString() + " " + ",";
                }
                else
                {
                    record = record + arr[i].ToString() + ",";
                }
            }
            body = body + record.Substring(0, record.Length - 1) + System.Environment.NewLine;
            record = "";
        }
        return (columnnames + System.Environment.NewLine + body);
    }
    /// <summary>
    /// Getting Information from resource file and display it in label
    /// </summary>
    /// <param name="ci"></param>
    private void LoadStrings(CultureInfo ci)
    {
        lbl_ImportEmployeeHeader.Text = rm.GetString("DataImport", ci);
        btn_Upload.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Upload", ci);
        lbl_ImportFilePath.Text = rm.GetString("SelectFile", ci);
        btnTemplate.Text = "&nbsp;&nbsp;" + rm.GetString("strDownloadTemplate", ci);
        lbl_Type.Text = rm.GetString("lbl_ImportType", ci);
        rblType.Items[0].Text = rm.GetString("rbt_Simple", ci);
        rblType.Items[1].Text = rm.GetString("rbt_Advanced", ci);
        lbl_IndicatesMandatoryFields.Text = rm.GetString("IndicatesMandatoryFields", ci);
        btn_UploadGrid.Text = "&nbsp;&nbsp;" + rm.GetString("btn_UploadGridData", ci);
        lbl_Mag.Text = rm.GetString("lbl_ListofInvalidemployeedetails", ci);
        //btnDelete.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Delete", ci);
        btnDelete.Text = "&nbsp;&nbsp;" + rm.GetString("AssignedEmployees_Remove", ci);
        lblempAdded.Text = rm.GetString("Field_empAddedvalue", ci);
        lblempActive.Text = rm.GetString("Field_empActive", ci);
        lblempInActive.Text = rm.GetString("Field_empInActive", ci);
        lblliccount.Text = rm.GetString("Field_liccount", ci);
        lblImportNote.Text = rm.GetString("Field_ImportantNote", ci);
    }
    #endregion
    #region Grid Events    
    protected void gvImportMaster_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            LinkButton btnError = (LinkButton)e.Row.FindControl("btnError");
            string strerror = "";
            strerror = btnError.ToolTip;
            char[] split = { '~' };
            string[] strToEmailIds = strerror.Split(split);
            for (int i = 0; i < strToEmailIds.Length; i++)
            {
                if (strToEmailIds[i].Contains("Please fill Employee First Name"))
                {
                    TextBox txtEmpFirstName = (TextBox)e.Row.FindControl("txt_Emp_FirstName");
                    txtEmpFirstName.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Date Of Birth"))
                {
                    TextBox txtDateOfBirth = (TextBox)e.Row.FindControl("txt_DateOfBirth");
                    txtDateOfBirth.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Contact Address"))
                {
                    TextBox txt_Contact_Address = (TextBox)e.Row.FindControl("txt_Contact_Address");
                    txt_Contact_Address.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please Enter the valid Email ID"))
                {
                    TextBox txt_Email_Id = (TextBox)e.Row.FindControl("txt_Email_Id");
                    txt_Email_Id.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please Enter the valid Personal Email ID"))
                {
                    TextBox txt_Personal_EmailID = (TextBox)e.Row.FindControl("txt_Personal_EmailID");
                    txt_Personal_EmailID.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Gender"))
                {
                    TextBox txt_Gender = (TextBox)e.Row.FindControl("txt_Gender");
                    txt_Gender.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Employee Code"))
                {
                    TextBox txt_Gender = (TextBox)e.Row.FindControl("txt_Employee_Code");
                    txt_Gender.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Date Of Joining"))
                {
                    TextBox txt_DateOfJoining = (TextBox)e.Row.FindControl("txt_DateOfJoining");
                    txt_DateOfJoining.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Designation"))
                {
                    TextBox txt_Designation = (TextBox)e.Row.FindControl("txt_Designation");
                    txt_Designation.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Employee Type"))
                {
                    TextBox txt_Employee_Type = (TextBox)e.Row.FindControl("txt_Employee_Type");
                    txt_Employee_Type.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Employee Category"))
                {
                    TextBox txt_Employee_Category = (TextBox)e.Row.FindControl("txt_Employee_Category");
                    txt_Employee_Category.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please fill Oraganization Level"))
                {
                    TextBox txt_Level1 = (TextBox)e.Row.FindControl("txt_Level1");
                    txt_Level1.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Gender should be either Male or Female"))
                {
                    TextBox txt_Gender = (TextBox)e.Row.FindControl("txt_Gender");
                    txt_Gender.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("CompOff_Eligible should be either 0 or 1"))
                {
                    TextBox txt_CompOff_Eligible = (TextBox)e.Row.FindControl("txt_CompOff_Eligible");
                    txt_CompOff_Eligible.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("OT_Eligible should be either 0 or 1"))
                {
                    TextBox txt_OT_Eligible = (TextBox)e.Row.FindControl("txt_OT_Eligible");
                    txt_OT_Eligible.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Report_Exclude should be either 0 or 1"))
                {
                    TextBox txt_Report_Exclude = (TextBox)e.Row.FindControl("txt_Report_Exclude");
                    txt_Report_Exclude.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Employee_Status should be either 0 or 1"))
                {
                    TextBox txt_Employee_Status = (TextBox)e.Row.FindControl("txt_Employee_Status");
                    txt_Employee_Status.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("IsDeleted should be either 0 or 1"))
                {
                    TextBox txt_IsDeleted = (TextBox)e.Row.FindControl("txt_IsDeleted");
                    txt_IsDeleted.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Hostel should be either 0 or 1"))
                {
                    TextBox txt_Hostel = (TextBox)e.Row.FindControl("txt_Hostel");
                    txt_Hostel.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Duplicated Employee_Code"))
                {
                    TextBox txt_Employee_Code = (TextBox)e.Row.FindControl("txt_Employee_Code");
                    txt_Employee_Code.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please check the Date Of Birth Format (dd-MMM-yyyy)"))
                {
                    TextBox txt_DateOfBirth = (TextBox)e.Row.FindControl("txt_DateOfBirth");
                    txt_DateOfBirth.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please check the Date Of Joining Format (dd-MMM-yyyy)"))
                {
                    TextBox txt_DateOfJoining = (TextBox)e.Row.FindControl("txt_DateOfJoining");
                    txt_DateOfJoining.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please check the Date Of Birth Record Format (dd-MMM-yyyy)"))
                {
                    TextBox txt_DateOfBirth_Record = (TextBox)e.Row.FindControl("txt_DateOfBirth_Record");
                    txt_DateOfBirth_Record.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please check the Passport Expiry Date Format (dd-MMM-yyyy)"))
                {
                    TextBox txt_Passport_ExpiryDate = (TextBox)e.Row.FindControl("txt_Passport_ExpiryDate");
                    txt_Passport_ExpiryDate.BorderColor = System.Drawing.Color.Red;
                }
                else if (strToEmailIds[i].Contains("Please check the Visa Expiry Date Format (dd-MMM-yyyy)"))
                {
                    TextBox txt_Visa_ExpiryDate = (TextBox)e.Row.FindControl("txt_Visa_ExpiryDate");
                    txt_Visa_ExpiryDate.BorderColor = System.Drawing.Color.Red;
                }
                if (Convert.ToString(Session["Demo"]) == "Enterprise")
                {
                    if (strToEmailIds[i].Contains("Please fill Grade"))
                    {
                        TextBox txt_Grade = (TextBox)e.Row.FindControl("txt_Grade");
                        txt_Grade.BorderColor = System.Drawing.Color.Red;
                    }
                    else if (strToEmailIds[i].Contains("Please fill GradeNo"))
                    {
                        TextBox txt_GradeNo = (TextBox)e.Row.FindControl("txt_GradeNo");
                        txt_GradeNo.BorderColor = System.Drawing.Color.Red;
                    }
                    else if (strToEmailIds[i].Contains("has different Grade"))
                    {
                        TextBox txt_Grade = (TextBox)e.Row.FindControl("txt_Grade");
                        txt_Grade.BorderColor = System.Drawing.Color.Red;
                        TextBox txt_GradeNo = (TextBox)e.Row.FindControl("txt_GradeNo");
                        txt_GradeNo.BorderColor = System.Drawing.Color.Red;
                    }
                }
            }
        }
    }
    public void GetEmptyText(object sender, EventArgs e)
    {
        Label lblNoRecords = (Label)sender;
        lblNoRecords.Text = rm.GetString("Alert_Norecordsfound", ci);
    }
    #endregion
    protected void btnDelete_Click(object sender, EventArgs e)
    {
        if (Page.IsValid)
        {
            ObjImportData.ToremoveImportErrorData();
            loadGridData();
            Message("Import master error data is removed Successfully");
        }
    }
}
