using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
//using System.IO;
using System.Globalization;
using System.IO;
using System.Net;
using System.Net.Mail;
using System.Net.NetworkInformation;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using OLServices;
using System.Resources;
using System.Threading;
public partial class TA_UI_LicenseRequest : System.Web.UI.Page
{
    #region Variable Declarion
    int MailSendOrNot = 0;
    Licensing objLic = new Licensing();
    LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
    // variable declaration
    string company = string.Empty, address1 = string.Empty, address2 = string.Empty, state = string.Empty;
    string zipCode = string.Empty, city = string.Empty, country = string.Empty;
    string phNo = string.Empty, faxNo = string.Empty, mobileNo = string.Empty, emialId = string.Empty;
    string noOfConcurrentUser = string.Empty, noOfEmployee = string.Empty, noOfTerminal = string.Empty, versionType = string.Empty, VersionNumber = string.Empty;
    string secEmailID = string.Empty;
    OL_Services Objservices = new OL_Services();
    string strDelarLogo;
    CultureInfo ci;
    ResourceManager rm;
    cls_Common objcommon = new cls_Common();
    string scriptText, FromEmailId = string.Empty, replacemailBody = string.Empty;
    DataTable dtTableScript = new DataTable();
    MailMessage message = new MailMessage();
    #endregion
    #region PageLoad
    protected void Page_Load(object sender, EventArgs e)
    {
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        if (!IsPostBack)
        {
            txtName.Focus();
            ClearValues();
            GetImagePath();
        }
    }
    #endregion
    #region Button Click Events
    /// <summary>
    /// Handles the Click event of the btnGenerateLicenseRequest control.
    /// </summary>
    /// <param name="sender">The source of the event.</param>
    /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
    protected void btnGenerateLicenseRequest_Click(object sender, EventArgs e)
    {
        if (Convert.ToInt16(txtNoOfConcurrentUser.Text) <= Convert.ToInt16(txtNoOfEmployee.Text))
        {
            company = txtName.Text.Trim();
            address1 = txtAddress1.Text.Trim();
            address2 = txtAddress2.Text.Trim();
            state = txtState.Text.Trim();
            zipCode = txtZipCode.Text.Trim();
            city = txtCity.Text.Trim();
            country = ddlCountry.SelectedItem.ToString();
            phNo = txtTelephoneNo.Text.Trim();
            faxNo = txtFaxNo.Text.Trim();
            mobileNo = txtMobileNo.Text.Trim();
            emialId = txtEmailId.Text.Trim();
            noOfConcurrentUser = txtNoOfConcurrentUser.Text.Trim();
            noOfEmployee = txtNoOfEmployee.Text.Trim();
            noOfTerminal = txtNoOfTerminal.Text.Trim();
            secEmailID = txtSecondEmailId.Text.Trim();
            versionType = Convert.ToString(ddlVersionType.SelectedItem.Text);
            string MacAddress = GetMACAddress();
            Int64 RequestID = -1;
            //Getting Applicatin version Number from database
            //Created By manikandan.R on 14-03-2014
            DataSet dsVersionDetails = new DataSet();
            dsVersionDetails = objLic.GettingVersionNumber();
            if (dsVersionDetails.Tables.Count > 0)
                if (dsVersionDetails.Tables[0].Rows.Count > 0)
                    VersionNumber = Convert.ToString(dsVersionDetails.Tables[0].Rows[0]["versionNumber"]);
            bool NetResult = System.Net.NetworkInformation.NetworkInterface.GetIsNetworkAvailable();
            if (NetResult == true)
            {
                DataSet dsCheckRequestID = new DataSet();
                dsCheckRequestID = objLic.SelectLicenseRequestID();
                if (dsCheckRequestID.Tables.Count > 0)
                    if (dsCheckRequestID.Tables[0].Rows.Count > 0)
                        RequestID = Convert.ToInt64(dsCheckRequestID.Tables[0].Rows[0]["RequestID"]);
                try
                {
                    DataSet dsLicenseRequest = new DataSet();
                    dsLicenseRequest = Objservices.InsertRequest(RequestID, company, address1, address2, city, zipCode, state, country, phNo, faxNo, mobileNo, emialId, secEmailID, Convert.ToInt64(noOfConcurrentUser),
                            Convert.ToInt64(noOfEmployee), Convert.ToInt64(noOfTerminal), versionType, VersionNumber, MacAddress, Convert.ToString(Session["user"]), "");
                    if (dsLicenseRequest.Tables.Count > 0)
                    {
                        if (dsLicenseRequest.Tables[0].Rows.Count > 0)
                        {
                            Int64 ResponseID = Convert.ToInt64(dsLicenseRequest.Tables[0].Rows[0]["RequestID"]);
                            if (ResponseID == 0)
                            {
                                ScriptManager.RegisterStartupScript(this, GetType(), "Alert", "alert('" + rm.GetString("Alert_Licfilealreadygenerated", ci) + "');window.location='TA_UI_LicenseFileUpload.aspx';", true);
                                ClearValues();
                            }
                            else
                            {
                                string ToMailID = Convert.ToString(dsLicenseRequest.Tables[0].Rows[0]["ToMailID"]);
                                string CCmailID = Convert.ToString(dsLicenseRequest.Tables[0].Rows[0]["CCMailID"]);
                                string ClientEmail = Convert.ToString(txtEmailId.Text);
                                if (Convert.ToString(txtSecondEmailId.Text) != string.Empty)
                                {
                                    ClientEmail += ";" + txtSecondEmailId.Text;
                                }
                                objLic.InsertLicenseResponseData(ResponseID, MacAddress, Convert.ToBoolean(true));
                                TriggerMail("License Request", "TimeCheck License Request Send Successfully", "TimeCheck License Request ", ToMailID, CCmailID);
                                TriggerMail("License Request Client", "TimeCheck License Request Send Successfully", "TimeCheck License Request ", ClientEmail, "");
                                ClearValues();
                                ScriptManager.RegisterStartupScript(this, GetType(), "Alert", "alert('" + rm.GetString("Alert_LicenseRequestSendSuccessfully", ci) + "');window.location='TA_UI_LicenseRequest.aspx';", true);
                            }
                        }
                        else
                            ScriptManager.RegisterStartupScript(this, GetType(), "Alert", "alert('" + rm.GetString("Unable to send license request", ci) + "');", true);
                    }
                }
                catch
                {
                    generateLRFFile(address1, address2, state, zipCode, city, country, phNo, faxNo, mobileNo, emialId, noOfConcurrentUser, noOfEmployee, noOfTerminal, secEmailID, versionType, VersionNumber);
                }
            }
            else
                generateLRFFile(address1, address2, state, zipCode, city, country, phNo, faxNo, mobileNo, emialId, noOfConcurrentUser, noOfEmployee, noOfTerminal, secEmailID, versionType, VersionNumber);
        }
    }
    /// <summary>
    /// Handles the Click event of the btnBack control.
    /// </summary>
    /// <param name="sender">The source of the event.</param>
    /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
    protected void btnBack_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Valid.aspx");
    }
    #endregion
    #region User Defiened Functions
    public void generateLRFFile(string address1, string address2, string state, string zipCode, string city, string country, string phNo, string faxNo,
        string mobileNo, string emialId, string noOfConcurrentUser, string noOfEmployee, string noOfTerminal, string secEmailID,
        string versionType, string VersionNumber)
    {
        string companyDetails = string.Empty;
        string customerIdLicFile = string.Empty;
        companyDetails += company;
        companyDetails += "*" + address1;
        companyDetails += "*" + address2;
        companyDetails += "*" + state;
        companyDetails += "*" + zipCode;
        companyDetails += "*" + city;
        companyDetails += "*" + country;
        companyDetails += "*" + phNo;
        companyDetails += "*" + faxNo;
        companyDetails += "*" + mobileNo;
        companyDetails += "*" + emialId;
        companyDetails += "*" + noOfConcurrentUser;
        companyDetails += "*" + noOfEmployee;
        string decryptedLicFileInfo = string.Empty;
        decryptedLicFileInfo = objcommon.VerifylicenseDetails(Server.MapPath("LicenseFile"), "*.lic");
        if (decryptedLicFileInfo != "")
        {
            string[] decryptedLicFileInfoArr = decryptedLicFileInfo.Split('#');
            string basicLicInfo = decryptedLicFileInfoArr[0].ToString();
            string[] basicLicInfoArr = basicLicInfo.Split(',');
            customerIdLicFile = basicLicInfoArr[0].ToString();
        }
        else if (decryptedLicFileInfo == "Error")
        {
            string strScript = "<script language='javascript' type='text/javascript'>";
            strScript += "alert('" + rm.GetString("Alert_Licenseinformationarenotcorrect", ci) + "');";
            strScript += " </script>";
            this.RegisterStartupScript("AlertLicInfoNotCorrect", strScript);
            return;
        }
        companyDetails += "*" + customerIdLicFile;
        companyDetails += "*" + noOfTerminal;
        companyDetails += "*" + secEmailID;
        companyDetails += "*" + versionType;
        companyDetails += "*" + VersionNumber;
        Session["companyDetails"] = companyDetails;
        Logger logger = new Logger();
        logger.FileName = Server.MapPath("LicenseFile/" + company + ".lrf");
        System.IO.FileInfo fileInfo = new System.IO.FileInfo(logger.FileName);
        NodeLocking nodeLocking = new NodeLocking();
        logger.Write(nodeLocking.GetEncryptedNodeId("", companyDetails));
        Response.Clear();
        Response.ContentType = MimeType(logger.FileName);
        HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment; filename=\"" + Path.GetFileName(logger.FileName) + "\"");
        FileStream sourceFile = new FileStream(logger.FileName, FileMode.Open);
        long FileSize;
        FileSize = sourceFile.Length;
        byte[] getContent = new byte[(int)FileSize];
        sourceFile.Read(getContent, 0, (int)sourceFile.Length);
        sourceFile.Close();
        Response.BinaryWrite(getContent);
        Response.End();
    }
    protected void GetImagePath()
    {
        try
        {
            if (System.Configuration.ConfigurationManager.AppSettings["DelarLogo"].ToString() != "")
            {
                strDelarLogo = System.Configuration.ConfigurationManager.AppSettings["DelarLogo"].ToString();
                IMG2.Visible = true;
                IMG2.Src = strDelarLogo;
            }
            else
            {
                IMG2.Visible = false;
            }
        }
        catch (Exception ex)
        {
        }
    }
    public string GetMACAddress()
    {
        NetworkInterface[] nics = NetworkInterface.GetAllNetworkInterfaces();
        String sMacAddress = string.Empty;
        foreach (NetworkInterface adapter in nics)
        {
            if (sMacAddress == String.Empty)// only return MAC Address from first card  
            {
                IPInterfaceProperties properties = adapter.GetIPProperties();
                sMacAddress = adapter.GetPhysicalAddress().ToString();
            }
        }
        return sMacAddress;
    }
    private string MimeType(string Filename)
    {
        string mime = "application/octetstream";
        string ext = System.IO.Path.GetExtension(Filename).ToLower();
        Microsoft.Win32.RegistryKey rk = Microsoft.Win32.Registry.ClassesRoot.OpenSubKey(ext);
        if (rk != null && rk.GetValue("Content Type") != null)
            mime = rk.GetValue("Content Type").ToString();
        return mime;
    }
    public void ClearValues()
    {
        txtName.Text = string.Empty;
        txtAddress1.Text = string.Empty;
        txtAddress2.Text = string.Empty;
        txtState.Text = string.Empty;
        txtZipCode.Text = string.Empty;
        txtCity.Text = string.Empty;
        ddlCountry.SelectedIndex = 0;
        txtTelephoneNo.Text = string.Empty;
        txtFaxNo.Text = string.Empty;
        txtMobileNo.Text = string.Empty;
        txtEmailId.Text = string.Empty;
        txtNoOfConcurrentUser.Text = "0";
        txtNoOfEmployee.Text = "0";
        txtNoOfTerminal.Text = "0";
        txtSecondEmailId.Text = string.Empty;
        ddlVersionType.SelectedIndex = 0;
    }
    #region EmailTriggering
    public void TriggerMail(string scriptName, string bodyContent, string subject, string ToEmail, string CcEmail)
    {
        try
        {
            dtTableScript = objLeaveApplicationEventData.GetEmailScripts(scriptName);
            if (dtTableScript.Rows.Count > 0)
            {
                scriptText = Convert.ToString(dtTableScript.Rows[0]["ScriptText"]);
                FromEmailId = Convert.ToString(ConfigurationManager.AppSettings["FromId"]);
                message.IsBodyHtml = true;
                message.Subject = subject + " | " + txtName.Text.Trim() + " | " + System.DateTime.Now.ToLongDateString();
                replacemailBody = replaceMailBodyContent(scriptText, scriptName);
                message.From = new MailAddress(FromEmailId);
                AlternateView htmlview = default(AlternateView);
                htmlview = AlternateView.CreateAlternateViewFromString(message.Body, null, "text/html");
                LinkedResource imageResourceEs = new LinkedResource(Server.MapPath("~/images/" + "logo.png"), "image/png");
                imageResourceEs.ContentId = "image1";
                imageResourceEs.TransferEncoding = System.Net.Mime.TransferEncoding.Base64;
                htmlview.LinkedResources.Add(imageResourceEs);
                LinkedResource imgCompLogo = new LinkedResource(Server.MapPath("~/images/" + "AngLogoNew_Email.png"), "image/png");
                imgCompLogo.ContentId = "imgCompLogo";
                imgCompLogo.TransferEncoding = System.Net.Mime.TransferEncoding.Base64;
                htmlview.LinkedResources.Add(imgCompLogo);
                message.AlternateViews.Add(htmlview);
                AddToAndCC(ToEmail, CcEmail, message, scriptName);
                objcommon.SendMail(message);
                MailSendOrNot = 1;
            }
            else
                MailSendOrNot = 0;
        }
        catch (Exception errorInSendingMail)
        {
        }
    }
    private static void AddToAndCC(string ToEmail, string CcEmail, MailMessage message, string scriptName)
    {
        char[] split = { ';' };
        string[] strToEmailIds = ToEmail.Split(split);
        foreach (string strToMail in strToEmailIds)
        {
            if (strToMail != string.Empty)
                message.To.Add(strToMail);
        }
        if (scriptName != "License Request Client")
        {
            string[] strCcEmailIds = CcEmail.Split(split);
            foreach (string strCcMail in strCcEmailIds)
            {
                if (strCcMail != string.Empty)
                    message.CC.Add(strCcMail);
            }
        }
    }
    private string replaceMailBodyContent(string scriptText, string scriptName)
    {
        string replacemailBody = string.Empty;
        if (scriptName == "License Request Client")
        {
            replacemailBody = scriptText.Replace("<<licenserequestusername>>", "<b>Dear " + txtName.Text + "</b>");
            replacemailBody = replacemailBody.Replace("<<licenserequestdetails>>", " You have send TimeCheck license requestion ");
        }
        else
            replacemailBody = scriptText.Replace("<<licenserequestdetails>>", txtName.Text + " requested the license");
        replacemailBody = replacemailBody.Replace("<<lblemployee>>", "Number Of Employees");
        replacemailBody = replacemailBody.Replace("<<employee>>", txtNoOfEmployee.Text);
        replacemailBody = replacemailBody.Replace("<<lblconcurrentusers>>", "Number Of Concurrent Users");
        replacemailBody = replacemailBody.Replace("<<concurrentusers>>", txtNoOfConcurrentUser.Text);
        replacemailBody = replacemailBody.Replace("<<lblterminals>>", "Number Of Terminals");
        replacemailBody = replacemailBody.Replace("<<terminals>>", txtNoOfTerminal.Text);
        replacemailBody = replacemailBody.Replace("<<lblversion>>", "Version Type");
        replacemailBody = replacemailBody.Replace("<<version>>", ddlVersionType.SelectedItem.Text);
        replacemailBody = replacemailBody.Replace("<<regards>>", "Regards,");
        if (scriptName == "License Request Client") replacemailBody = replacemailBody.Replace("<<clientname>>", "TimeCheck");
        else replacemailBody = replacemailBody.Replace("<<clientname>>", txtName.Text);
        return replacemailBody;
    }
    #endregion
    #endregion
}
