using System;
using System.Data;
using System.Net;
using System.Web;
using Cryptographys;
using System.Resources;
using System.Threading;
using System.Globalization;
using System.IO;
public partial class TA_UI_Valid : Base.BasePage
{
    #region VariableDeclaration
    cls_Common objCommon = new cls_Common();
    EmployeeEventData ObjEmployeeEventData = new EmployeeEventData();
    Licensing objLicense = new Licensing();
    string userId, ipAddress, session_Id, res, db_sessionId;
    string strDelarLogo;
    CultureInfo ci;
    ResourceManager rm;
    #endregion
    #region PageLoadEvent
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        if (!IsPostBack)
        {
            GetImagePath();
            if (Session["sLicNotSupport"] != null && Convert.ToString(Session["sLicNotSupport"]) == "1")
            {
                btnContinueDemoVersion.Visible = false;
                Message(rm.GetString("Alert_Licensecannotsupportothissystem", ci));
                return;
            }
            if (Session["sExpiryDays"] != null && Convert.ToInt32(Session["sExpiryDays"]) < 0)
            {
                btnContinueDemoVersion.Visible = false;
                Message(rm.GetString("Alert_YourSoftwareLicenseisexpired", ci));
                return;
            }
            if (Session["sModuleExceeds"] != null && Convert.ToString(Session["sModuleExceeds"]) == "1")
            {
                btnContinueDemoVersion.Visible = false;
                Message(rm.GetString("Alert_Pleaseupdatelicenseaslicenseinformation", ci));
                return;
            }
            if (Session["sEmployeeAllow"] != null && Convert.ToString(Session["sEmployeeAllow"]) == "0")
            {
                btnContinueDemoVersion.Visible = false;
                Message(rm.GetString("Alert_CannotLoginMaximumNoofConcurrentuser", ci));
                return;
            }
            if (Session["sTerminalAllow"] != null && Convert.ToString(Session["sTerminalAllow"]) == "0")
            {
                btnContinueDemoVersion.Visible = false;
                Message(rm.GetString("Alert_CannotLoginMaximumNoofTerminalshavebeencreated", ci));
                return;
            }
            if (!objCommon.VerifyDevMachine(Convert.ToString(Session["localMACAdderssForlic"])))
                objLicense.ActivateEmployeeBasedOnLicence("5");
        }
    }
    #endregion
    #region UserDefinedFunctions
    protected void GetImagePath()
    {
        try
        {
            if (System.Configuration.ConfigurationManager.AppSettings["DelarLogo"].ToString() != "")
            {
                strDelarLogo = Convert.ToString(System.Configuration.ConfigurationManager.AppSettings["DelarLogo"]);
                IMG2.Visible = true;
                IMG2.Src = strDelarLogo;
            }
            else
            {
                IMG2.Visible = false;
            }
        }
        catch (Exception ex)
        {
        }
    }
    protected bool CheckDemo()
    {
        string strInstalledDate = "";
        string strExpiryDate = "";
        string strDemoExpiryDate = "";
        //Check expiry date       
        strInstalledDate = Convert.ToString(System.Configuration.ConfigurationManager.AppSettings["Validate1"]);
        strDemoExpiryDate = strExpiryDate = Convert.ToString(System.Configuration.ConfigurationManager.AppSettings["Validate2"]);
        strInstalledDate = Cryptography.Decrypt(strInstalledDate, "TimecheckPhaseI");
        strExpiryDate = Cryptography.Decrypt(strExpiryDate, "TimecheckPhaseI");
        DateTime dtExpDate = DateTime.Parse(strExpiryDate);
        if (DateTime.Compare(DateTime.Now.Date, dtExpDate) >= 0)
        {
            MessageWithRedirect(rm.GetString("Alert_DemoVersionExpired", ci), "TA_UI_LicenseFileUpload.aspx");
            return false;
        }
        else
        {
            // get license information from protection table(TA_Tbl_LIC_Details)
            DataSet dsLicenseInfo = new DataSet();
            dsLicenseInfo = objLicense.SelectFromProtectionTable();
            if (dsLicenseInfo != null)
            {
                if (dsLicenseInfo.Tables.Count > 0)
                {
                    if (dsLicenseInfo.Tables[0].Rows.Count == 0)
                    {
                        string customerId, packageId, noOfConcurrentUser, noOfEmployee, noOfTerminal, packageVersion, licenseGenerationDate, expiryDate;
                        customerId = "1";
                        string ecustomerId = Encryption.Encrypt(customerId, "");
                        packageId = "1";
                        string epackageId = Encryption.Encrypt(packageId, "");
                        packageVersion = "2.7";
                        string epackageVersion = Encryption.Encrypt(packageVersion, "");
                        noOfConcurrentUser = "5";
                        string enoOfConcurrentUser = Encryption.Encrypt(noOfConcurrentUser, "");
                        noOfEmployee = "5";
                        string enoOfEmployee = Encryption.Encrypt(noOfEmployee, "");
                        string emacAddressLicFile = "";
                        licenseGenerationDate = strInstalledDate;
                        string elicenseGenerationDate = Encryption.Encrypt(licenseGenerationDate, "");
                        expiryDate = strExpiryDate;
                        string eexpiryDate = Encryption.Encrypt(expiryDate, "");
                        noOfTerminal = "5";
                        string enoOfTerminal = Encryption.Encrypt(noOfTerminal, "");
                        objLicense.InsertIntoProtectionTable(ecustomerId, epackageId, epackageVersion, enoOfConcurrentUser, enoOfEmployee, enoOfTerminal, emacAddressLicFile, elicenseGenerationDate, eexpiryDate, "", "", "", "", "", "", "");
                    }
                }
            }
            return true;
        }
    }
    private void ConcurrentUserUpdation()
    {
        Boolean Flag = true;
        cls_Common objCommon = new cls_Common();
        // for concurrent user status checking - code added here                                                    
        ipAddress = Request.ServerVariables["REMOTE_ADDR"].ToString();
        String strHostName;
        strHostName = Dns.GetHostName();
        IPHostEntry ipEntry = Dns.GetHostByName(strHostName);
        userId = Convert.ToString(Session["EmployeeId"]);
        DateTime loginTime = DateTime.Now;
        IPAddress[] addr = ipEntry.AddressList;
        string session_name = "a";
        session_Id = Session.SessionID.ToString();
        HttpCookie cookie_Session = new HttpCookie(session_name, session_Id);
        Response.Cookies.Add(cookie_Session);
        int cUserCount = HttpContext.Current.Cache.Count; // cache handling
        string sActiveYearcUserCount = Convert.ToString(Cache["ActiveYearSetting"]);
        if (sActiveYearcUserCount != null && sActiveYearcUserCount != String.Empty)
            cUserCount = cUserCount - 1;
        if (cUserCount == 0)
        {
            string sUser = Convert.ToString(Cache[userId.ToUpper()]);
            if (sUser == null || sUser == String.Empty)
            {
                TimeSpan SessTimeOut = new TimeSpan(0, 0, HttpContext.Current.Session.Timeout, 0, 0);
                string userValue = string.Empty;
                userValue = ipAddress.ToString() + "," + loginTime + "," + session_Id;
                HttpContext.Current.Cache.Insert(userId.ToUpper(), userValue, null, DateTime.MaxValue, SessTimeOut, System.Web.Caching.CacheItemPriority.NotRemovable, null); // cache handling
                Session["cUserName"] = userId.ToUpper();
                Flag = true;
            }
        }
        else
        {
            string sUser = Convert.ToString(Cache[userId.ToUpper()]);
            if (sUser != null && sUser != String.Empty)
            {
                lbl_Error.Text = "User is currently logged in an another session. If you want kill that session Press Proceed!";
                btn_Proceed.Visible = true;
                btn_Cancel.Visible = true;
                return;
            }
            else
            {
                int concurrentUserCount = 0;
                concurrentUserCount = HttpContext.Current.Cache.Count;
                string sActiveYear = Convert.ToString(Cache["ActiveYearSetting"]);
                if (sActiveYear == null && sActiveYear == String.Empty)
                    concurrentUserCount = concurrentUserCount - 1;
                if (userId.ToLower() != "admin" && concurrentUserCount >= 5)
                {
                    MessageWithRedirect(rm.GetString("Alert_CannotLoginMaximumNoofConcurrentuser", ci), "index.aspx");
                    Flag = false;
                    return;
                }
                else
                {
                    TimeSpan SessTimeOut = new TimeSpan(0, 0, HttpContext.Current.Session.Timeout, 0, 0);
                    string userValue = string.Empty;
                    userValue = ipAddress.ToString() + "," + loginTime + "," + session_Id;
                    HttpContext.Current.Cache.Insert(userId.ToUpper(), userValue, null, DateTime.MaxValue, SessTimeOut, System.Web.Caching.CacheItemPriority.NotRemovable, null); // cache handling
                    Session["cUserName"] = userId.ToUpper();
                    Flag = true;
                }
            }
        }
        if (Flag == true)
        {
            InsertUpdateLastLoginDetailsAndRedirect();
        }
    }
    private void InsertUpdateLastLoginDetailsAndRedirect()
    {
        //To get Last login and Logout time of the specified user               
        DataSet dsLastLogin = new DataSet();
        dsLastLogin = ObjEmployeeEventData.GetLastLoginTime(Convert.ToString(Session["EmployeeId"]));
        string strLastLogin = string.Empty;
        string strLastLogout = string.Empty;
        if (dsLastLogin.Tables[0].Rows.Count > 0)
        {
            if (dsLastLogin.Tables[0].Rows[0]["LastLoginTime"] != DBNull.Value)
                strLastLogin = Convert.ToString(dsLastLogin.Tables[0].Rows[0]["LastLoginTime"]);
            if (dsLastLogin.Tables[0].Rows[0]["LastLogoutTime"] != DBNull.Value)
                strLastLogout = Convert.ToString(dsLastLogin.Tables[0].Rows[0]["LastLogoutTime"]);
        }
        Session["LastLoginTime"] = strLastLogin;
        Session["LastLogoutTime"] = strLastLogout;
        //Insert or Update Login Time in database table
        try
        {
            ObjEmployeeEventData.InsertUpdateLastLogin(Convert.ToString(Session["EmployeeId"]));
        }
        catch (Exception ex)
        {
            Response.Write(ex.ToString());
        }
        DataSet dsUserGroup = new DataSet();
        dsUserGroup = objCommon.SelectGroupName(Convert.ToInt32(Session["userGroup_Id"]));
        if (dsUserGroup != null)
            if (dsUserGroup.Tables.Count > 0)
                if (dsUserGroup.Tables[0].Rows.Count > 0)
                {
                    Session["UserGroupName"] = Convert.ToString(dsUserGroup.Tables[0].Rows[0]["groupName"]);
                    Session["HasSpecialRights"] = Convert.ToString(dsUserGroup.Tables[0].Rows[0]["hasSpecialRights"]);
                    Session["IndividualUsers"] = Convert.ToString(dsUserGroup.Tables[0].Rows[0]["IndividualUsers"]);
                }
        if (Convert.ToString(Session["Edition"]) == "1" || Convert.ToString(Session["Edition"]) == "2")
            Response.Redirect("Landing.aspx");
        else
            Response.Redirect("DashBoard.aspx");
    }
    #endregion
    #region ButtonEvents
    protected void btn_Cancel_Click(object sender, EventArgs e)
    {
        Response.Redirect("Index.aspx");
    }
    protected void btn_Proceed_Click(object sender, EventArgs e)
    {
        UpdateGradeAndDemoType();
        if (Session["EmployeeId"] != null && Session["EmployeeId"].ToString() != "")
        {
            string sUser = Convert.ToString(Cache[Session["EmployeeId"].ToString().ToUpper()]);
            if (sUser != null && sUser != String.Empty)
            {
                ObjEmployeeEventData.InsertUpdateLastLogout(Session["EmployeeId"].ToString());
                HttpContext.Current.Cache.Remove(Session["EmployeeId"].ToString().ToUpper());
            }
            else return;
            ipAddress = Request.ServerVariables["REMOTE_ADDR"].ToString();
            DateTime loginTime = DateTime.Now;
            TimeSpan SessTimeOut = new TimeSpan(0, 0, HttpContext.Current.Session.Timeout, 0, 0);
            string userValue = string.Empty;
            userId = Convert.ToString(Session["EmployeeId"]);
            userValue = ipAddress.ToString() + "," + loginTime + "," + Session.SessionID.ToString();
            HttpContext.Current.Cache.Insert(userId.ToUpper(), userValue, null, DateTime.MaxValue, SessTimeOut, System.Web.Caching.CacheItemPriority.NotRemovable, null); // cache handling
            Session["cUserName"] = userId.ToUpper();
            InsertUpdateLastLoginDetailsAndRedirect();
        }
    }
    private void UpdateGradeAndDemoType()
    {
        if (rbtnEnterprise.Checked == true)
        {
            Session["Edition"] = "3";
            Session["Demo"] = "Enterprise";
            if (objCommon.VerifyDevMachine(Convert.ToString(Session["localMACAdderssForlic"])))
                objLicense.EnterpriseGradeUpdation();
        }
        else if (rbtnstandard.Checked == true)
        {
            Session["Edition"] = "1";
            Session["Demo"] = "Standard";
            objLicense.UpdateDefaultGradeForSEFromDemo("SEGrade", 1, Convert.ToInt32(Session["EmpAutoID"]));
        }
        else
        {
            Session["Edition"] = "2";
            Session["Demo"] = "Express";
            objLicense.UpdateDefaultGradeForSEFromDemo("SEGrade", 1, Convert.ToInt32(Session["EmpAutoID"]));
        }
        ObjEmployeeEventData.InsertandUpdateDemoType(Convert.ToString(Session["Demo"]));
    }
    protected void btnContinueDemoVersion_Click(object sender, EventArgs e)
    {
        UpdateGradeAndDemoType();
        bool valid = false;
        if (objCommon.VerifyDevMachine(Convert.ToString(Session["localMACAdderssForlic"])))
        {
            valid = true;
        }
        else
        {
            valid = CheckDemo();
        }
        if (valid) ConcurrentUserUpdation();
    }
    protected void btnLicenseRequest_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_LicenseRequest.aspx");
    }
    protected void btnUpdateLicense_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_LicenseFileUpload.aspx");
    }
    #endregion
}
