using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net.Mail;
using System.Data.SqlClient;
using System.Globalization;
using System.Threading;
using System.Reflection;
using System.Resources;
using System.Net;
public partial class Transactions_TA_UI_Transactions_LeaveApplicationView : Base.BasePage
{
    #region VariableDeclaration
    ResourceManager rm;
    CultureInfo ci;
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    cls_Common objcls_Common = new cls_Common();
    LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
    EmployeeEventData objEmployeeEventData = new EmployeeEventData();
    PermissionEventData objPermissionEventData = new PermissionEventData();
    DataSet ds_LeaveType = new DataSet();
    DataSet ds_PermissionApplication = new DataSet();
    DataSet ds_RemainingDays = new DataSet();
    DataSet ds_HoursAlreadyTaken = new DataSet();
    DataSet ds_CheckLeaveApplication = new DataSet();
    DataSet ds_MaxNoOfHours = new DataSet();
    DataSet dsEmailIdOfSanctionAuthority = new DataSet();
    DataSet ds_EmailIdOfReportingTo = new DataSet();
    DataSet ds_EmployeeDetails = new DataSet();
    bool blnCheckEmail = true;
    int iLeaveApplication_Id, iEmployeeID;
    int YearSettingID = 0;
    string strReason = string.Empty, strEmailIdReportingTo, gstrDateFormat, gstrTimeFormat, strlevelName;
    string strStatusType = string.Empty;
    #endregion
    #region PageLoad
    protected override void Page_Load(object sender, EventArgs e)
    {
        if (Request.UrlReferrer != null)
        {
            string GetURL = Request.UrlReferrer.ToString();
        }
        else
        {
            Response.Redirect("TA_UI_Transactions_LeaveApplication.aspx");
        }
        // session checking
        base.Page_Load(sender, e);
        //get the culture info to set the language
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        LoadStrings(ci);
        loadcss();
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_LeaveType", ci) + "','" + rm.GetString("Alert_LeaveRestictHoliday", ci) + "','" + rm.GetString("Alert_Fromdate", ci) + "','" + rm.GetString("Alert_ToDate", ci) + "','" + rm.GetString("Alert_FromSession", ci) + "','" + rm.GetString("Alert_ToSession", ci) + "','" + rm.GetString("Alert_FillReasons", ci) + "','" + rm.GetString("Alert_DayEmpty", ci) + "','" + rm.GetString("Alert_DaysZero", ci) + "','" + rm.GetString("Alert_Are_you_sure_to_Save", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        //Set UserRights
        UserRights();
        if (Session["User"] == null)
        {
            Response.Redirect("../index.aspx");
        }
        if (Session["User"].ToString() == "")
        {
            Response.Redirect("../index.aspx");
        }
        iLeaveApplication_Id = int.Parse(Request.QueryString["LeaveApplication_Id"].ToString());
        if (!Page.IsPostBack)
        {
            ViewDetails();
            GetEmployeeName();
            ControlCreation();
            btn_Delete.OnClientClick = "return confirm('" + rm.GetString("Alert_ConfirmDelete", ci) + "')";
        }
    }
    #endregion
    #region UserDefinedFunctions
    /// <summary>
    /// Using Resource file, here the label and button text are changed
    /// </summary>
    /// <param name="ci"></param>
    private void LoadStrings(CultureInfo ci)
    {
        lbl_EmployeeID1.Text = rm.GetString("Field_EmployeeID", ci);
        lbl_EmployeeName1.Text = rm.GetString("Field_EmployeeName", ci);
        lbl_From.Text = rm.GetString("LeaveApplication_From_New", ci);
        lbl_LeaveApplicationDate1.Text = rm.GetString("LeaveApplication_LeaveApplicationDate", ci);
        lbl_LeaveRestrictedHoliday.Text = rm.GetString("LeaveApplication_LeaveRestrictedHoliday", ci);
        lbl_LeaveType.Text = rm.GetString("lbl_leavetype", ci);
        lbl_Numberofdaysapplied.Text = rm.GetString("LeaveApplication_NumberOfDaysApplied", ci);
        lbl_Reason.Text = rm.GetString("Field_Reason", ci);
        lbl_To.Text = rm.GetString("LeaveApplication_To_New", ci);
        lbl_HeaderLeaveApplication.Text = rm.GetString("Transactions_LeaveApplication", ci);
        lbl_FromSession.Text = rm.GetString("Transactions_FromSession", ci);
        lbl_ToSession.Text = rm.GetString("Transactions_ToSession", ci);
        btn_Cancel.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
        btn_Delete.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Delete", ci);
    }
    public void YearClosureUpdate(string strLeaveStatus)
    {
        if (strLeaveStatus == "ApprovalNotRequired")
        {
            int Employee_Id = Convert.ToInt32(ViewState["iEmployeeID"]);
            string strTypeOfLeave = ViewState["lblType"].ToString();
            if (strTypeOfLeave == "Leave")
            {
                double NumberOfDays = Convert.ToDouble(lblNumberofdaysapplied.Text);
                int LeaveTypeId = Convert.ToInt32(ViewState["LeaveTypeId"]);
                if (Convert.ToBoolean(ViewState["IsBorrow"]) == false)
                {
                    objLeaveApplicationEventData.UpdateYearClosureByLeaveSanction(NumberOfDays, LeaveTypeId, Employee_Id, "R", Convert.ToInt32(Session["EmpAutoId"]), YearSettingID);
                }
                else
                {
                    objLeaveApplicationEventData.UpdateYearClosureByLeaveSanction(NumberOfDays, LeaveTypeId, Employee_Id, "RB", Convert.ToInt32(Session["EmpAutoId"]), YearSettingID);
                }
            }
            // Update Processed Data Flag for Re-Processing
            objLeaveApplicationEventData.UpdateProcessedDataFlag(Employee_Id, ViewState["LeaveFromDate"].ToString(), ViewState["LeaveToDate"].ToString(), 0);
        }
    }
    /// <summary>
    /// Display Leave Application Details Based on Leave Application Id
    /// </summary>
    public void ViewDetails()
    {
        DataSet ds_LeaveApplication = new DataSet();
        ds_LeaveApplication = objLeaveApplicationEventData.SelectLeaveApplication(iLeaveApplication_Id);
        iEmployeeID = Convert.ToInt32(ds_LeaveApplication.Tables[0].Rows[0]["Employee_Id"]);
        YearSettingID = Convert.ToInt32(ds_LeaveApplication.Tables[0].Rows[0]["YearSettings_Id"]);
        ViewState["iEmployeeID"] = iEmployeeID.ToString();
        ViewState["StatusOfApplication"] = ds_LeaveApplication.Tables[0].Rows[0]["Status"].ToString();
        lblType.Text = ds_LeaveApplication.Tables[0].Rows[0]["Type"].ToString();
        ViewState["lblType"] = ds_LeaveApplication.Tables[0].Rows[0]["Type"].ToString();
        if (lblType.Text == "Leave")
        {
            lblType.Text = rm.GetString("LeaveApplication_Leave", ci);
        }
        else if (lblType.Text == "Restricted Holiday")
        {
            lblType.Text = rm.GetString("Holiday_RestrictedHoliday", ci);
        }
        else if (lblType.Text == "Comp Off")
        {
            lblType.Text = rm.GetString("Caption_CompOff", ci);
        }
        else if (lblType.Text == "LOP")
        {
            lblType.Text = rm.GetString("lbl_LOP", ci);
        }
        else if (lblType.Text == "ESI")
        {
            lblType.Text = rm.GetString("Caption_ESI", ci);
        }
        lblLeaveType.Text = ds_LeaveApplication.Tables[0].Rows[0]["LeaveType"].ToString();
        ViewState["LeaveTypeId"] = ds_LeaveApplication.Tables[0].Rows[0]["LeaveType_Id"].ToString();
        lbl_LeaveApplicationDate.Text = (DateTime.Parse(ds_LeaveApplication.Tables[0].Rows[0]["Leave_ApplicationDate"].ToString())).ToString(Session["MDateFormat"].ToString());
        lblFromDate.Text = (DateTime.Parse(ds_LeaveApplication.Tables[0].Rows[0]["Leave_FromDate"].ToString())).ToString(Session["MDateFormat"].ToString());
        ViewState["LeaveFromDate"] = ds_LeaveApplication.Tables[0].Rows[0]["Leave_FromDate"].ToString();
        lblToDate.Text = (DateTime.Parse(ds_LeaveApplication.Tables[0].Rows[0]["Leave_ToDate"].ToString())).ToString(Session["MDateFormat"].ToString());
        ViewState["LeaveToDate"] = ds_LeaveApplication.Tables[0].Rows[0]["Leave_ToDate"].ToString();
        lblSessionFrom.Text = ds_LeaveApplication.Tables[0].Rows[0]["Leave_SessionFrom"].ToString();
        if (lblSessionFrom.Text == "First half")
        {
            lblSessionFrom.Text = rm.GetString("Caption_Firsthalf", ci);
        }
        else if (lblSessionFrom.Text == "Second half")
        {
            lblSessionFrom.Text = rm.GetString("Caption_Secondhalf", ci);
        }
        lblSessionTo.Text = ds_LeaveApplication.Tables[0].Rows[0]["Leave_SessionTo"].ToString();
        if (lblSessionTo.Text == "First half")
        {
            lblSessionTo.Text = rm.GetString("Caption_Firsthalf", ci);
        }
        else if (lblSessionTo.Text == "Second half")
        {
            lblSessionTo.Text = rm.GetString("Caption_Secondhalf", ci);
        }
        lblReason.Text = ds_LeaveApplication.Tables[0].Rows[0]["Reason"].ToString();
        lblNumberofdaysapplied.Text = ds_LeaveApplication.Tables[0].Rows[0]["NumberOfDays"].ToString();
        ViewState["IsBorrow"] = ds_LeaveApplication.Tables[0].Rows[0]["IsBorrow"].ToString();
        if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin")
        {
            if (ds_LeaveApplication.Tables[0].Rows[0]["Status"].ToString() == "Rejected")
            {
                btn_Delete.Enabled = true;
            }
        }
        else
        {
            if (ds_LeaveApplication.Tables[0].Rows[0]["Status"].ToString() == "Rejected")
            {
                btn_Delete.Enabled = false;
            }
        }
    }
    /// <summary>
    /// Get Employee Name Based on EmployeeId
    /// </summary>
    public void GetEmployeeName()
    {
        if (Session["user"] == null || Session["user"].ToString() == "")
        {
            Response.Redirect("../Index.aspx");
        }
        else
        {
            DataSet ds_EmployeeDetails = new DataSet();
            string strEmpFirstName, strEmpLastName;
            ds_EmployeeDetails = objEmployeeEventData.Select_EmployeeDetailsNewbyId(iEmployeeID);
            strEmpFirstName = ds_EmployeeDetails.Tables[0].Rows[0]["Employee_FirstName"].ToString();
            strEmpLastName = ds_EmployeeDetails.Tables[0].Rows[0]["Employee_LastName"].ToString();
            lbl_EmployeeID.Text = ds_EmployeeDetails.Tables[0].Rows[0]["Employee_Code_Id"].ToString();
            lbl_EmployeeName.Text = strEmpFirstName + " " + strEmpLastName;
        }
    }
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(22, Convert.ToInt32(Session["userGroup_Id"]), "");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["viewPrv"] == DBNull.Value || Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) != 1)
            {
                Response.Redirect("TA_UI_Transactions_LeaveApplication.aspx");
            }
            if (ds_Checkuser.Tables[0].Rows[0]["deletePrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["deletePrv"]) == 1)
            {
                this.btn_Delete.Visible = true;
            }
            else
            {
                this.btn_Delete.Visible = false;
            }
        }
        else
        {
            Response.Redirect("TransactionLandingPAge.aspx");
        }
    }
    private void loadcss()
    {
        CultureInfo ci;
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        //if Standard Demo
        htmlLeaveView.Attributes.Add("dir", rm.GetString("Direction", ci));
        switch (source_Language)
        {
            case "Resources.Resource_AR":
                stylebootstrap.Href = "../bootstrap/css/bootstrap-rtl.min.css";
                stylefontawesome.Href = "../bootstrap/font-awesome/css/font-awesome-rtl.css";
                styleAdminLTE.Href = "../dist/css/AdminLTE.min-rtl.css";
                stylecustom.Href = "../dist/css/custom-rtl.css";
                stylefonts.Href = "../dist/css/fonts.css";
                break;
            default:
                stylebootstrap.Href = "../bootstrap/css/bootstrap.min.css";
                stylefontawesome.Href = "../bootstrap/font-awesome/css/font-awesome.css";
                styleAdminLTE.Href = "../dist/css/AdminLTE.min.css";
                stylecustom.Href = "../dist/css/custom.css";
                stylefonts.Href = "../dist/css/fonts.css";
                break;
        }
    }
    private void MailToReportingTo()
    {
        string strEmployeeEmailId = string.Empty;
        ds_EmployeeDetails = objLeaveApplicationEventData.GetEmployeeDetails(Convert.ToInt32(ViewState["iEmployeeID"]));
        if (ds_EmployeeDetails.Tables.Count > 0)
        {
            if (ds_EmployeeDetails.Tables[0].Rows.Count > 0)
            {
                strlevelName = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["levelName"]);
                strEmployeeEmailId = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["emailId"]);
                objcls_Common.PrepareEmailContentForMailTriggering
               (
                    Convert.ToString(lbl_EmployeeID.Text),
                    Convert.ToString(lbl_EmployeeName.Text),
                    strlevelName,
                    Convert.ToString(0),
                    "",
                    "",
                    strReason,
                    strEmployeeEmailId,
                    "Deleted",
                    "",
                    "",
                    "",
                    "",
                   Convert.ToString(iLeaveApplication_Id),
                   Convert.ToString(lblLeaveType.Text),
                   Convert.ToString(lbl_LeaveApplicationDate.Text),
                   Convert.ToString(lblFromDate.Text),
                   Convert.ToString(lblToDate.Text),
                   Convert.ToString(lblSessionFrom.Text),
                   Convert.ToString(lblSessionTo.Text),
                   Convert.ToString(lblNumberofdaysapplied.Text),
                   "",
                   "",
                   "LeaveApplication",
                   iEmployeeID
               );
            }
        }
    }
    private void ControlCreation()
    {
        // getting leave conversation 
        DataSet dsLeaveConversation = objLeaveApplicationEventData.GetLeaveConversation(iLeaveApplication_Id);
        if (dsLeaveConversation.Tables[0].Rows.Count > 0)
        {
            Table leaveConversation = new Table();
            leaveConversation.Width = Unit.Percentage(100);
            leaveConversation.CssClass = "table das-table1";
            TableHeaderRow leaveConversationHr = new TableHeaderRow();
            TableHeaderCell leaveConversationHeading3 = new TableHeaderCell();
            leaveConversationHeading3.Text = rm.GetString("TerminalDataType_Date_And_Time", ci);
            leaveConversationHeading3.HorizontalAlign = HorizontalAlign.Left;
            leaveConversationHr.Cells.Add(leaveConversationHeading3);
            TableHeaderCell leaveConversationHeading1 = new TableHeaderCell();
            leaveConversationHeading1.Text = rm.GetString("leaveConversationHeading1", ci);
            leaveConversationHeading1.HorizontalAlign = HorizontalAlign.Left;
            leaveConversationHr.Cells.Add(leaveConversationHeading1);
            TableHeaderCell leaveConversationHeading2 = new TableHeaderCell();
            leaveConversationHeading2.Text = rm.GetString("leaveConversationHeading2", ci);
            leaveConversationHeading2.HorizontalAlign = HorizontalAlign.Left;
            leaveConversationHr.Cells.Add(leaveConversationHeading2);
            leaveConversationHr.CssClass = "empheader";
            leaveConversation.Rows.Add(leaveConversationHr);
            if (dsLeaveConversation != null && dsLeaveConversation.Tables.Count > 0)
            {
                if (dsLeaveConversation.Tables[0].Rows.Count > 0)
                {
                    int rowIndex = 0;
                    foreach (DataRow drLeaveConversation in dsLeaveConversation.Tables[0].Rows)
                    {
                        TableRow trLeaveConversation = new TableRow();
                        TableCell tcLeaveConversationRepliedOn = new TableCell();
                        Label lblLeaveConversationRepliedOn = new Label();
                        tcLeaveConversationRepliedOn.Width = 200;
                        lblLeaveConversationRepliedOn.ID = "lblLeaveConversationRepliedOn" + rowIndex;
                        lblLeaveConversationRepliedOn.Text = Convert.ToDateTime(drLeaveConversation["TimeStamp"]).ToString(Session["MDateFormat"].ToString()) + "  " + Convert.ToDateTime(drLeaveConversation["TimeStamp"]).ToString(Session["MTimeFormat"].ToString());
                        tcLeaveConversationRepliedOn.Controls.Add(lblLeaveConversationRepliedOn);
                        trLeaveConversation.Cells.Add(tcLeaveConversationRepliedOn);
                        TableCell tcLeaveConversationCommentsBy = new TableCell();
                        Label lblLeaveConversationCommentsBy = new Label();
                        tcLeaveConversationCommentsBy.Width = 200;
                        lblLeaveConversationCommentsBy.ID = "lblLeaveConversationCommentsBy" + rowIndex;
                        lblLeaveConversationCommentsBy.Text = objLeaveApplicationEventData.GetEmployeeName(Convert.ToInt32(drLeaveConversation["Emp_Id"].ToString()));
                        tcLeaveConversationCommentsBy.Controls.Add(lblLeaveConversationCommentsBy);
                        trLeaveConversation.Cells.Add(tcLeaveConversationCommentsBy);
                        TableCell tcLeaveConversationComments = new TableCell();
                        Label lblLeaveConversationComments = new Label();
                        lblLeaveConversationComments.ID = "lblLeaveConversationComments" + rowIndex;
                        lblLeaveConversationComments.Text = drLeaveConversation["Comments"].ToString();
                        tcLeaveConversationComments.Controls.Add(lblLeaveConversationComments);
                        trLeaveConversation.Cells.Add(tcLeaveConversationComments);
                        leaveConversation.Rows.Add(trLeaveConversation);
                        rowIndex += 1;
                    }
                }
            }
            divLeaveConversation.Controls.Add(leaveConversation);
        }
    }
    #endregion
    #region ButtonEvents
    protected void btn_Delete_Click(object sender, EventArgs e)
    {
        //Declare Leave Status
        string strLeaveStatus = string.Empty;
        int approvalSettingsPageExists = 0;
        //Checking grade module is available or not and changed the id value from 110 to 228
        approvalSettingsPageExists = objcls_Common.CheckPageExistsInLicense(228);
        if (approvalSettingsPageExists == 1)
        {
            //Get Compnay Id of the Employeee
            int intCompanyId = base.GetCompanyId(Convert.ToInt32(ViewState["iEmployeeID"]));
            //Get Approval Settings Based on Company Id
            DataSet dsApprovalSettings = new DataSet();
            ShiftEvenData objShift = new ShiftEvenData();
            dsApprovalSettings = objShift.SelectApprovalSettings(intCompanyId);
            if (dsApprovalSettings != null)
            {
                if (dsApprovalSettings.Tables.Count > 0)
                {
                    if (dsApprovalSettings.Tables[0].Rows.Count > 0)
                    {
                        if (Convert.ToBoolean(dsApprovalSettings.Tables[0].Rows[0]["Approval"]) == false)
                            strLeaveStatus = "ApprovalNotRequired";
                    }
                    else
                    {
                        base.Message(rm.GetString("Msg_ApprovalSettings", ci));
                        return;
                    }
                }
            }
        }
        else
        {
            strLeaveStatus = "ApprovalNotRequired";
        }
        if (ViewState["StatusOfApplication"].ToString() == "Rejected")
        {
            objLeaveApplicationEventData.Delete_LeaveApplication(iLeaveApplication_Id, Convert.ToInt32(Session["EmpAutoId"]));
            RedirectToLandingPage();
        }
        else if (ViewState["StatusOfApplication"].ToString() == "Pending" || strLeaveStatus == "ApprovalNotRequired")
        {
            //Check Borrow Leave Exists after normal leaves
            int intBorrowCount = objLeaveApplicationEventData.CheckBorrowLeaveExists(ViewState["LeaveFromDate"].ToString(), ViewState["LeaveToDate"].ToString(), Convert.ToInt32(ViewState["LeaveTypeId"]), Convert.ToInt32(ViewState["iEmployeeID"]));
            if (intBorrowCount > 0)
            {
                base.Message(rm.GetString("Msg_BorrowLeavesareavailabletodelete", ci));
                return;
            }
            //Delete Leave Application
            objLeaveApplicationEventData.Delete_LeaveApplication(iLeaveApplication_Id, Convert.ToInt32(Session["EmpAutoId"]));
            //Update Year Closure
            YearClosureUpdate(strLeaveStatus);
            //Added Newly by Manikandan.RR on 10-06-2015 11.38 AM
            if (ConfigurationManager.AppSettings.Get("MailNotificationRequired") != null)
                if (Convert.ToInt16(ConfigurationManager.AppSettings.Get("MailNotificationRequired")) == 1)
                {
                    MailToReportingTo();
                }
            RedirectToLandingPage();
        }
        else
        {
            if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
            {
                //Check Borrow Leave Exists after normal leaves
                int intBorrowCount = objLeaveApplicationEventData.CheckBorrowLeaveExists(ViewState["LeaveFromDate"].ToString(), ViewState["LeaveToDate"].ToString(), Convert.ToInt32(ViewState["LeaveTypeId"]), Convert.ToInt32(ViewState["iEmployeeID"]));
                if (intBorrowCount > 0)
                {
                    base.Message(rm.GetString("Msg_BorrowLeavesareavailabletodelete", ci));
                    return;
                }
                //Delete Leave Application
                objLeaveApplicationEventData.Delete_LeaveApplication(iLeaveApplication_Id, Convert.ToInt32(Session["EmpAutoId"]));
                //Update Year Closure
                YearClosureUpdate(strLeaveStatus);
                if (ConfigurationManager.AppSettings.Get("MailNotificationRequired") != null)
                    if (Convert.ToInt16(ConfigurationManager.AppSettings.Get("MailNotificationRequired")) == 1)
                    {
                        MailToReportingTo();
                    }
                RedirectToLandingPage();
            }
            else
            {
                ControlCreation();
                Page.RegisterStartupScript("statusalert", "<script language='javascript'>alert('" + rm.GetString("Alert_Cannotdeletethisrecordd", ci) + "');</script>");
            }
        }
    }

    private void RedirectToLandingPage()
    {
        string strScript = "";
        strScript = strScript + "<script language='javascript'>";
        strScript = strScript + "alert('" + rm.GetString("Alert_LeaveApplicationDeleted", ci) + "');";
        strScript = strScript + "location.replace('TA_UI_Transactions_LeaveApplication.aspx');";
        strScript = strScript + "</script>";
        //Dispaly alert messsage.
        Page.RegisterStartupScript("AlertLDel65507866", strScript);
    }

    protected void btn_Cancel_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Transactions_LeaveApplication.aspx");
    }
    #endregion
}