using System;
using System.Collections;
using System.Data;
using System.Globalization;
using System.Web;
using System.Web.Security;
using System.IO;
using System.Text;
using NPOI.HSSF.UserModel;
using NPOI.SS.UserModel;
using NPOI.HSSF.Util;
using NPOI.SS.Util;
using System.Web.UI.WebControls;

namespace Base
{
    /// <summary>
    /// Summary description for BasePage
    /// </summary>
    public class BasePage : System.Web.UI.Page
    {
        HSSFFont pageheaderFont;
        ISheet sheet;
        HSSFCellStyle empDetailStyle, DetailStyle, MainStyle, fieldHeaderStyle, totalStyle;
        int rowIndex = 0;
        NPOI.SS.UserModel.IRow row;
        protected virtual void Page_Load(object sender, System.EventArgs e)
        {
            this.CheckTimeout();
        }
        public void CheckPages(int iPageID)
        {
            if (Session["CheckMandatoryPage"] != null && Convert.ToString(Session["CheckMandatoryPage"]) == "Required")
            {
                string sPath = System.Web.HttpContext.Current.Request.Url.AbsolutePath;
                System.IO.FileInfo oInfo = new System.IO.FileInfo(sPath);
                string sRet = oInfo.Name;
                cls_Common objClass = new cls_Common();
                objClass.UpdateRowsCountAllTables();
                DataSet dsPage = new DataSet();
                dsPage = objClass.GetRowsCountInTable(iPageID);
                if (dsPage != null && dsPage.Tables.Count > 0 && dsPage.Tables[0].Rows.Count > 0)
                {
                    if (dsPage.Tables[0].Rows[0]["Rows"] != DBNull.Value && Convert.ToInt16(dsPage.Tables[0].Rows[0]["Rows"]) > 0)
                    {
                        return;
                    }
                }
                DataSet ds = new DataSet();
                objClass.UpdateRowsCountAllTables();
                ds = objClass.GetRowsCountAllTables();
                if (ds != null && ds.Tables.Count > 0 && ds.Tables[0].Rows.Count > 0)
                {
                    for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
                    {
                        if (ds.Tables[0].Rows[i]["Rows"] != DBNull.Value && Convert.ToInt16(ds.Tables[0].Rows[i]["Rows"]) == 0)
                        {
                            string strModule = "";
                            string strPage = "";
                            string strPagePath = "";
                            int iPage = 0;
                            if (ds.Tables[0].Rows[i]["Module"] != DBNull.Value)
                            {
                                strModule = Convert.ToString(ds.Tables[0].Rows[i]["Module"]);
                            }
                            if (ds.Tables[0].Rows[i]["Page"] != DBNull.Value)
                            {
                                strPage = Convert.ToString(ds.Tables[0].Rows[i]["Page"]);
                            }
                            if (ds.Tables[0].Rows[i]["PageFullPath"] != DBNull.Value)
                            {
                                strPagePath = Convert.ToString(ds.Tables[0].Rows[i]["PageFullPath"]);
                            }
                            if (ds.Tables[0].Rows[i]["PageId"] != DBNull.Value)
                            {
                                iPage = Convert.ToInt16(ds.Tables[0].Rows[i]["PageId"]);
                            }
                            if (iPage == iPageID)
                                return;
                            string temppage;
                            if (iPageID == 179)
                                temppage = "Landing.aspx";
                            else
                                temppage = "../Landing.aspx";
                            string strScript = "if (confirm('Please Fill - " + strModule + "'))" + "{ location.href='" + strPagePath + "'; }else { location.href='" + temppage + "'; }";
                            ClientScript.RegisterClientScriptBlock(this.GetType(), "Redirect", strScript, true);
                            return;
                        }
                    }
                }
            }
        }
        private void CheckTimeout()
        {
            CultureInfo CI = new CultureInfo("en-us");
            CI.DateTimeFormat.ShortDatePattern = "MM/dd/yyyy";
            CI.DateTimeFormat.DateSeparator = @"/";
            System.Threading.Thread.CurrentThread.CurrentCulture = CI;
            //Session.LCID = 1033;
            if (Session["Session_ActiveLanguage"] == null)
            {
                Session.Abandon();
                FormsAuthentication.SignOut();
                string currentPageFileName = new FileInfo(this.Request.Url.LocalPath).Name;
                switch (currentPageFileName.ToUpper())
                {
                    case "DASHBOARD.ASPX":
                    case "TA_UI_VALID.ASPX":
                    case "LANDING.ASPX":
                    case "MYCALENDAR.ASPX":
                        HttpContext.Current.Response.Redirect("Index.aspx");
                        break;
                    default:
                        HttpContext.Current.Response.Redirect("../Index.aspx");
                        break;
                }
            }
        }
        public int GetConcurrentUserCount()
        {
            int concurrentUserCount = 0;
            concurrentUserCount = HttpContext.Current.Cache.Count;
            string sActiveYear = Convert.ToString(Cache["ActiveYearSetting"]);
            if (sActiveYear == null || sActiveYear == String.Empty)
            {
            }
            else
            {
                concurrentUserCount = concurrentUserCount - 1;
            }
            return concurrentUserCount;
        }
        #region Message.
        public void Message(string messageContent)
        {
            string strScript = "<script language='javascript' type='text/javascript'>";
            strScript += "alert('" + messageContent.Replace("'", " ").Replace("\n", "").Replace("\r", "") + "');";
            strScript += " </script>";
            this.RegisterStartupScript("setScript", strScript);
        }
        #endregion
        #region MessageWithRedirect.
        public void MessageWithRedirect(string messageContent, string ToPage)
        {
            string strScript = "<script language='javascript' type='text/javascript'>";
            strScript += "alert('" + messageContent.Replace("'", " ").Replace("\n", "").Replace("\r", "") + "');";
            strScript += "location.href='" + ToPage + "';";
            strScript += " </script>";
            this.RegisterStartupScript("setScript", strScript);
        }
        public void MessageWithreplace(string messageContent, string ToPage)
        {
            string strScript = "<script language='javascript' type='text/javascript'>";
            strScript += "alert('" + messageContent.Replace("'", " ").Replace("\n", "").Replace("\r", "") + "');";
            strScript += "location.replace('" + ToPage + "');";
            strScript += " </script>";
            this.RegisterStartupScript("setScript", strScript);
        }
        #endregion
        #region CompanyId for Employee
        public int GetCompanyId(int intEmployeeId)
        {
            DataSet dsEmp = new DataSet();
            LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
            dsEmp = objLeaveApplicationEventData.GetEmployeeLevel(Convert.ToInt32(intEmployeeId));
            int iEmployeeLevelID = 0;
            if (dsEmp != null && dsEmp.Tables.Count != 0 && dsEmp.Tables[0].Rows.Count != 0)
            {
                if (dsEmp.Tables[0].Rows[0]["levelID"] != DBNull.Value)
                {
                    iEmployeeLevelID = Convert.ToInt32(dsEmp.Tables[0].Rows[0]["levelID"]);
                }
            }
            //Select Company
            org_levelsEventData getOrg = new org_levelsEventData();
            getOrg.GetOrgParentLevels_FromID(iEmployeeLevelID);
            DataSet ds_getOrg = new DataSet();
            ds_getOrg = getOrg.GetOrgParentLevels();
            int iCompanyID = 0;
            if (ds_getOrg != null)
            {
                if (ds_getOrg.Tables[0].Rows.Count > 0)
                {
                    iCompanyID = Convert.ToInt32(ds_getOrg.Tables[0].Rows[0]["LevelID"].ToString());
                }
            }
            return iCompanyID;
        }
        #endregion
        public void LogoutUsers()
        {
            string userId = string.Empty;
            DictionaryEntry de = new DictionaryEntry();
            EmployeeEventData ObjEmployeeEventData = new EmployeeEventData();
            foreach (object obj in HttpContext.Current.Cache)
            {
                de = (DictionaryEntry)obj;
                if (de.Key.ToString() != "ActiveYearSetting")
                {
                    userId = de.Key.ToString();
                    ObjEmployeeEventData.UpdateLastLogout(userId);
                    HttpContext.Current.Cache.Remove(userId.ToUpper());
                }
            }
        }

        public void EncryptandRedirect(string navigatePage, string reportName, string fromdate, string todate, string empId, int shift, string empName, string levId, int empcategory, int emptype, string groupName, string grade, string cardNo, int ParentId, int Designation, string Gender, int absentType, int Noofdays, int continuousAbsent, string blnNormal, string SummaryOrDetail, string MinExceptHrs, string rptHeaderName, string Intime, string OutTime, int AllSwipesReportType, string MinWorkHours, string dtMonth, string dtYear, string mon, string ReportType, int NoOfDays, string TotalDays, int RawDataDashboard, string ProcessType, string TableDescription, string Operation, int EmailAvail, int OTCompOff, int UserGroupID, int LeavePolicyID, int ReportingTo, int SanctionTo, string EmpStatus, string PageFilter, string SanctionType, string Status, string LeaveType, string LeaveReportType, string MonthClosureId, string YearSettingsId, string strLeavePlanned, string strLeaveWI, string strLeaveWOI, string MaxDeviationHrs, string PunchType)
        {
            StringBuilder strScript = new StringBuilder();
            StringBuilder encryptedString = new StringBuilder();

            String encryptKey = "TimecheckPhaseI";
            if (reportName != null && navigatePage != null)
            {
                encryptedString.Append("ReportName=" + Cryptographys.Cryptography.Encrypt(reportName, encryptKey));
                if (encryptedString != null)
                {
                    if (fromdate != null)
                        encryptedString.Append("&dtFrom=" + Cryptographys.Cryptography.Encrypt(fromdate, encryptKey));
                    if (todate != null)
                        encryptedString.Append("&dtTo=" + Cryptographys.Cryptography.Encrypt(todate, encryptKey));
                    if (empId != null)
                        encryptedString.Append("&empid=" + Cryptographys.Cryptography.Encrypt(empId, encryptKey));
                    if (Convert.ToString(shift) != null)
                        encryptedString.Append("&shft=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(shift), encryptKey));
                    if (empName != null)
                        encryptedString.Append("&EmpName=" + Cryptographys.Cryptography.Encrypt(empName, encryptKey));
                    if (levId != null)
                        encryptedString.Append("&Level=" + Cryptographys.Cryptography.Encrypt(levId, encryptKey));
                    if (Convert.ToString(empcategory) != null)
                        encryptedString.Append("&EmpCategory=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(empcategory), encryptKey));
                    if (Convert.ToString(emptype) != null)
                        encryptedString.Append("&EmpType=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(emptype), encryptKey));
                    if (Convert.ToString(ParentId) != null)
                        encryptedString.Append("&ParentLevelId=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(ParentId), encryptKey));
                    if (Convert.ToString(groupName) != null)
                        encryptedString.Append("&UserGroupName=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(groupName), encryptKey));
                    if (Convert.ToString(grade) != null)
                        encryptedString.Append("&GradeLevel=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(grade), encryptKey));
                    if (cardNo != null)
                        encryptedString.Append("&SwipeCard=" + Cryptographys.Cryptography.Encrypt(cardNo, encryptKey));
                    if (Convert.ToString(Designation) != null)
                        encryptedString.Append("&Designation=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(Designation), encryptKey));
                    if (Gender != null)
                        encryptedString.Append("&Gender=" + Cryptographys.Cryptography.Encrypt(Gender, encryptKey));


                    switch (reportName)
                    {
                        case "Absentees":
                            if (Convert.ToString(absentType) != null)
                                encryptedString.Append("&absentType=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(absentType), encryptKey));
                            if (Convert.ToString(Noofdays) != null)
                                encryptedString.Append("&NoofDays=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(Noofdays), encryptKey));
                            if (Convert.ToString(continuousAbsent) != null)
                                encryptedString.Append("&ContninuousLeave=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(continuousAbsent), encryptKey));
                            if (Convert.ToString(blnNormal) != null)
                                encryptedString.Append("&Normal=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(blnNormal), encryptKey));
                            if (Convert.ToString(blnNormal) != null)
                                encryptedString.Append("&ReportType=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(ReportType), encryptKey));
                            break;
                        case "LessHoursWorked":
                            if (SummaryOrDetail != null)
                                encryptedString.Append("&LessHoursWorked_SummaryOrDetail=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(SummaryOrDetail), encryptKey));
                            break;
                        case "Exception":
                        case "EarlyEntry":
                        case "LateExit":
                        case "LateEntry":
                        case "EarlyExit":
                            if (MinExceptHrs != null)
                                encryptedString.Append("&MinExceptHours=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(MinExceptHrs), encryptKey));
                            if (SummaryOrDetail != null)
                                encryptedString.Append("&summaryOrDetail=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(SummaryOrDetail), encryptKey));
                            break;
                        case "AllSwipes":
                        case "MatchedAllSwipes":
                            if (Intime != null)
                                encryptedString.Append("&Intime=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(Intime), encryptKey));
                            if (OutTime != null)
                                encryptedString.Append("&OutTime=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(OutTime), encryptKey));
                            if (Convert.ToString(AllSwipesReportType) != null)
                                encryptedString.Append("&AllSwipesReportType=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(AllSwipesReportType), encryptKey));
                            break;
                        case "DetailedAttendance":
                        case "Punctuality":
                        case "LeavePolicyNotAllocated":
                            if (Convert.ToString(blnNormal) != null)
                                encryptedString.Append("&Normal=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(blnNormal), encryptKey));
                            break;
                        case "MonthlyAttendance":
                        case "MonthlyAttendanceDetail":
                        case "DailyDeviation":
                            if (MinWorkHours != null)
                                encryptedString.Append("&MinWorkHours=" + Cryptographys.Cryptography.Encrypt(MinWorkHours, encryptKey));
                            if (SummaryOrDetail != null)
                                encryptedString.Append("&chksessionWise=" + Cryptographys.Cryptography.Encrypt(SummaryOrDetail, encryptKey));
                            break;
                        case "EmployeeInOut":
                            if (dtMonth != null)
                                encryptedString.Append("&dtMonth=" + Cryptographys.Cryptography.Encrypt(dtMonth, encryptKey));
                            if (dtYear != null)
                                encryptedString.Append("&dtYear=" + Cryptographys.Cryptography.Encrypt(dtYear, encryptKey));
                            if (mon != null)
                                encryptedString.Append("&mon=" + Cryptographys.Cryptography.Encrypt(mon, encryptKey));
                            if (ReportType != null)
                                encryptedString.Append("&ReportType=" + Cryptographys.Cryptography.Encrypt(ReportType, encryptKey));
                            break;
                        case "TotalDays":
                            if (Convert.ToString(NoOfDays) != null)
                                encryptedString.Append("&NoOfDays=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(NoOfDays), encryptKey));
                            if (TotalDays != null)
                                encryptedString.Append("&TotalDays=" + Cryptographys.Cryptography.Encrypt(TotalDays, encryptKey));
                            break;
                        case "SummaryReport":
                        case "DeviationWorkHours":
                        case "ForPayroll":
                        case "WeeklyWorkHours_Angler":
                            if (ReportType != null)
                                encryptedString.Append("&ReportType=" + Cryptographys.Cryptography.Encrypt(ReportType, encryptKey));
                            break;
                        case "RawData":
                        case "RawData_Latest":
                            if (Convert.ToString(RawDataDashboard) != null)
                                encryptedString.Append("&RawDataDashboard=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(RawDataDashboard), encryptKey));
                            if (ProcessType != null)
                                encryptedString.Append("&ProcessType=" + Cryptographys.Cryptography.Encrypt(ProcessType, encryptKey));
                            break;
                        case "WeeklyWorkHours":
                            if (ReportType != null)
                                encryptedString.Append("&ReportType=" + Cryptographys.Cryptography.Encrypt(ReportType, encryptKey));
                            break;
                        case "AuditTrail":
                            if (TableDescription != null)
                                encryptedString.Append("&TableDescription=" + Cryptographys.Cryptography.Encrypt(TableDescription, encryptKey));
                            if (Operation != null)
                                encryptedString.Append("&Operation=" + Cryptographys.Cryptography.Encrypt(Operation, encryptKey));
                            break;
                        case "EmployeeDetailedReport":
                            if (Convert.ToString(EmailAvail) != null)
                                encryptedString.Append("&EmailAvail=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(EmailAvail), encryptKey));
                            if (Convert.ToString(OTCompOff) != null)
                                encryptedString.Append("&OTCompOff=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(OTCompOff), encryptKey));
                            if (Convert.ToString(UserGroupID) != null)
                                encryptedString.Append("&UserGroupID=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(UserGroupID), encryptKey));
                            if (Convert.ToString(LeavePolicyID) != null)
                                encryptedString.Append("&LeavePolicyID=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(LeavePolicyID), encryptKey));
                            if (Convert.ToString(ReportingTo) != null)
                                encryptedString.Append("&ReportingTo=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(ReportingTo), encryptKey));
                            if (Convert.ToString(SanctionTo) != null)
                                encryptedString.Append("&SanctionTo=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(SanctionTo), encryptKey));
                            if (EmpStatus != null)
                                encryptedString.Append("&EmpStatus=" + Cryptographys.Cryptography.Encrypt(EmpStatus, encryptKey));
                            if (PageFilter != null)
                                encryptedString.Append("&PageFilter=" + Cryptographys.Cryptography.Encrypt(PageFilter, encryptKey));
                            break;
                        case "OverTime":
                            if (SanctionType != null)
                                encryptedString.Append("&SanctionType=" + Cryptographys.Cryptography.Encrypt(SanctionType, encryptKey));
                            if (Status != null)
                                encryptedString.Append("&Status=" + Cryptographys.Cryptography.Encrypt(Status, encryptKey));
                            break;
                        case "Leave":
                            if (YearSettingsId != null)
                                encryptedString.Append("&YearSettingsId=" + Cryptographys.Cryptography.Encrypt(YearSettingsId, encryptKey));
                            if (Convert.ToString(blnNormal) != null)
                                encryptedString.Append("&Normal=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(blnNormal), encryptKey));
                            if (Status != null)
                                encryptedString.Append("&Status=" + Cryptographys.Cryptography.Encrypt(Status, encryptKey));
                            if (LeaveType != null)
                                encryptedString.Append("&LeaveType=" + Cryptographys.Cryptography.Encrypt(LeaveType, encryptKey));
                            if (LeaveReportType != null)
                                encryptedString.Append("&LeaveReportType=" + Cryptographys.Cryptography.Encrypt(LeaveReportType, encryptKey));
                            break;
                        case "Permission":
                        case "OnDutyEntry":
                        case "ManualTimeEntry":
                            if (Status != null)
                                encryptedString.Append("&Status=" + Cryptographys.Cryptography.Encrypt(Status, encryptKey));
                            break;
                        case "MonthClosure":
                            if (MonthClosureId != null)
                                encryptedString.Append("&MonthClosureId=" + Cryptographys.Cryptography.Encrypt(MonthClosureId, encryptKey));
                            break;
                        case "YearClosure":
                            if (YearSettingsId != null)
                                encryptedString.Append("&YearSettingsId=" + Cryptographys.Cryptography.Encrypt(YearSettingsId, encryptKey));
                            break;
                        case "LeaveAnalysis":
                            if (strLeavePlanned != null)
                                encryptedString.Append("&strLeavePlanned=" + Cryptographys.Cryptography.Encrypt(strLeavePlanned, encryptKey));
                            if (strLeaveWI != null)
                                encryptedString.Append("&strLeaveWI=" + Cryptographys.Cryptography.Encrypt(strLeaveWI, encryptKey));
                            if (strLeaveWOI != null)
                                encryptedString.Append("&strLeaveWOI=" + Cryptographys.Cryptography.Encrypt(strLeaveWOI, encryptKey));
                            break;
                        case "InPunchDeviationHrs":
                            if (MaxDeviationHrs != null)
                                encryptedString.Append("&MaxDeviationHrs=" + Cryptographys.Cryptography.Encrypt(MaxDeviationHrs, encryptKey));
                            if (PunchType != null)
                                encryptedString.Append("&PunchType=" + Cryptographys.Cryptography.Encrypt(PunchType, encryptKey));
                            break;

                    }

                    if (navigatePage == "TA_UI_Report_Graphical_View.aspx" && rptHeaderName != null)
                        encryptedString.Append("&ReportHeaderName=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(rptHeaderName), encryptKey));

                    strScript.Append("<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>");
                    strScript.Append("<meta http-equiv='X-UA-Compatible' content='IE=edge' />");
                    strScript.Append("<script language='javascript'>");
                    strScript.Append("window.open('" + navigatePage + "?" + encryptedString + "','','left=10px, top=60px, width=1000px, height=600px, scrollbars=yes, status=no, resizable=yes');");
                    //strScript = strScript + "window.open('TA_UI_Report_ReportViewer.aspx?ReportName=" + Cryptographys.Cryptography.Encrypt(reportName, "TimecheckPhaseI") + "&dtFrom=" + Cryptographys.Cryptography.Encrypt(dtFromDate, "TimecheckPhaseI") + "&dtTo=" + Cryptographys.Cryptography.Encrypt(dtToDate, "TimecheckPhaseI") + "&empid=" + Cryptographys.Cryptography.Encrypt(empId, "TimecheckPhaseI") + "&shft=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(shift), "TimecheckPhaseI") + "&EmpName=" + Cryptographys.Cryptography.Encrypt(empName, "TimecheckPhaseI") + "&Level=" + Cryptographys.Cryptography.Encrypt(levId, "TimecheckPhaseI") + "&EmpCategory=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(employeeCategory), "TimecheckPhaseI") + "&EmpType=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(employeeType), "TimecheckPhaseI") + "&ParentLevelId=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(ParentId), "TimecheckPhaseI") + "&UserGroupName=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(userGroupName), "TimecheckPhaseI") + "&GradeLevel=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(gradeLevel), "TimecheckPhaseI") + "&Normal=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(blnNormal), "TimecheckPhaseI") + "&SwipeCard=" + Cryptographys.Cryptography.Encrypt(strSwipeCard, "TimecheckPhaseI") + "&Designation=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(Designation), "TimecheckPhaseI") + "&Gender=" + Cryptographys.Cryptography.Encrypt(Gender, "TimecheckPhaseI") + "&absentType=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(absentType), "TimecheckPhaseI") + "&NoofDays=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(Noofdays), "TimecheckPhaseI") + "&ContninuousLeave=" + Cryptographys.Cryptography.Encrypt(Convert.ToString(checkContinousLeave), "TimecheckPhaseI") + "','','left=10px, top=60px, width=1000px, height=600px, scrollbars=yes, status=no, resizable=yes');";
                    strScript.Append("</script>");
                    Response.Write(strScript);
                }
            }
        }

        public void ShowMessage_CloseWindow(string messageContent)
        {
            string strScript = "<script language='javascript' type='text/javascript'>";
            strScript += "alert('" + messageContent.Replace("'", " ").Replace("\n", "").Replace("\r", "") + "');window.close();";
            strScript += " </script>";
            this.RegisterStartupScript("setScript", strScript);
        }
        public void ExportToExcel(HSSFWorkbook workbook, string fileName)
        {
            using (MemoryStream memoryStream = new MemoryStream())
            {
                fileName = string.Format(fileName + "-{0:d}.xls", DateTime.Now).Replace("/", "-");
                workbook.Write(memoryStream);
                memoryStream.Flush();
                try
                {
                    HttpResponse response = HttpContext.Current.Response;
                    response.ClearContent();
                    response.ClearHeaders();
                    response.Buffer = true;
                    response.ContentType = "application/vnd.ms-excel";
                    response.AddHeader("Content-Length", memoryStream.Length.ToString());
                    response.AddHeader("Content-Disposition", string.Format("attachment;filename={0}", fileName));
                    response.BinaryWrite(memoryStream.GetBuffer());
                    response.Flush();
                    response.End();
                }
                catch
                {
                }
            }
        }
        protected void getStyles(HSSFWorkbook workbook, out HSSFCellStyle empDetailStyle, out HSSFCellStyle DetailStyle, out HSSFCellStyle MainStyle, out HSSFCellStyle fieldHeaderStyle, out HSSFCellStyle totalStyle)
        {
            #region objectCreation
            pageheaderFont = (HSSFFont)workbook.CreateFont();
            empDetailStyle = (HSSFCellStyle)workbook.CreateCellStyle();
            DetailStyle = (HSSFCellStyle)workbook.CreateCellStyle();
            MainStyle = (HSSFCellStyle)workbook.CreateCellStyle();
            fieldHeaderStyle = (HSSFCellStyle)workbook.CreateCellStyle();
            totalStyle = (HSSFCellStyle)workbook.CreateCellStyle();
            #endregion
            #region PageHeaderStyles
            pageheaderFont.Boldweight = (short)FontBoldWeight.Bold;
            pageheaderFont.Color = HSSFColor.Maroon.Index;
            pageheaderFont.FontHeightInPoints = 16;
            MainStyle.SetFont(pageheaderFont);
            MainStyle.Alignment = HorizontalAlignment.Center;
            #endregion
            #region EmpHeaderStyle
            empDetailStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
            empDetailStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
            empDetailStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
            empDetailStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
            empDetailStyle.Alignment = HorizontalAlignment.Center;
            empDetailStyle.VerticalAlignment = VerticalAlignment.Center;
            empDetailStyle.WrapText = true;
            empDetailStyle.FillPattern = FillPattern.SolidForeground;
            HSSFFont empheaderfont = (HSSFFont)workbook.CreateFont();
            empheaderfont.Boldweight = (short)FontBoldWeight.Bold;
            empheaderfont.Color = HSSFColor.Black.Index;
            empheaderfont.FontHeightInPoints = 12;
            empDetailStyle.SetFont(empheaderfont);
            #endregion
            #region fieldHeaderStyle
            fieldHeaderStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
            fieldHeaderStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
            fieldHeaderStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
            fieldHeaderStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
            fieldHeaderStyle.Alignment = HorizontalAlignment.Center;
            fieldHeaderStyle.VerticalAlignment = VerticalAlignment.Center;
            fieldHeaderStyle.FillForegroundColor = HSSFColor.Aqua.Index;
            fieldHeaderStyle.WrapText = true;
            fieldHeaderStyle.FillPattern = FillPattern.SolidForeground;
            HSSFFont h2font = (HSSFFont)workbook.CreateFont();
            h2font.Boldweight = (short)FontBoldWeight.Bold;
            h2font.Color = HSSFColor.White.Index;
            h2font.FontHeightInPoints = 10;
            fieldHeaderStyle.SetFont(h2font);
            #endregion
            #region DetailsStyle
            DetailStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
            DetailStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
            DetailStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
            DetailStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
            DetailStyle.VerticalAlignment = VerticalAlignment.Center;
            DetailStyle.Alignment = HorizontalAlignment.Center;
            #endregion
            #region TotalFieldStyle
            totalStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
            totalStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
            totalStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
            totalStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
            totalStyle.FillPattern = FillPattern.SolidForeground;
            totalStyle.VerticalAlignment = VerticalAlignment.Center;
            totalStyle.FillForegroundColor = HSSFColor.Grey25Percent.Index;
            HSSFFont h3font = (HSSFFont)workbook.CreateFont();
            h3font.Boldweight = (short)FontBoldWeight.Bold;
            h3font.FontHeightInPoints = 12;
            totalStyle.SetFont(h3font);
            #endregion
        }
        public void ExportToExcel(string sheetName, HSSFWorkbook workbook, DataTable dtlevelDetails, string reportHeader)
        {
            sheet = workbook.CreateSheet(sheetName);
            getStyles(workbook, out empDetailStyle, out DetailStyle, out MainStyle, out fieldHeaderStyle, out totalStyle);
            sheet.IsPrintGridlines = true;
            sheet.VerticallyCenter = true;
            row = sheet.CreateRow(rowIndex);
            if (dtlevelDetails.Rows.Count > 0)
            {
                row.CreateCell(0).SetCellValue(Convert.ToString(dtlevelDetails.Rows[0][0]));
                sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, 21));
                row.GetCell(0).CellStyle = MainStyle;
                rowIndex++;
                row = sheet.CreateRow(rowIndex);
            }
            row.CreateCell(0).SetCellValue(reportHeader);
            row.GetCell(0).CellStyle = MainStyle;
            sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, 21));
            rowIndex++;
            row = sheet.CreateRow(rowIndex);
            rowIndex++;
        }
        public void BindToolTip(DropDownList ddl)
        {
            foreach (ListItem item in ddl.Items)
            {
                if (item.Text == "Report_CountFactor_WorkingDays")
                    item.Text = "Count factor Working days";
                else
                    item.Attributes.Add("title", item.Text);
            }
        }
    }
}
