using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for OverTimeCodeEventData
/// </summary>
public class OverTimeCodeEventData
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    public DataSet SelectAllOtType(int iOtTypeID, string strAll, string strUserGroup, string strUserLevels, int parentLevelId)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectOtType", new object[] { iOtTypeID, strAll, strUserGroup, strUserLevels, parentLevelId });
        }
        catch (Exception ex)
        {            
            throw ex;
        }
        return ds;
    }
    public DataSet SelectOtTypeByID(int iOtTypeID, string strAll, string strUserGroup, string strUserLevels, int parentLevelId)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectOtType", new object[] { iOtTypeID, strAll, strUserGroup, strUserLevels, parentLevelId });
        }
        catch (Exception ex)
        {            
            throw ex;
        }
        return ds;
    }
    public DataSet CheckOtType(string OTType, string OTCategory, int CompanyID, int iOtTypeID, string strOpr)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckOtType", new object[] { OTType, OTCategory, CompanyID, iOtTypeID, strOpr });
        }
        catch (Exception ex)
        {            
            throw ex ;
        }
        return ds;
    }
    public void InsertOtType(string strOtType, string strOtTypeCat, int iCompanyID, Int32 iEmpID)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_InsertOtType", new object[] { strOtType, strOtTypeCat, iCompanyID, iEmpID });
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void UpdateOtType(int iOtTypeID, string strOtType, string strOtCat, int iCompanyID, Int32 iEmpID)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_UpdateOtType", new object[] { iOtTypeID, strOtType, strOtCat, iCompanyID, iEmpID });
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void DeleteOtType(int iOtTypeID, Int32 iEmpID)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_DeleteOtType", new object[] { iOtTypeID, iEmpID });
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void PremanentDeleteOtType(int iOtTypeID, Int32 iEmpID)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_PermanentDeleteOtType", new object[] { iOtTypeID, iEmpID });
        }
        catch (Exception ex)
        {            
            throw ex;
        }
    }
    public void RestoreOtType(int iOtTypeID, Int32 iEmpID)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_RstoreOtType", new object[] { iOtTypeID, iEmpID });
        }
        catch (Exception ex)
        {            
            throw ex;
        }
    }
    public OverTimeCodeEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
