using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;

/// <summary>
/// Summary description for PayrollConfiguration
/// </summary>
public class PayrollConfiguration_Angler
{
    Database objDataAccess = DatabaseFactory.CreateDatabase("DBConnection");

    public PayrollConfiguration_Angler()
	{
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
	}

    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = objDataAccess.DbProviderFactory;
        objDataAccess = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }

    public int InsertPayrollConfiguration_Armis(Int16 StartTime1, Int16 EndTime1, Decimal Day1, Int16 StartTime2, Int16 EndTime2, Decimal Day2,
        Int16 StartTime3, Int16 EndTime3, Decimal Day3,Int16 StartTime4, Int16 EndTime4, Decimal Day4,Int16 StartTime5, Int16 EndTime5, Decimal Day5)
    {
        int ArmisSetting = 0;
        DbCommand cmd_InsertArmis = objDataAccess.GetStoredProcCommand("Proc_TA_InsertUpdatePayrollConfig_Armis", new object[] { StartTime1, EndTime1, Day1, 
            StartTime2, EndTime2, Day2, StartTime3, EndTime3, Day3, StartTime4, EndTime4,  Day4, StartTime5, EndTime5, Day5 });
        try
        {
            ArmisSetting = Convert.ToInt32(objDataAccess.ExecuteScalar(cmd_InsertArmis));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ArmisSetting;
    }

    public int InsertPayrollConfiguration_LateEntry(Int16 StartTime1, Int16 EndTime1, Decimal Day1, Int16 StartTime2, Int16 EndTime2, Decimal Day2,
       Int16 StartTime3, Int16 EndTime3, Decimal Day3, Int16 StartTime4, Int16 EndTime4, Decimal Day4, Int16 StartTime5, Int16 EndTime5, Decimal Day5, Int16 StartTime6, Int16 EndTime6, Decimal Day6)
    {
        int LateEntrySetting = 0;
        DbCommand cmd_InsertLateEntry = objDataAccess.GetStoredProcCommand("Proc_TA_InsertUpdatePayrollConfig_LateEntry", new object[] { StartTime1, EndTime1, Day1, 
            StartTime2, EndTime2, Day2, StartTime3, EndTime3, Day3, StartTime4, EndTime4,  Day4, StartTime5, EndTime5, Day5, StartTime6, EndTime6, Day6 });
        try
        {
            LateEntrySetting = Convert.ToInt32(objDataAccess.ExecuteScalar(cmd_InsertLateEntry));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return LateEntrySetting;
    }

    public int InsertPayrollConfiguration_WorkHours(Int16 StartTime1, Int16 EndTime1, Decimal Day1, Int16 StartTime2, Int16 EndTime2, Decimal Day2,
       Int16 StartTime3, Int16 EndTime3, Decimal Day3, Int16 StartTime4, Int16 EndTime4, Decimal Day4, Int16 StartTime5, Int16 EndTime5, Decimal Day5, Int16 StartTime6, Int16 EndTime6, Decimal Day6)
    {
        int WorkHoursSetting = 0;
        DbCommand cmd_InsertWorkHours = objDataAccess.GetStoredProcCommand("Proc_TA_InsertUpdatePayrollConfig_WorkHours", new object[] { StartTime1, EndTime1, Day1, 
            StartTime2, EndTime2, Day2, StartTime3, EndTime3, Day3, StartTime4, EndTime4,  Day4, StartTime5, EndTime5, Day5, StartTime6, EndTime6, Day6 });
        try
        {
            WorkHoursSetting = Convert.ToInt32(objDataAccess.ExecuteScalar(cmd_InsertWorkHours));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return WorkHoursSetting;
    }

    public DataSet GetConfigurationDetails()
    {
        DataSet dsConfigurationDetails = new DataSet();

        try
        {
            dsConfigurationDetails = objDataAccess.ExecuteDataSet("Proc_TA_GetPayrollConfigurationDetails", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsConfigurationDetails;
    }
}
