using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for ShiftRoasterEventData
/// </summary>
public class ShiftRoasterEventData
{
    Database dbCon = DatabaseFactory.CreateDatabase("DBConnection");
    int count;
    public DataSet SelectShiftRoaster(string usergroupname, string UserLevels, int parentLevelId)
    {
        DataSet ds_SelectShiftRoaster = new DataSet();
        try
        {
            ds_SelectShiftRoaster = dbCon.ExecuteDataSet("Proc_TA_SelectShiftRoaster", new object[] { usergroupname, UserLevels, parentLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_SelectShiftRoaster;
    }
    public DataSet GetShiftRoasterDetails(string UserGroupName, int ParentLevelId)
    {
        DataSet ds_SelectShiftRoaster = new DataSet();
        try
        {
            ds_SelectShiftRoaster = dbCon.ExecuteDataSet("Proc_TA_GetShiftRoasterDetails", new object[] { UserGroupName, ParentLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_SelectShiftRoaster;
    }
    public DataSet GetShiftRoasterDetailsById(int RoasterId)
    {
        DataSet ds_SelectShiftRoaster = new DataSet();
        try
        {
            ds_SelectShiftRoaster = dbCon.ExecuteDataSet("Proc_TA_GetShiftRoasterDetailsById", new object[] { RoasterId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_SelectShiftRoaster;
    }
    public DataSet SelectShiftRoasterById(int RoasterId)
    {
        DataSet ds_ShiftRoasterById = new DataSet();
        try
        {
            ds_ShiftRoasterById = dbCon.ExecuteDataSet("Proc_TA_SelectShiftRoasterById", new object[] { RoasterId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftRoasterById;
    }
    public DataSet SelectShiftPattern(string UserGroupName, string UserLevels, int ParentId)
    {
        DataSet ds_ShiftPattern = new DataSet();
        try
        {
            ds_ShiftPattern = dbCon.ExecuteDataSet("Proc_TA_SelectShiftPattern", new object[] { UserGroupName, UserLevels, ParentId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftPattern;
    }
    public int CheckShiftRoasterName(int companyId, string RoasterName)
    {
        DataSet ds_CheckRoasterName = new DataSet();
        try
        {
            ds_CheckRoasterName = dbCon.ExecuteDataSet("Proc_TA_CheckProcName", new object[] { companyId, RoasterName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        if (ds_CheckRoasterName.Tables[0].Rows.Count > 0)
        {
            count = Convert.ToInt32(ds_CheckRoasterName.Tables[0].Rows[0][0]);
        }
        return count;
    }
    public int CheckShiftRoasterNameUpdate(int companyId, string RoasterName, int RoasterId)
    {
        DataSet ds_CheckRoasterName = new DataSet();
        try
        {
            ds_CheckRoasterName = dbCon.ExecuteDataSet("Proc_TA_CheckProcNameUpdate", new object[] { companyId, RoasterName, RoasterId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        if (ds_CheckRoasterName.Tables[0].Rows.Count > 0)
        {
            count = Convert.ToInt16(ds_CheckRoasterName.Tables[0].Rows[0][0]);
        }
        return count;
    }
    public void InsertShiftRoaster(int companyId, string ShiftRoastername, int NumberofPatterns, int Pattern1Id, int Pattern2Id, int Pattern3Id, int Pattern4Id, int Pattern5Id, int Pattern6Id,
                                   int Pattern7Id, int Pattern8Id, int Pattern9Id, int Pattern10Id, string EmpId)
    {
        try
        {
            DbCommand cmd_Insert = dbCon.GetStoredProcCommand("Proc_TA_InsertShiftRoaster", new object[] {companyId, ShiftRoastername, NumberofPatterns, Pattern1Id, Pattern2Id,
                                                               Pattern3Id,Pattern4Id,Pattern5Id,Pattern6Id,Pattern7Id,Pattern8Id,Pattern9Id,Pattern10Id,EmpId});
            cmd_Insert.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void DeleteShiftRoaster(int RoasterId)
    {
        try
        {
            DbCommand cmd_delete = dbCon.GetStoredProcCommand("Proc_TA_DeleteShiftRoaster", new object[] { RoasterId });
            cmd_delete.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_delete);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void UpdateShiftRoaster(int companyId, int RoasterId, string ShiftRoastername, int NumberofPatterns, int Pattern1Id, int Pattern2Id, int Pattern3Id, int Pattern4Id, int Pattern5Id, int Pattern6Id,
                                   int Pattern7Id, int Pattern8Id, int Pattern9Id, int Pattern10Id, string EmpId)
    {
        try
        {
            DbCommand cmd_UpdateShiftRoaster = dbCon.GetStoredProcCommand("Proc_TA_UpdateShiftRoaster", new object[] {companyId, RoasterId,ShiftRoastername,NumberofPatterns,Pattern1Id,Pattern2Id,Pattern3Id,Pattern4Id,
                                                                         Pattern5Id,Pattern6Id,Pattern7Id,Pattern8Id,Pattern9Id,Pattern10Id,EmpId});
            cmd_UpdateShiftRoaster.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_UpdateShiftRoaster);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void DeleteShiftRoaster(string ShiftRoasterIds, bool DeleteType)
    {
        try
        {
            DbCommand cmd_DeleteEntranceDetails = dbCon.GetStoredProcCommand("Proc_TA_DeleteShiftRoasterDetails", new object[] { ShiftRoasterIds, DeleteType });
            cmd_DeleteEntranceDetails.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_DeleteEntranceDetails);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet RestoreShiftRoaster(string ShiftRoasterIds)
    {
        DataSet dst = new DataSet();
        try
        {
            DbCommand cmd = dbCon.GetStoredProcCommand("Proc_TA_RestoreShiftRoster", new object[] { ShiftRoasterIds });
            cmd.CommandTimeout = 0;
            dst = dbCon.ExecuteDataSet(cmd);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dst;
    }
    public void UpdateShiftRoaster_AfterInsert(int EmpID, int year, int month, int Day1Shift, int Day2Shift, int Day3Shift, int Day4Shift, int Day5Shift, int Day6Shift, int Day7Shift, int Day8Shift, int Day9Shift, int Day10Shift, int Day11Shift, int Day12Shift, int Day13Shift, int Day14Shift, int Day15Shift, int Day16Shift, int Day17Shift, int Day18Shift, int Day19Shift, int Day20Shift, int Day21Shift, int Day22Shift, int Day23Shift, int Day24Shift, int Day25Shift, int Day26Shift, int Day27Shift, int Day28Shift, int Day29Shift, int Day30Shift, int Day31Shift)
    {
        try
        {
            DbCommand cmd_Update = dbCon.GetStoredProcCommand("temp_UpdatePerShiftAllocation", new object[34] { EmpID, year, month, Day1Shift, Day2Shift, Day3Shift, Day4Shift, Day5Shift, Day6Shift, Day7Shift, Day8Shift, Day9Shift, Day10Shift, Day11Shift, Day12Shift, Day13Shift, Day14Shift, Day15Shift, Day16Shift, Day17Shift, Day18Shift, Day19Shift, Day20Shift, Day21Shift, Day22Shift, Day23Shift, Day24Shift, Day25Shift, Day26Shift, Day27Shift, Day28Shift, Day29Shift, Day30Shift, Day31Shift });
            cmd_Update.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_Update);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void UpdateTempShiftAllocation_AfterInsert(int EmpID, int year, int month, int Day1Shift, int Day2Shift, int Day3Shift, int Day4Shift, int Day5Shift, int Day6Shift, int Day7Shift, int Day8Shift, int Day9Shift, int Day10Shift, int Day11Shift, int Day12Shift, int Day13Shift, int Day14Shift, int Day15Shift, int Day16Shift, int Day17Shift, int Day18Shift, int Day19Shift, int Day20Shift, int Day21Shift, int Day22Shift, int Day23Shift, int Day24Shift, int Day25Shift, int Day26Shift, int Day27Shift, int Day28Shift, int Day29Shift, int Day30Shift, int Day31Shift)
    {
        try
        {
            DbCommand cmd_Update = dbCon.GetStoredProcCommand("Proc_TA_UpdatePerShiftAllocation", new object[34] { EmpID, year, month, Day1Shift, Day2Shift, Day3Shift, Day4Shift, Day5Shift, Day6Shift, Day7Shift, Day8Shift, Day9Shift, Day10Shift, Day11Shift, Day12Shift, Day13Shift, Day14Shift, Day15Shift, Day16Shift, Day17Shift, Day18Shift, Day19Shift, Day20Shift, Day21Shift, Day22Shift, Day23Shift, Day24Shift, Day25Shift, Day26Shift, Day27Shift, Day28Shift, Day29Shift, Day30Shift, Day31Shift });
            cmd_Update.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_Update);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet SelectShiftPatternForShiftRoster(int companyId)
    {
        DataSet ds_ShiftPattern = new DataSet();
        try
        {
            ds_ShiftPattern = dbCon.ExecuteDataSet("Proc_TA_SelectShiftPatternForShiftRoster", new object[] { companyId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftPattern;
    }
    public ShiftRoasterEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = dbCon.DbProviderFactory;
        dbCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
