using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Data.OleDb;
/// <summary>
/// Summary description for TerminalEventData
/// </summary>
///
public class TerminalEventData
{
    //creating DB connection
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    OleDbConnection connRdbms;
    //creating Datasets
    DataSet ds_TerminalDetails = new DataSet();
    DataSet ds_TerminalMappingDetails = new DataSet();
    //int count;
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    //select all Terminal details
    public DataSet SelectTerminalDetails(string strUserGroupName)
    {
        try
        {
            ds_TerminalDetails = DBCon.ExecuteDataSet("Proc_TA_SelectTerminalDetails", new object[] { 'A', 0, strUserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TerminalDetails;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    //select all Terminal details for Entrance
    public DataSet SelectTerminalDetailsForEntrance(string Type, int EntranceId)
    {
        try
        {
            ds_TerminalDetails = DBCon.ExecuteDataSet("Proc_TA_SelectTerminalDetailsForEntrance", new object[] { Type, EntranceId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TerminalDetails;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public void SelectReaderBasicInfo(string strConnection)
    {
        DataSet ds_TerminalDatatype = new DataSet();
        try
        {
            DbCommand cmd_Insert = DBCon.GetStoredProcCommand("PROC_TA_SelectReaderBasicInfo_New", new object[] { strConnection });
            cmd_Insert.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Get Device data from MDB database Created by Karthikeyan.R on 05-Mar-2016
    public void InitializeRDBMSConnection(string strConnectionString)
    {
        try
        {
            connRdbms = new OleDbConnection(strConnectionString);
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void OpenOledbCon(OleDbConnection ConnOleDbOpen)
    {
        if (ConnOleDbOpen.State == ConnectionState.Closed)
        {
            ConnOleDbOpen.Open();
        }
    }
    public DataTable rdbmsExecuteQuery(string SqlQuery, string tableName)
    {
        try
        {
            OleDbDataAdapter myAdapter = new OleDbDataAdapter(SqlQuery, connRdbms);
            DataSet dsData = new DataSet();
            myAdapter.Fill(dsData, tableName);
            dsData.Tables[0].TableName = tableName;
            myAdapter.Dispose();
            return dsData.Tables[0];
        }
        catch (Exception ex)
        {
            throw ex;
        }
        finally
        {
            if (connRdbms.State == ConnectionState.Open)
            {
                connRdbms.Close();
                connRdbms.Dispose();
            }
        }
    }
    //check for duplicate terminal name
    public int Check_duplicateReaderID(string TerminalReaderId)
    {
        int count;
        try
        {
            DbCommand cmdDVEmployeeCreation = DBCon.GetStoredProcCommand("Proc_TA_CheckTerminalName_Sync", new object[] { TerminalReaderId });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            count = Convert.ToInt32(DBCon.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //End
    //select Terminal details based on ID
    public DataSet SelectTerminalDetailsBYId(int TerminalId, string UserGroupName)
    {
        try
        {
            ds_TerminalDetails = DBCon.ExecuteDataSet("Proc_TA_SelectTerminalDetails", new object[] { 'P', TerminalId, UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TerminalDetails;
    }
    //select Terminal details based on ID for view
    public DataSet SelectTerminalDetailsBYIdView(int TerminalId)
    {
        try
        {
            ds_TerminalDetails = DBCon.ExecuteDataSet("Proc_TA_Select_TerminalforView", new object[] { TerminalId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TerminalDetails;
    }
    //select all Raw Data Formats
    public DataSet SelectRawDataFormats()
    {
        DataSet ds_RawDataFormats = new DataSet();
        try
        {
            ds_RawDataFormats = DBCon.ExecuteDataSet("Proc_TA_SelectRawDataFormats", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_RawDataFormats;
    }
    //insert Terminal details
    public void InsertTerminalDetails(string Terminal_ReaderID, string TerminalName, string TerminalDescription, int RawDataFormat, int Emp_Id)
    {
        try
        {
            DbCommand cmd_InsertTerminal = DBCon.GetStoredProcCommand("Proc_TA_InsertTerminalDetails", new object[] { 'I', 0, Terminal_ReaderID, TerminalName, TerminalDescription, RawDataFormat, Emp_Id });
            cmd_InsertTerminal.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_InsertTerminal);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update Terminal details
    public void UpdateTerminalDetails(int TerminalID, string TerminalReaderID, string TerminalName, string TerminalDescription, int RawDataFormat, int Emp_Id)
    {
        try
        {
            DbCommand cmd_updateTerminal = DBCon.GetStoredProcCommand("Proc_TA_InsertTerminalDetails", new object[] { 'U', TerminalID, TerminalReaderID, TerminalName, TerminalDescription, RawDataFormat, Emp_Id });
            cmd_updateTerminal.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_updateTerminal);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // In Activating Terminal details
    public void DeleteTerminals(string Terminals, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteTerminal = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreTerminal", new object[] { "TemporaryDelete", Terminals, auditEmpId });
            cmd_DeleteTerminal.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteTerminal);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Permanently Deleting Terminal details
    public void PermanentDeleteTerminals(string Terminals, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteTerminal = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreTerminal", new object[] { "PermanentDelete", Terminals, auditEmpId });
            cmd_DeleteTerminal.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteTerminal);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Check for Duplicate Record while Restoring
    public int CheckRestoreTerminal(int TerminalID)
    {
        int Count;
        DataSet ds_GetTerminalCount = new DataSet();
        try
        {
            DbCommand cmdDVEmployeeCreation = DBCon.GetStoredProcCommand("Proc_TA_CheckRestoreTerminal", new object[] { TerminalID });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            Count = Convert.ToInt32(DBCon.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    // Restoring Terminal details
    public void RestoreTerminals(string Terminals, int auditEmpId)
    {
        try
        {
            DbCommand cmd_RestoreTerminal = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreTerminal", new object[] { "Restore", Terminals, auditEmpId });
            cmd_RestoreTerminal.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_RestoreTerminal);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //check for duplicate terminal name
    public int Check_duplicateTerminal(string TerminalReaderId, string TerminalName)
    {
        int count;
        try
        {
            DbCommand cmdDVEmployeeCreation = DBCon.GetStoredProcCommand("Proc_TA_CheckTerminalName", new object[] { TerminalReaderId, TerminalName });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            count = Convert.ToInt32(DBCon.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //check for duplicate terminal name update
    public int Check_duplicateTerminalupdate(int terID, string TerminalReaderID, string TerminalName)
    {
        int count;
        try
        {
            DbCommand cmdDVEmployeeCreation = DBCon.GetStoredProcCommand("Proc_TA_CheckTerminalNameUpdate", new object[] { terID, TerminalReaderID, TerminalName });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            count = Convert.ToInt32(DBCon.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int CheckTerminalDatatype(string TerminalDataType)
    {
        int Count;
        try
        {
            DbCommand cmdDVEmployeeCreation = DBCon.GetStoredProcCommand("Proc_TA_CheckRawFormat", new object[] { TerminalDataType });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            Count = Convert.ToInt32(DBCon.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    //Get count for the given Terminal Data Type Id
    public int GetCountTerminal(int TerminalID, string UserGroupName)
    {
        int Count;
        try
        {
            DbCommand cmdDVEmployeeCreation = DBCon.GetStoredProcCommand("Proc_TA_SelectTerminalDetails", new object[] { 'C', TerminalID, UserGroupName });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            Count = Convert.ToInt32(DBCon.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    public int GetCountTerminalForPermanentDelete(int TerminalID, string UserGroupName)
    {
        int Count;
        try
        {
            DbCommand cmdDVEmployeeCreation = DBCon.GetStoredProcCommand("Proc_TA_SelectTerminalDetailsForPermanentDelete", new object[] { 'C', TerminalID, UserGroupName });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            Count = Convert.ToInt32(DBCon.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    //Get Entrance Count to the given Terminal Id
    public int GetTerminalMappingCount(int TerminalID)
    {
        int Count;
        try
        {
            DbCommand cmdDVEmployeeCreation = DBCon.GetStoredProcCommand("Proc_TA_GetTerminalMappingCount", new object[] { TerminalID });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            Count = Convert.ToInt32(DBCon.ExecuteScalar(cmdDVEmployeeCreation));            
        }
        catch (Exception Ex)
        {
            throw Ex;
        }        
        return Count;
    }
    public TerminalEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
