using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for TypeEventData
/// </summary>
public class TypeEventData
{
    //creating DB connection
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    //Delete Type
    public void DeleteType(string TypeID, int EmpID)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_DeleteType", new object[] { TypeID, EmpID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Delete Permanent Type
    public void DeletePermanentType(string TypeID, int EmpID)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_DeletePermanentType", new object[] { TypeID, EmpID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Delete Permanent Type
    public void RestoreType(string TypeID, int EmpID)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_RestoreType", new object[] { TypeID, EmpID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Check for delete
    public DataSet CheckForDelete(int TypeID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckTypeDelete", new object[] { TypeID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Select Type
    public DataSet SelectType(int TypeID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectType", new object[] { TypeID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Select All Type
    public DataSet SelectAllType(string UserType)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectAllType", new object[] { UserType });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Check duplicate for update or insert
    public DataSet CheckDuplicate(string Opr, string TypeName, int TypeID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckTypeDuplicate", new object[] { Opr, TypeName, TypeID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet CheckDuplicate(string Opr, int TypeID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckTypeDuplicateForRestore", new object[] { Opr, TypeID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Insert or update Type
    public void InsertUpdate(string Opr, string Type, string EmpID, int TypeID, bool IsFlexible)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_InsertUpdateType", new object[] { Opr, Type, EmpID, TypeID, IsFlexible });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public TypeEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
