using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
public class cls_Master_Title
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    DataSet ds_TitleDetails = new DataSet();
    int count;
    /// <summary>
    /// select Title details for grid
    /// </summary>
    /// <param name="UserGroupName"></param>
    /// <param name="Designation"></param>
    /// <returns></returns>
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectTitleFirstDetails(string UserGroupName, string Designation)
    {
        try
        {
            DbCommand cmd_InsertTitle = DBCon.GetStoredProcCommand("Proc_TA_GetTitleDetails", new object[] { UserGroupName, Designation });
            cmd_InsertTitle.CommandTimeout = 0;
            ds_TitleDetails = DBCon.ExecuteDataSet(cmd_InsertTitle);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TitleDetails;
    }
    /// <summary>
    /// select Title details for view/modify
    /// </summary>
    /// <param name="Titleid"></param>
    /// <param name="UserGroupName"></param>
    /// <returns></returns>
    public DataSet SelectTitleFirstDetailsById(int Titleid, string UserGroupName)
    {
        try
        {
            DbCommand cmd_InsertTitle = DBCon.GetStoredProcCommand("Proc_TA_GetTitleFirstDetailsById", new object[] { Titleid, UserGroupName });
            cmd_InsertTitle.CommandTimeout = 0;
            ds_TitleDetails = DBCon.ExecuteDataSet(cmd_InsertTitle);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TitleDetails;
    }
    /// <summary>
    /// insert Title details
    /// </summary>
    /// <param name="TitleName"></param>
    /// <param name="TitleDescription"></param>
    /// <param name="LevelID"></param>
    /// <param name="PolicyID"></param>
    /// <param name="GradeID"></param>
    /// <param name="EmpID"></param>
    public int InsertTitleFirstDetails(string TitleName, string TitleDescription, int LevelID, int PolicyID, int GradeID, int EmpID)
    {
        int designationID = 0;
        try
        {
            DbCommand cmd_InsertTitle = DBCon.GetStoredProcCommand("Proc_TA_Insert_TitleFirstDetails", new object[] { TitleName, TitleDescription, LevelID, PolicyID, GradeID, EmpID });
            cmd_InsertTitle.CommandTimeout = 0;
            //designationID = (int)DBCon.ExecuteScalar(cmd_InsertTitle);
            DBCon.ExecuteNonQuery(cmd_InsertTitle);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return designationID;
    }
    /// <summary>
    /// update Title details
    /// </summary>
    /// <param name="TitleName"></param>
    /// <param name="TitleDescription"></param>
    /// <param name="LevelID"></param>
    /// <param name="PolicyID"></param>
    /// <param name="GradeID"></param>
    /// <param name="EmpID"></param>
    /// <param name="TitleId"></param>
    public void UpdateTitleFirstDetails(string TitleName, string TitleDescription, int LevelID, int PolicyID, int GradeID, int EmpID, int TitleId)
    {
        try
        {
            DbCommand cmd_UpdateTitle = DBCon.GetStoredProcCommand("Proc_Update_TA_TBL_TitleFirst", new object[] { TitleName, TitleDescription, LevelID, PolicyID, GradeID, EmpID, TitleId });
            cmd_UpdateTitle.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_UpdateTitle);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    /// In Activating the Designation Details
    /// </summary>
    /// <param name="TitleIds"></param>
    /// <param name="auditEmpId"></param>
    public void DeleteTitles(string TitleIds, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteTitles = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreTitle", new object[] { "TemporaryDelete", TitleIds, auditEmpId });
            cmd_DeleteTitles.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteTitles);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    //// Permanently Deleting the Designation Details
    /// </summary>
    /// <param name="TitleIds"></param>
    /// <param name="auditEmpId"></param>
    public void PermanentDeleteTitles(string TitleIds, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteTitles = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreTitle", new object[] { "PermanentDelete", TitleIds, auditEmpId });
            cmd_DeleteTitles.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteTitles);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    /// Restoring the Designation Details
    /// </summary>
    /// <param name="TitleIds"></param>
    /// <param name="auditEmpId"></param>
    public void RestoreTitles(string TitleIds, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteTitles = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreTitle", new object[] { "Restore", TitleIds, auditEmpId });
            cmd_DeleteTitles.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteTitles);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    public int CheckDesignation()
    {
        DataSet ds_CheckID = new DataSet();
        try
        {
            ds_CheckID = DBCon.ExecuteDataSet("Proc_TA_GetDesignationID");
            count = Convert.ToInt32(ds_CheckID.Tables[0].Rows[0]["TitleId"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }

    /// <summary>
    /// Check for already existing Title while update
    /// </summary>
    /// <param name="TitleId"></param>
    /// <returns></returns>
    public int CheckTitleName_Update(int TitleId)
    {
        DataSet ds_CheckTitle = new DataSet();
        try
        {
            ds_CheckTitle = DBCon.ExecuteDataSet("Proc_TA_CheckTitle_Update", new object[] { TitleId });
            count = Convert.ToInt32(ds_CheckTitle.Tables[0].Rows[0]["TName"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    /// <summary>
    /// Adding LevelId param by MAnjula.P on 06-Jan-2014 for levelid in designation
    /// check for already existing Title while insert
    /// </summary>
    /// <param name="TitleName"></param>
    /// <param name="LevelId"></param>
    /// <returns></returns>
    public int CheckTilteName_Insert(string TitleName, int LevelId)
    {
        DataSet ds_CheckTitle = new DataSet();
        try
        {
            ds_CheckTitle = DBCon.ExecuteDataSet("Proc_TA_CheckTitle_Insert", new object[] { TitleName, LevelId });
            count = Convert.ToInt32(ds_CheckTitle.Tables[0].Rows[0]["TName"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    /// <summary>
    /// Adding LevelId param by MAnjula.P on 06-Jan-2014 for levelid in designation
    /// </summary>
    /// <param name="TitleName"></param>
    /// <param name="titleID"></param>
    /// <param name="LevelId"></param>
    /// <returns></returns>
    public int CheckTilteName_Updates(string TitleName, int titleID, int LevelId)
    {
        DataSet ds_CheckTitle = new DataSet();
        try
        {
            ds_CheckTitle = DBCon.ExecuteDataSet("Proc_TA_CheckTitle_Updates", new object[] { TitleName, titleID, LevelId });
            count = Convert.ToInt32(ds_CheckTitle.Tables[0].Rows[0]["TName"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    /// <summary>
    /// select all Grades
    /// </summary>
    /// <param name="userGroupName"></param>
    /// <returns></returns>
    public DataSet SelectGrades(string userGroupName)
    {
        DataSet ds_Grades = new DataSet();
        try
        {
            ds_Grades = DBCon.ExecuteDataSet("Proc_TA_SelectGrades", new object[] { 'A', 0, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Grades;
    }
    /// <summary>
    /// select Grades details for standard
    /// </summary>
    /// <param name="userGroupName"></param>
    /// <returns></returns>
    public DataSet SelectGradesStandard(string userGroupName)
    {
        DataSet ds_Grades = new DataSet();
        try
        {
            ds_Grades = DBCon.ExecuteDataSet("Proc_TA_SelectGradesStandard", new object[] { 'A', 0, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Grades;
    }
    /// <summary>
    /// Restoring the Designation Details
    /// </summary>
    public void CheckGradeNamesStandard()
    {
        try
        {
            DbCommand cmd_CheckGradeNamesStandard = DBCon.GetStoredProcCommand("Proc_TA_CheckGradeStandard", new object[] { });
            cmd_CheckGradeNamesStandard.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_CheckGradeNamesStandard);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    /// checking for mapping of designation in Employee
    /// </summary>
    /// <param name="Title"></param>
    /// <returns></returns>
    public int CountTitle(int Title)
    {
        int count = 0;
        try
        {
            count = Convert.ToInt32(DBCon.ExecuteScalar("Proc_TA_CountTitle", Title));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public cls_Master_Title()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
