using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using System.Diagnostics;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for userRightsEventData
/// </summary>
public class userRightsEventData
{
    // creating Database connection
    Database DBCon = DatabaseFactory.CreateDatabase("DbConnection");
    // insert user rights with required information
    public void insertUserRights(int groupId, int pageId, int pageGroup, int addPrv, int modifyPrv, int deletePrv, int viewPrv, int employeeId)
    {
        try
        {
            DbCommand cmd_InsertRights = DBCon.GetStoredProcCommand("Proc_TA_userRightsInsert", new object[] { groupId, pageId, pageGroup, addPrv, modifyPrv, deletePrv, viewPrv, employeeId });
            cmd_InsertRights.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_InsertRights);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // get existing user rights status from database for respective user grtoups
    public DataSet getUserRights(int groupId)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_GetUserRights", new object[] { groupId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // get all user groups from database
    public DataSet getUserGroups()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_Ta_getUserGroups");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // check user group duplication while inserting
    public DataSet checkDuplication(string groupname)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_checkDuplicationUsergroup", new object[] { groupname });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // insert user group name with required data

    public void insertUserGroup(string opr, int groupId, string groupName, int isdel, int IndividualUsers, int SpecialRights, string emp_id, DateTime tim, int ReportsBasedOn, int AllowLeaveApprovalPastEntry)
    {
        DbCommand cmd_InsertGroup = DBCon.GetStoredProcCommand("Proc_TA_InsertUserName", new object[] { opr, groupId, groupName, isdel, IndividualUsers, SpecialRights, emp_id, tim, ReportsBasedOn, AllowLeaveApprovalPastEntry });
        try
        {
            DBCon.ExecuteNonQuery(cmd_InsertGroup);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // get user group name by UserGroupId
    public DataSet getUserGroupNameById(int groupId)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_getGroupNameById", new object[] { groupId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // select user groups
    public DataSet selectUserGroup(string GroupName)
    {
        if (GroupName == null)
        {
            GroupName = "";
        }
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_getUserGroups", new object[] { GroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // select user group name
    public string selectUserGroupName(int GroupId)
    {
        string strGroupName = string.Empty;
        try
        {
            strGroupName = DBCon.ExecuteScalar("Proc_TA_getUserGroupName", new object[] { GroupId }).ToString();
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return strGroupName;
    }
    // check user group while deleting
    public DataSet CheckUserGroupForDel(int groupId, string opr)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_delUserGroup ", new object[] { groupId, opr });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // delete user group
    public void DelUserGroup(int groupId, string opr)
    {
        try
        {
            DbCommand cmdDelGroup = DBCon.GetStoredProcCommand("Proc_TA_delUserGroup ", new object[] { groupId, opr });
            cmdDelGroup.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmdDelGroup);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // get page name for all modules
    public DataSet GetPageName(string strType)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_GetPageName", new object[] { strType });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet GetChildMenus(int pageid)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_GetChildMenu", new object[] { pageid });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void InsertLevelRights(int GroupID, string LevelID, string EmpID)
    {
        try
        {
            DbCommand cmd = DBCon.GetStoredProcCommand("Proc_TA_InsertLevelWiseRights", new object[] { GroupID, LevelID, EmpID });
            cmd.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // delete levelwise rights
    public void DeleteLevelWiseRights(int groupId)
    {
        try
        {
            DbCommand cmdDeleteLevelWiseRights = DBCon.GetStoredProcCommand("Proc_TA_DeleteLevelWiseRights ", new object[] { groupId });
            cmdDeleteLevelWiseRights.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmdDeleteLevelWiseRights);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Insert into TA_Tbl_LevelRights
    public void InsertInto_TATblLevelRights(DataTable dtLevelRights)
    {
        try
        {
            string strDecryptedString = string.Empty;
            strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
            SqlBulkCopy sbcLevelRights = new SqlBulkCopy(strDecryptedString, SqlBulkCopyOptions.TableLock);
            sbcLevelRights.DestinationTableName = "TA_Tbl_LevelRights";
            sbcLevelRights.ColumnMappings.Clear();
            foreach (DataColumn dcColumn in dtLevelRights.Columns)
            {
                sbcLevelRights.ColumnMappings.Add(new SqlBulkCopyColumnMapping(dcColumn.ColumnName, dcColumn.ColumnName));
            }
            Stopwatch sw = new Stopwatch();
            sw.Start();
            sbcLevelRights.WriteToServer(dtLevelRights);
            sw.Stop();
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet InsertAddWeeklyOff(string AdditionalWeekOffDay, string AdditionalWeekOffWeek, int EmpId, string Xmldata, int AddWeekOffId)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_InsertAddtionalWeeklyOffLevels", new object[] { AdditionalWeekOffDay, AdditionalWeekOffWeek, EmpId, Xmldata, AddWeekOffId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet SelectLevelRights(int GroupID)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmd_InsertRights = DBCon.GetStoredProcCommand("Proc_TA_SelectLevelRights", new object[] { GroupID });
            cmd_InsertRights.CommandTimeout = 0;
            ds = DBCon.ExecuteDataSet(cmd_InsertRights);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public userRightsEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public DataSet SelectDashboardRights(int usergroupID)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmd_InsertRights = DBCon.GetStoredProcCommand("Proc_TA_SelectDashBoardRightsDetails", new object[] { usergroupID });
            cmd_InsertRights.CommandTimeout = 0;
            ds = DBCon.ExecuteDataSet(cmd_InsertRights);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet InsertDashboardRightDetails(string UsergroupName, int BoardId, int Dashboard, int Gridview, int Chart, int Empid, int viewprev)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmdDeleteLevelWiseRights = DBCon.GetStoredProcCommand("Proc_Ta_InsertDashboardRightsDetails ", new object[] { UsergroupName, BoardId, Dashboard, Gridview, Chart, Empid, viewprev });
            cmdDeleteLevelWiseRights.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmdDeleteLevelWiseRights);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet RemoveEmployee_SelectedUserGroup(int employeeid, string comingfrm, int groupid)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmdDeleteLevelWiseRights = DBCon.GetStoredProcCommand("Proc_Ta_RemoveSpecificUserFromSelectedUserGroup ", new object[] { employeeid, comingfrm, groupid });
            cmdDeleteLevelWiseRights.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmdDeleteLevelWiseRights);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
}
