using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
public class AddlWeekOffEventData
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    [DataObjectMethod(DataObjectMethodType.Insert, true)]
    //insert addl week off details
    public void Insert_AddlWeekoffDetails(int LevelId, string AddlWeekoffDay, string AddlWeekoffWeek, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@TYPE", 'I');
            htable.Add("@AddlWeekoffID", 0);
            htable.Add("@LevelId", LevelId);
            htable.Add("@AddlWeekoffDay", AddlWeekoffDay);
            htable.Add("AddlWeekoffWeek", AddlWeekoffWeek);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_Insert_AddlWeekOffDetails");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update addl week off details
    public void Update_AddlWeekoffDetails(int AddlWeekOffID, int LevelId, string AddlWeekoffDay, string AddlWeekoffWeek, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@TYPE", 'U');
            htable.Add("@AddlWeekoffID", AddlWeekOffID);
            htable.Add("@LevelId", LevelId);
            htable.Add("@AddlWeekoffDay", AddlWeekoffDay);
            htable.Add("AddlWeekoffWeek", AddlWeekoffWeek);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_Insert_AddlWeekOffDetails");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //select addl week off details
    public DataSet Select_AddlWeekoffdetails(string userGroupName, int ParentId, string WeekOffDay, string WeekOffWeek)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@TYPE", 'A');
            htable.Add("@AddlWeekOffID", 0);
            htable.Add("@userGroupName", userGroupName);
            htable.Add("@ParentId", ParentId);
            htable.Add("@WeekOffDay", WeekOffDay);
            htable.Add("@WeekOffWeek", WeekOffWeek);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_SelectAddlWeekOffDetails", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //select addl week off details view
    public DataSet Select_AddlWeekoffdetails_view(int addlWeekoffID, string userGroupName)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@TYPE", 'I');
            htable.Add("@AddlWeekOffID", addlWeekoffID);
            htable.Add("@userGroupName", userGroupName);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_SelectAddlWeekOffDetails", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //select addl week off details Modify
    public DataSet Select_AddlWeekoffdetails_Modify(int addlWeekoffID)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@TYPE", 'P');
            htable.Add("@AddlWeekOffID", addlWeekoffID);
            htable.Add("@userGroupName", "");
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_SelectAddlWeekOffDetails", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // permanent delete - addl week off
    public void PermanentDelete_AddlWeekoff(string AddlWeekOffID, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@type", "PermanentDelete");
            htable.Add("@WeedayId", AddlWeekOffID);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteRestoreAddlWeekoff");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // temporary delete - addl week off
    public void TemporaryDelete_AddlWeekoff(string AddlWeekOffID, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@type", "TemporaryDelete");
            htable.Add("@WeedayId", AddlWeekOffID);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteRestoreAddlWeekoff");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // restore - addl week off
    public void Restore_AddlWeekoff(string AddlWeekOffID, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@type", "Restore");
            htable.Add("@WeedayId", AddlWeekOffID);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteRestoreAddlWeekoff");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //temporary delete addl week off details - by single AddlWeekOffID in view page
    public void TemporaryDelete_AddlWeekoffInView(int AddlWeekOffID, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@type", "TemporaryDelete");
            htable.Add("@AddlWeekoffID", AddlWeekOffID);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteAddlWeekoff");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //permanent delete addl week off details - by single AddlWeekOffID in view page
    public void PermanentDelete_AddlWeekoffInView(int AddlWeekOffID, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@type", "PermanentDelete");
            htable.Add("@AddlWeekoffID", AddlWeekOffID);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteAddlWeekoff");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //restore addl week off details - by single AddlWeekOffID in view page
    public void Restore_AddlWeekoffInView(int AddlWeekOffID, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@type", "Restore");
            htable.Add("@AddlWeekoffID", AddlWeekOffID);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteAddlWeekoff");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //check addl weekoff for insert
    public int CheckAddlWeekoff_Insert(int LevelId, string addlWeekoffDay, string addlWeekoffWeek)
    {
        int count = 0;
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@LevelID", LevelId);
            htable.Add("@addlWeekoffDay", addlWeekoffDay);
            htable.Add("@addlWeekoffWeek", addlWeekoffWeek);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_CheckAddlWeekOff_Insert", htable);
            count = Convert.ToInt32(ds.Tables[0].Rows[0]["AID"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //check addl weekoff for update
    public int CheckAddlWeekoff_Update(int AddlWeekoffID, int LevelId, string addlWeekoffDay, string addlWeekoffWeek)
    {
        int count = 0;
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@AddlWeekOffID", AddlWeekoffID);
            htable.Add("@LevelId", LevelId);
            htable.Add("@addlWeekoffDay", addlWeekoffDay);
            htable.Add("@addlWeekoffWeek", addlWeekoffWeek);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_CheckAddlWeekOff_Update", htable);
            count = Convert.ToInt32(ds.Tables[0].Rows[0]["AID"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    // Check whether the Record already Exists while Restoring
    public int CheckRestoreAddlWeekoff(int weekOffId, string weekDay, string weekOffWeek, string Type)
    {
        int count;
        try
        {
            htable.Add("@weekOffId", weekOffId);
            htable.Add("@weekDay", weekDay);
            htable.Add("@weekOffWeek", weekOffWeek);
            htable.Add("@Type", Type);
            count = Convert.ToInt32(objDataAccess.ExecuteScaler("Proc_TA_CheckRestoreWeekOff", htable));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int CheckRestoreAddlWeekoffGroup(string AddlWeekId)
    {
        int count;
        try
        {
            htable.Clear();
            htable.Add("@AddionalWeekId", AddlWeekId);
            count = Convert.ToInt32(objDataAccess.ExecuteScaler("Proc_TA_CheckAdditionalWeeklyOffGroupCount", htable));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public DataSet SelectAdditionalWeekOffLevelRights(int GroupID)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@AdditionalWeekOffId", GroupID);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_SelectAdditionalWeekOffLevelRights", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
}
