using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.ComponentModel;
using System.Collections.Generic;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Diagnostics;
using System.Data.SqlClient;

/// <summary>
/// Summary description for CCGroupEventData
/// </summary>
public class CCGroupEventData_Angler
{
    Database db = DatabaseFactory.CreateDatabase("DBConnection");

    public CCGroupEventData_Angler()
	{
		//
		// TODO: Add constructor logic here
		//
        string strDecryptedString = string.Empty;

        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
	}

    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db.DbProviderFactory;
        db = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }

   // public DataSet GetCCGroupDetails(string UserGroup,int ParentId)
    public DataSet GetCCGroupDetails(string UserGroupName,string LevelRights)
    {
        DataSet dsCCGroupDetails = new DataSet();
        try
        {
            dsCCGroupDetails = db.ExecuteDataSet("Proc_TA_GetCCGroup_Details", new object[] { UserGroupName, LevelRights });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsCCGroupDetails;
    }

    //Fetches the Designation based on the organization.
    public DataSet GetCCGroupDesignation(int LevelID)
    {
        DataSet dsCCGroupDesignation = new DataSet();
        try
        {
            dsCCGroupDesignation = db.ExecuteDataSet("Proc_TA_GetCCGroup_Designation", new object[] { LevelID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsCCGroupDesignation;
    }

    //Inserts,updates and deletes the CC group Id in the CC group parent table.
    public int InsertUpdateDelete_CCGroup(int LevelId,int DesignationId,int PlannedStatus,int UnPlannedstatus,string parameter)
    {
        int CcGroupId;
        try
        {
            CcGroupId = Convert.ToInt32(db.ExecuteScalar("Proc_TA_InsertUpdateDelete_CCGroup", new object[] { LevelId, DesignationId, PlannedStatus, UnPlannedstatus, parameter }));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return CcGroupId;
    }


    //Insert into TA_Tbl_CCGroup_Planned
    public void InsertInto_TA_Tbl_CCGroup_Planned(DataTable dtPlannedCC)
    {
        try
        {
            string strDecryptedString = string.Empty;
            strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();

            SqlBulkCopy sbcPlannedCC = new SqlBulkCopy(strDecryptedString, SqlBulkCopyOptions.TableLock);
            sbcPlannedCC.DestinationTableName = "TA_Tbl_CCGroup_Planned";
            sbcPlannedCC.ColumnMappings.Clear();
            foreach (DataColumn dcColumn in dtPlannedCC.Columns)
            {
                sbcPlannedCC.ColumnMappings.Add(new SqlBulkCopyColumnMapping(dcColumn.ColumnName, dcColumn.ColumnName));
            }
            Stopwatch sw = new Stopwatch();
            sw.Start();
            sbcPlannedCC.WriteToServer(dtPlannedCC);
            sw.Stop();
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    //Insert into TA_Tbl_CCGroup_UnPlanned
    public void InsertInto_TA_Tbl_CCGroup_UnPlanned(DataTable dtUnPlannedCC)
    {
        try
        {
            string strDecryptedString = string.Empty;
            strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();

            SqlBulkCopy sbcUnPlannedCC = new SqlBulkCopy(strDecryptedString, SqlBulkCopyOptions.TableLock);
            sbcUnPlannedCC.DestinationTableName = "TA_Tbl_CCGroup_UnPlanned";
            sbcUnPlannedCC.ColumnMappings.Clear();
            foreach (DataColumn dcColumn in dtUnPlannedCC.Columns)
            {
                sbcUnPlannedCC.ColumnMappings.Add(new SqlBulkCopyColumnMapping(dcColumn.ColumnName, dcColumn.ColumnName));
            }
            Stopwatch sw = new Stopwatch();
            sw.Start();
            sbcUnPlannedCC.WriteToServer(dtUnPlannedCC);
            sw.Stop();
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    //Insert into TA_Tbl_CCGroup_Others
    public void InsertInto_TA_Tbl_CCGroup_Others(DataTable dtOtherCC)
    {
        try
        {
            string strDecryptedString = string.Empty;
            strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();

            SqlBulkCopy sbcOtherCC = new SqlBulkCopy(strDecryptedString, SqlBulkCopyOptions.TableLock);
            sbcOtherCC.DestinationTableName = "TA_Tbl_CCGroup_Others";
            sbcOtherCC.ColumnMappings.Clear();
            foreach (DataColumn dcColumn in dtOtherCC.Columns)
            {
                sbcOtherCC.ColumnMappings.Add(new SqlBulkCopyColumnMapping(dcColumn.ColumnName, dcColumn.ColumnName));
            }
            Stopwatch sw = new Stopwatch();
            sw.Start();
            sbcOtherCC.WriteToServer(dtOtherCC);
            sw.Stop();
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    //Insert into TA_Tbl_CCGroup_ODApproval
    public void InsertInto_TA_Tbl_CCGroup_ODApproval(DataTable dtODCC)
    {
        try
        {
            string strDecryptedString = string.Empty;
            strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();

            SqlBulkCopy sbcODApprovalCC = new SqlBulkCopy(strDecryptedString, SqlBulkCopyOptions.TableLock);
            sbcODApprovalCC.DestinationTableName = "TA_Tbl_CCGroup_ODApproval";
            sbcODApprovalCC.ColumnMappings.Clear();
            foreach (DataColumn dcColumn in dtODCC.Columns)
            {
                sbcODApprovalCC.ColumnMappings.Add(new SqlBulkCopyColumnMapping(dcColumn.ColumnName, dcColumn.ColumnName));
            }
            Stopwatch sw = new Stopwatch();
            sw.Start();
            sbcODApprovalCC.WriteToServer(dtODCC);
            sw.Stop();
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    //Deletes the CC group from the child tables.
    public void delete_CCGroupsInChildTables(string CCGroupId,string parameter)
    {
        try
        {
            DbCommand cmd_deleteCCGroupsInChildTables = db.GetStoredProcCommand("Proc_TA_DeleteCCGroup", new object[] { CCGroupId, parameter });
            db.ExecuteNonQuery(cmd_deleteCCGroupsInChildTables);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }


    //check whether the CC group already exixts or not.
    public int CheckCcGroupExists(int LevelId, int DesignationId)
    {
        int CcGroupExists;
        try
        {
            CcGroupExists = Convert.ToInt32(db.ExecuteScalar("Proc_TA_CheckCCGroupExists", new object[] { LevelId, DesignationId }));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return CcGroupExists;
    }

    // Gets the CC groups
    public DataSet GetCCGroups(int SearchOption, string SearchText)
    {
        DataSet dsCCGroups = new DataSet();
        try
        {
            dsCCGroups = db.ExecuteDataSet("Proc_TA_SelectCCGroups", new object[] { SearchOption, SearchText });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsCCGroups;
    }

    // Gets the specific CC group based on the ID
    public DataSet GetCCGroupById(int CCGroupId)
    {
        DataSet dsCCGroup = new DataSet();
        try
        {
            dsCCGroup = db.ExecuteDataSet("Proc_TA_GetCCGroupById", new object[] { CCGroupId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsCCGroup;
    }

    //Fetches the CC mail Ids.
    public DataSet GetCCEmailIds(int LevelID,int DesignationId,string Parameter)
    {
        DataSet dsCCEmailIds = new DataSet();
        try
        {
            dsCCEmailIds = db.ExecuteDataSet("Proc_TA_GetEmailIdsByUserGroup", new object[] { LevelID, DesignationId, Parameter });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsCCEmailIds;
    }

}
