using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
public class ShiftSettingsEventData
{
    Hashtable htable = new Hashtable();
    DataAccess objDataAccess = new DataAccess();
    public DataSet GetShiftSettings()
    {
        DataSet dsShiftSettings = new DataSet();
        try
        {
            dsShiftSettings = objDataAccess.ExecuteDataSet("Proc_TA_getShiftSettings");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsShiftSettings;
    }
    public DataSet GetShiftSettingsByComId(int CompanyId)
    {
        DataSet dsShiftSettings = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@CompanyId", CompanyId);
            dsShiftSettings = objDataAccess.GetStoredProcCommand("Proc_TA_GetShiftSettingsByComId", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsShiftSettings;
    }
    public int UpdateShiftReportSetting(string weekStartDay, string weekEndDay, string monthStartDay, string monthEndDay)
    {
        int shiftSettingId = 0;
        try
        {
            htable.Clear();
            htable.Add("@WeekStartDay", weekStartDay);
            htable.Add("@WeekEndDay", weekEndDay);
            htable.Add("@MonthStartDay", monthStartDay);
            htable.Add("@MonthEndDay", monthEndDay);
            shiftSettingId = objDataAccess.ExecuteScaler("Proc_TA_UpdateShiftReport", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return shiftSettingId;
    }
    public int insertShiftSetting(string tag, int CompanyId, string maxHoursBeforeShift, string maxHoursAfterShift, string shiftBreak, string shiftMaxBreakHours, string monthlyWorkingHours, string weeklyWorkingHours, string AuditEmp, string HolidayOT, string WeekOffOT, string TwentyFourmaxHoursBeforeShift, string TwentyFourweeklyWorkingHours, string otOption, string strMonthClosureDate, int flexibleStatus, int flexibleValue, int otStatus, int fullAttendance, int halfAttendance, string WeekOffStartHours, int IgnorePunches, string IgnorePunchInterval, int AfterShiftTime, int BeforeShiftTime, int WorkHrs, int NoOfSuccessiveDays, int CompensationDays, string HalfDayComoff, string FullDayComoff, int ValidsDays, int LateEntry, int EarlyEntry, int EarlyExit, int LateExit, bool IsLunchDeduction, string LunchDeductionHours, int flexiAfter, int flexiBefore, int flexiConsider, string CumulativeWeekStartDay, string CumulativeWeekEndDay, string defaultLunch, string maxLunchHrs, string ExceptionHours, int isCarryForwardCOff, int isRequestingforCompOff, bool FirstAndLast)
    {
        int shiftSettingId = 0;
        try
        {
            htable.Clear();
            htable.Add("@tag", tag);
            htable.Add("@CompanyId", CompanyId);
            htable.Add("@maxHoursBeforeShift", maxHoursBeforeShift);
            htable.Add("@maxHoursAfterShift", maxHoursAfterShift);
            htable.Add("@shiftBreak", shiftBreak);
            htable.Add("@shiftMaxBreakHours", shiftMaxBreakHours);
            htable.Add("@monthlyWorkingHours", monthlyWorkingHours);
            htable.Add("@weeklyWorkingHours", weeklyWorkingHours);
            htable.Add("@AuditEmp", AuditEmp);
            htable.Add("@HolidayOT", HolidayOT);
            htable.Add("@WeekOffOT", WeekOffOT);
            htable.Add("@24maxHoursBeforeShift", TwentyFourmaxHoursBeforeShift);
            htable.Add("@24weeklyWorkingHours", TwentyFourweeklyWorkingHours);
            htable.Add("@otOption", otOption);
            htable.Add("@strMonthClosureDate", strMonthClosureDate);
            htable.Add("@flexibleStatus", flexibleStatus);
            htable.Add("@flexibleValue", flexibleValue);
            htable.Add("@otStatus", otStatus);
            htable.Add("@fullAttendance", fullAttendance);
            htable.Add("@halfAttendance", halfAttendance);
            htable.Add("@WeekOffStartHours", WeekOffStartHours);
            htable.Add("@IgnorePunch", IgnorePunches);
            htable.Add("@IgnorePunchInterval", IgnorePunchInterval);
            htable.Add("@AfterShiftTime", AfterShiftTime);
            htable.Add("@BeforeShiftTime", BeforeShiftTime);
            htable.Add("@DefinedWorkhrs", WorkHrs);
            htable.Add("@NoOfSuccessiveDaysInYear", NoOfSuccessiveDays);
            htable.Add("@CompensationValidityDays", CompensationDays);
            htable.Add("@HalfDayCompOff", HalfDayComoff);
            htable.Add("@FullDayCompOff", FullDayComoff);
            htable.Add("@VaildityCompOffDays", ValidsDays);
            htable.Add("@LateEntry", LateEntry);
            htable.Add("@EarlyEntry", EarlyEntry);
            htable.Add("@EarlyExit", EarlyExit);
            htable.Add("@LateExit", LateExit);
            htable.Add("@IsLunchDeduction", IsLunchDeduction);
            htable.Add("@LunchDeductionHours", LunchDeductionHours);
            htable.Add("@Flexi_AfterShiftTime", flexiAfter);
            htable.Add("@Flexi_BeforeShiftTime", flexiBefore);
            htable.Add("@Flexi_DefinedWorkhrs", flexiConsider);
            htable.Add("@CumulativeWeekStartDay", CumulativeWeekStartDay);
            htable.Add("@CumulativeWeekEndDay", CumulativeWeekEndDay);
            htable.Add("@ExceptionHours", ExceptionHours);
            htable.Add("@DefaultLunchHours", defaultLunch);
            htable.Add("@MaxLunchHrs", maxLunchHrs);
            htable.Add("@isCarryForwardCOff", isCarryForwardCOff);
            htable.Add("@isRequestingforCompOff", isRequestingforCompOff);
            htable.Add("@FirstAndLast", FirstAndLast);
            shiftSettingId = objDataAccess.ExecuteScaler("Proc_TA_UpdateShiftSettings", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return shiftSettingId;
    }
    public void InsertOTRoundoffSetting(int shiftSettingId, string startTime, string endTime, float startMins, float endMins, string roundedAs)
    {
        try
        {
            htable.Clear();
            htable.Add("@shiftSettingId", shiftSettingId);
            htable.Add("@startTime", startTime);
            htable.Add("@endTime", endTime);
            htable.Add("@startMins", startMins);
            htable.Add("@endMins", endMins);
            htable.Add("@roundedAs", roundedAs);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_UpdateOTRoundoffSettings");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet GetOTRoundoffByShiftSettingId(int shiftSettingId)
    {
        DataSet dsShiftSettings = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@shiftSettingId", shiftSettingId);
            dsShiftSettings = objDataAccess.ExecuteDataSet("Proc_TA_GetOTRoundoffByShiftSettingId", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsShiftSettings;
    }
    public void DeleteOTRoundoffSetting(int shiftSettingId)
    {
        try
        {
            htable.Clear();
            htable.Add("@shiftSettingId", shiftSettingId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteOTRoundoffSettings");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
}
