using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
/// <summary>
/// Summary description for TempWeekdayEvendata
/// </summary>
public class TempWeekdayEvendata
{
    Hashtable htable = new Hashtable();
    DataAccess objDataAccess = new DataAccess();
    public DataSet InsertWeekday(string TempWeekday_Fromdate, string TempWeekday_Todate, string ClosingTime, string Reason, int Employee_Id, string XmlData, int TempWeekId, string ShiftId)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@TempWeekdayFromDate", TempWeekday_Fromdate);
            htable.Add("@TempWeekdayToDate", TempWeekday_Todate);
            htable.Add("@ClosingTime", ClosingTime);
            htable.Add("@Reason", Reason);
            htable.Add("@Employee_Id", Employee_Id);
            htable.Add("@XMLdata", XmlData);
            htable.Add("@TempWeeklyoffId", TempWeekId);
            htable.Add("@ShiftId", ShiftId);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_InsertTempWeekday", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet SelectTempweekday(string userGroupName, int ParentId, string FromDate, string ToDate)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@userGroupName", userGroupName);
            htable.Add("@ParentId", ParentId);
            htable.Add("@FromDate", FromDate);
            htable.Add("@ToDate", ToDate);
            ds = objDataAccess.GetStoredProcCommand("Proc_SelectWeekday", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void PermanentDeleteTempWeekday(string WeekdayId, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@type", "PermanentDelete");
            htable.Add("@WeedayId", WeekdayId);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteRestoreWeekday");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // temporary delete - temporary week day
    public void TemporaryDeleteTempWeekday(string WeekdayId, int auditEmpId)
    {
        try
        {
            htable.Clear();
            htable.Add("@type", "TemporaryDelete");
            htable.Add("@WeedayId", WeekdayId);
            htable.Add("@auditEmpId", auditEmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteRestoreWeekday");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void RestoreTempWeekday(string WeekdayId, int auditEmpId)
    {
        htable.Clear();
        htable.Add("@type", "Restore");
        htable.Add("@WeedayId", WeekdayId);
        htable.Add("@auditEmpId", auditEmpId);
        try
        {
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteRestoreWeekday");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public int CheckTempWeekDay_Insert(string WeekFromdate, string WeekToDate, string XmlData, string ClosingTime, string ShiftId)
    {
        int count = 0;
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@WeekFromdate", WeekFromdate);
            htable.Add("@WeekTodate", WeekToDate);
            htable.Add("@XMLdata", XmlData);
            htable.Add("@ClosingTime", ClosingTime);
            htable.Add("@ShiftId", ShiftId);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_CheckTempWeekDay_Insert", htable);
            count = Convert.ToInt32(ds.Tables[0].Rows[0]["WeekDateCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int CheckTempWeekDayHoliday_Insert(int TempWeekDay_ID, string WeekFromDate, string WeekToDate, string Type, string LevelId)
    {
        int count = 0;
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@weekDayId", TempWeekDay_ID);
            htable.Add("@WeekFromdate", WeekFromDate);
            htable.Add("@weekTodate", WeekToDate);
            htable.Add("@Type", Type);
            htable.Add("@levelid", LevelId);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_CheckTempWeekDayHoliday_Insert", htable);
            count = Convert.ToInt32(ds.Tables[0].Rows[0]["WeekDateHolidayCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int CheckRestoreWeekdate(int TempWeekDay_ID)
    {
        int count;
        try
        {
            htable.Clear();
            htable.Add("@weekDayId", TempWeekDay_ID);
            count = objDataAccess.ExecuteScaler("Proc_TA_CheckRestoreWeekday", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public DataSet GetTemporaryWeekdayLevels(int TempWeekId)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@TempWeekdayId", TempWeekId);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_TemporaryWeekDayLevelDetails", htable);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ds;
    }
    public DataSet LoadShiftByLevels(string LevelId)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@LevelIds", LevelId);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_LoadShiftByLevelsId", htable);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ds;
    }
    public int GetTempWeeklyOffProcessedDays(int TempWeekday_Id)
    {
        int count = 0;
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@tempWeekday_Id", TempWeekday_Id);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_GetTempWeeklyOffProcessedDays", htable);
            count = Convert.ToInt32(ds.Tables[0].Rows[0]["count"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public DataSet GetShiftByWeekDayId(int TempWeekDay)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@TempWeekDayId", TempWeekDay);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_getShiftByWeekDayId", htable);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ds;
    }
}
