using System;
using System.Collections;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
/// <summary>
/// Summary description for AttendanceEntry
/// </summary>
public class AttendanceEntry
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    public AttendanceEntry()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public DataSet SelectAttendanceReport(DateTime AttendanceDate)
    {
        DataSet ds_AttendanceData = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@AttendanceDate", AttendanceDate);
            ds_AttendanceData = objDataAccess.GetStoredProcCommand("Proc_TA_GetAttendanceData", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_AttendanceData;
    }
    /// <summary>
    /// Load and Update Attendance Data Record
    /// </summary>
    /// <param name="CardNo"></param>
    /// <param name="EmployeeName"></param>
    /// <param name="EmployeeId"></param>
    /// <param name="EmpCategory"></param>
    /// <param name="EmployeeType"></param>
    /// <param name="Designation"></param>
    /// <param name="Gender"></param>
    /// <param name="ParentLevelId"></param>
    /// <param name="Month"></param>
    /// <param name="Year"></param>
    /// <param name="UserGroupName"></param>
    /// <param name="GradeLevel"></param>
    /// <param name="parentLevelId"></param>
    /// <param name="EmpId"></param>
    /// <param name="Presentdays"></param>
    /// <param name="differencedays"></param>
    /// <returns></returns>
    public DataSet GetAttendanceReport(string CardNo, string EmployeeName, string EmployeeId, int EmpCategory, int EmployeeType, int Designation, string Gender, int Month, int Year, string UserGroupName, string GradeLevel, int parentLevelId, string EmpId, decimal Presentdays, decimal differencedays, string Status)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@CardNo", CardNo);
            htable.Add("@EmployeeName", EmployeeName);
            htable.Add("@EmployeeId", EmployeeId);
            htable.Add("@EmpCategory", EmpCategory);
            htable.Add("@EmployeeType", EmployeeType);
            htable.Add("@Designation", Designation);
            htable.Add("@Gender", Gender);
            htable.Add("@Month", Month);
            htable.Add("@Year", Year);
            htable.Add("@UserGroupName", UserGroupName);
            htable.Add("@GradeLevel", GradeLevel);
            htable.Add("@parentLevelId", parentLevelId);
            htable.Add("@EmpId", EmpId);
            htable.Add("@PresentDays", Presentdays);
            htable.Add("@Difference_Days", differencedays);
            htable.Add("@Status", Status);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_GetEmployeeDetails", htable);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ds;
    }
}
