using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Net;
using System.IO;

public class SMSNotification
{
    //creating DB connection
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();    
    public SMSNotification()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public DataSet SelectTemplateDetails(int TemplateID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_Ta_SelectSMSTemplateDetails", new object[] { TemplateID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet SelectTemplateFilterDetails(int TemplateID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectTemplateFilterDetails", new object[] { TemplateID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void UpdatingSMSTemplateStaus(string TemplateID, string status, int EmployeeID)
    {
        try
        {
            DbCommand cmd_updateStatus = DBCon.GetStoredProcCommand("Proc_Ta_UpdatingSMSTemplateStaus", new object[] { TemplateID, status, EmployeeID });
            cmd_updateStatus.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_updateStatus);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet SelectReceiversDetails(int TemplateID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_Ta_SelectReceiversForSMS", new object[] { TemplateID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet SelectTagDetailsUsingTemplate(string TemplateName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_Ta_SelectTagDetailsUsingTemplate", new object[] { TemplateName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void UpdatingSMSTemplateDetails(int TemplateID, string Receivers, string firstNotification, string secondNotification, string Message, string ModifiedBy, int ToEmployee, string LessHrsLimitation, int Continue_AbsentDays, string repofilters, string ReportType, string Tags)
    {
        try
        {
            DbCommand cmd_updateStatus = DBCon.GetStoredProcCommand("Proc_TA_UpdateSMSTemplateDetails", new object[] { TemplateID, Receivers, firstNotification, secondNotification, Message, ModifiedBy, ToEmployee, LessHrsLimitation, Continue_AbsentDays, repofilters, ReportType, Tags });
            cmd_updateStatus.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_updateStatus);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet selectUserGroupForSMS(int TemplateID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectUsergroupDetailsForSMS", new object[] { TemplateID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet SelectGatewayDetails()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_Ta_SelectSMSGateWayDetails", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void UpdatingGatewayDetails(string serviceURL, string destinationKey, string messageKey, string phNo, int empID)
    {
        try
        {
            DbCommand cmd_updateStatus = DBCon.GetStoredProcCommand("Proc_TA_UpdatingSMSGatewayDetails", new object[] { serviceURL, destinationKey, messageKey, phNo, empID });
            cmd_updateStatus.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_updateStatus);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet SelectLogDetails(int parentId, string TemplateName, string receivers, string fromDate, string toDate, int status, string usergroup, string GradeLevel)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_GetSMSLogDetails", new object[] { TemplateName, fromDate, toDate, receivers, usergroup, GradeLevel, parentId, status });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet GetTemplateStauts(string TemplateName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_GetSMSTemplateStatus", new object[] { TemplateName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet GetReceiversDetails(string TemplateName, string Employee_ID, string EmployeeName, string LeaveFrom_LeaveTo, string LeaveType, string NoofDays)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_GettingReceiverDetails", new object[] { TemplateName, Employee_ID, EmployeeName, LeaveFrom_LeaveTo, LeaveType, NoofDays });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void InsertLogDetails(string TemplateName, string Receivers, string EmployeeId, bool status, string message, string StatusMessage)
    {
        try
        {
            DbCommand cmd_updateStatus = DBCon.GetStoredProcCommand("Proc_TA_InsertSMSLogDetailsForNotification", new object[] { TemplateName, Receivers, EmployeeId, status, message, StatusMessage });
            cmd_updateStatus.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_updateStatus);
        }
        catch (Exception)
        {
            throw;
        }
    }    
    public bool SendSMSNotifications(string serviceUrl, string destinationKey, string messageKey, string receivers, string SMSTemplate, string MobNo, string employeeID, string TemplateName, string ReceiversID)
    {
        bool blnCheckSMS = false;
        try
        {
            if (serviceUrl.Contains("=" + destinationKey))
            {
                serviceUrl = serviceUrl.Replace(destinationKey, MobNo);
            }
            if (SMSTemplate.Contains("{User Name}"))
            {
                SMSTemplate = SMSTemplate.Replace("{User Name}", receivers);
            }
            if (serviceUrl.Contains("=" + messageKey))
            {
                serviceUrl = serviceUrl.Replace("=" + messageKey, "=" + SMSTemplate);
            }
            DataTable dtwhiteLists = new DataTable();
            dtwhiteLists = objLeaveApplicationEventData.GetWhiteListData();
            if (dtwhiteLists.Rows.Count > 0)
            {
                if (Convert.ToString(dtwhiteLists.Rows[0]["whiteList"]) != "")
                {
                    serviceUrl = serviceUrl + Convert.ToString(dtwhiteLists.Rows[0]["whiteList"]);
                }
            }
            HttpWebRequest smsRequest = (HttpWebRequest)HttpWebRequest.Create(serviceUrl.ToString());
            smsRequest.Method = WebRequestMethods.Http.Get;
            HttpWebResponse smsResponse = (HttpWebResponse)smsRequest.GetResponse();
            StreamReader responseReader = new StreamReader(smsResponse.GetResponseStream());
            string message = responseReader.ReadToEnd();
            string status = smsResponse.StatusDescription;
            responseReader.Close();
            responseReader.Dispose();
            smsResponse.Close();
            smsRequest = null;
            smsResponse = null;
            InsertLogDetails(TemplateName, ReceiversID, employeeID, true, SMSTemplate, "Fine");
            blnCheckSMS = true;
        }
        catch (Exception ex)
        {
            InsertLogDetails(TemplateName, ReceiversID, employeeID, false, SMSTemplate, ex.Message.ToString());
            blnCheckSMS = false;
        }
        return blnCheckSMS;
    }
}
