using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for DiscrepancyEventData
/// </summary>
public class DiscrepancyEventData
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    public void InsertDiscrepancy(string EmployeeCodeID, string InDate, string InTime, string InPunchType, int InReaderID, string OutDate, string OutTime, string OutPunchType, int OutReaderID, int EmpID, string strManaulEntryStatus, string strReason)
    {
        DbCommand cmd = DBCon.GetStoredProcCommand("Proc_TA_InsertDiscrepancyData", new object[] { EmployeeCodeID, InDate, InTime, InPunchType, InReaderID, OutDate, OutTime, OutPunchType, OutReaderID, EmpID, strManaulEntryStatus, strReason });
        DBCon.ExecuteNonQuery(cmd);
    }
    public DataSet SelectMatchingDevice(string ReaderID, string Para)
    {
        DataSet ds = new DataSet();
        ds = DBCon.ExecuteDataSet("Proc_TA_SelectMatchingDevice", new object[] { ReaderID, Para });
        return ds;
    }
    //Discrepancy List
    public DataSet SelectDiscrepancyList(string dtFromDate, string dtToDate, string empId, int shift, string empName, string levId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int CompanyId, int ParentId, int LoginEmployeeAutoId)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmdSelectDiscrepancyEmployee = DBCon.GetStoredProcCommand("proc_ta_SelectDiscrepancyEmployee", new object[] { dtFromDate, dtToDate, empId, shift, empName, levId, employeeCategory, employeeType, UserGroupName, GradeLevel, strSwipeCard, CompanyId, ParentId, LoginEmployeeAutoId });
            cmdSelectDiscrepancyEmployee.CommandTimeout = 0;
            ds = DBCon.ExecuteDataSet(cmdSelectDiscrepancyEmployee);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public int GetShiftIdBeforeWeekOff(int EmployeeId, string Date)
    {
        int ShiftId = 0;
        try
        {
            ShiftId = (int)DBCon.ExecuteScalar("Proc_TA_GetShiftIdBeforeWeekOff", new object[] { EmployeeId, Date });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ShiftId;
    }
    //Discrepancy List
    public DataSet SelectDiscrepancyData(string EmpID, string dtDate)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectDiscrepancy", new object[] { EmpID, dtDate });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DiscrepancyEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    //AbsentRecords
    public DataSet SelectAbsentRecords(string dtFromDate, string dtToDate, string empId, int shift, string empName, string levId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int CompanyId, int ParentId)
    {
        using (DataSet ds = new DataSet())
        {
            try
            {
                DbCommand cmdSelectAbsentRecords = DBCon.GetStoredProcCommand("proc_ta_SelectAbsentRecords", new object[] { dtFromDate, dtToDate, empId, shift, empName, levId, employeeCategory, employeeType, UserGroupName, GradeLevel, strSwipeCard, CompanyId, ParentId });
                cmdSelectAbsentRecords.CommandTimeout = 0;
                ds.Tables.Add(DBCon.ExecuteDataSet(cmdSelectAbsentRecords).Tables[0].Copy());
            }
            catch (Exception Ex)
            {
                throw Ex;
            }
            return ds;
        }
    }
    public DataSet LoadingPunchTypes(string ReaderId, string ReaderType)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_LoadingPunchTypes", new object[] { ReaderId, ReaderType });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public string CheckPunchTypeForDiscrepancy(string strReaderId, string punchType)
    {
        DataSet ds = new DataSet();
        string Status = string.Empty;
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckPunchTypeForDiscrepancy", new object[] { strReaderId, punchType });
            if (ds.Tables[0].Rows.Count > 0)
                Status = Convert.ToString(ds.Tables[0].Rows[0]["Status"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Status;
    }
}
