using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using System.Web;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for EncashmentEventData
/// </summary>
public class EncashmentEventData
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    DataSet ds_EncashmentDetails = new DataSet();
    public EncashmentEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public void InsertEncashmentDetails(int Employee_Id, int LeaveTypeId, double NumberOfDays, string Reason)
    {
        try
        {
            DbCommand cmd_InsertEncashmentDetails = DBCon.GetStoredProcCommand("Proc_TA_InsertEncashmentDetails", new object[] { Employee_Id, LeaveTypeId, NumberOfDays, Reason });
            cmd_InsertEncashmentDetails.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_InsertEncashmentDetails);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void UpdateEncashmentDetails(int EncashmentId, double NumberOfDays, string Reason)
    {
        try
        {
            DbCommand cmd_UpdateEncashmentDetails = DBCon.GetStoredProcCommand("Proc_TA_UpdateEncashmentDetails", new object[] { EncashmentId, NumberOfDays, Reason });
            cmd_UpdateEncashmentDetails.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_UpdateEncashmentDetails);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    //select all Encashment Details for Particular Employee
    public DataSet SelectEncashmentDetails(int Employee_Id, string GradeLevel, string LevelRights, string UserGroupName, int parentLevelId)
    {
        try
        {
            ds_EncashmentDetails = DBCon.ExecuteDataSet("Proc_TA_SelectEncashmentDetailsByEmpId", new object[] { Employee_Id, GradeLevel, LevelRights, UserGroupName, parentLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EncashmentDetails;
    }
    [DataObjectMethod(DataObjectMethodType.Select, false)]
    //select all Encashment Details For SuperAdmin
    public DataSet SelectEncashmentDetailsSuperAdmin(int Employee_Id, string LevelRights, string EmpCodeId, string EmpFirstName, string StartDate, string EndDate, string strSwipeCard, string UserGroupName, int parentLevelId)
    {
        try
        {
            if (EmpFirstName != null && EmpFirstName != "")
            {
            }
            if (StartDate != "01/01/1900")
            {
                cls_Common objClassCommon = new cls_Common();
                string strDateFormat = Convert.ToString(HttpContext.Current.Session["MDateFormat"]);
                StartDate = objClassCommon.DateConvertion(strDateFormat, StartDate);
                if (EndDate == "01/01/1900")
                {
                    EndDate = (Convert.ToDateTime(System.DateTime.Now.ToShortDateString())).ToString(HttpContext.Current.Session["MDateFormat"].ToString());
                    EndDate = objClassCommon.DateConvertion(strDateFormat, EndDate);
                }
                else
                {
                    EndDate = objClassCommon.DateConvertion(strDateFormat, EndDate);
                }
            }
            ds_EncashmentDetails = DBCon.ExecuteDataSet("Proc_TA_SelectEncashmentDetailsSuperAdmin", new object[] { Employee_Id, LevelRights, EmpCodeId, EmpFirstName, StartDate, EndDate, strSwipeCard, UserGroupName, parentLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EncashmentDetails;
    }
}
