using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for ShiftAllocationEvendata
/// </summary>
public class ShiftAllocationEvendata
{
    Database db_Con = DatabaseFactory.CreateDatabase("DBConnection");
    //for filling grid
    public DataSet SelectEmployee(int EmpAutoID, string LevelId, string UserGroupName, string GradeLevel, int ParentId)
    {
        DataSet ds_Employee = new DataSet();
        try
        {
            ds_Employee = db_Con.ExecuteDataSet("Proc_TA_SelectEmployee", new object[] { EmpAutoID, LevelId, UserGroupName, GradeLevel, ParentId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Employee;
    }
    //for filling grid
    public DataSet SelectEmployeeforpopup(int EmpID,string LevelId, string UserGroupName, string GradeLevel, int ParentId, string EmployeeId, string EmployeeName, int EmpCategoryShift, int EmpTypeShift,string isFrom)
    {        
        DataSet ds_Employee = new DataSet();
        try
        {
            ds_Employee = db_Con.ExecuteDataSet("Proc_TA_SelectEmployeeForPopup", new object[] { EmpID, LevelId, UserGroupName, GradeLevel, ParentId, EmployeeId, EmployeeName, EmpCategoryShift, EmpTypeShift, isFrom });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Employee;
    }
    //for filling employee grid
    public DataSet SelectEmployeeForShiftAlloc(int EmpID, string LevelId, string UserGroupName, string GradeLevel, string EmployeeID, int ParentId, string EmployeeName, int EmployeeCategory, int EmployeeType, int Religion)
    {
        DataSet ds_Employee = new DataSet();
        try
        {
            ds_Employee = db_Con.ExecuteDataSet("Proc_TA_SelectEmployeeForShiftAlloc", new object[] { EmpID, LevelId, UserGroupName, GradeLevel, EmployeeID, ParentId, EmployeeName, EmployeeCategory, EmployeeType, Religion });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Employee;
    }
    public void UpdateOTHours(string Type, int OTMins, string UpOTHours, string OTHours, int UpOTHrs, int Process_Rec_ID)
    {
        try
        {
            DbCommand cmd_UpdateOTHours = db_Con.GetStoredProcCommand("Proc_UpdateOTHours", new object[] { Type, OTMins, UpOTHours, OTHours, UpOTHrs, Process_Rec_ID });
            cmd_UpdateOTHours.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_UpdateOTHours);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //for getting EmpCode,Name based on EmpID for insert into TempShift Allocation
    public DataSet GetEmployee(int EmpID)
    {
        DataSet ds_Employee = new DataSet();
        try
        {
            ds_Employee = db_Con.ExecuteDataSet("Proc_TA_GetEmpforShift", new object[] { EmpID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Employee;
    }
    public DataSet GetEmployeeUsingCode(string EmployeeCode,string UserGroupName,int empAutoID)
    {
        DataSet ds_Employee = new DataSet();
        try
        {
            ds_Employee = db_Con.ExecuteDataSet("Proc_TA_SelectEmployeeCode", new object[] { EmployeeCode, UserGroupName, empAutoID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Employee;
    }
    //insert into tempShift allocation
    public void InsertEmpDetails(int EmpID, string EmployeeId, string EmpName, int loginEmployeeId)
    {
        try
        {
            DbCommand cmd_Insert = db_Con.GetStoredProcCommand("Proc_TA_InsertEmpName", new object[] { EmpID, EmployeeId, EmpName, loginEmployeeId });
            cmd_Insert.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //deleting from tempShift allocation for individual Empid
    public void DeleteEmpDetails(int EmpId, int loginEmployeeId)
    {
        try
        {
            DbCommand cmd_Insert = db_Con.GetStoredProcCommand("Proc_TA_DeleteEmpName", new object[] { 'I', EmpId, loginEmployeeId });
            cmd_Insert.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //deleting all records from tempShift allocation
    public void DeleteEmpShiftDetails(int loginEmployeeId)
    {
        try
        {
            DbCommand cmd_Insert = db_Con.GetStoredProcCommand("Proc_TA_DeleteEmpName", new object[] { 'A', 0, loginEmployeeId });
            cmd_Insert.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //deleting all records from tempShift allocation
    public DataSet DeleteEmpFromTempTable(string xmlData, int loginEmployeeId)
    {
        DataSet dsEmployee = new DataSet();
        try
        {
            dsEmployee = db_Con.ExecuteDataSet("Proc_TA_DeleteEmployeesFromTempTable", new object[] { xmlData, loginEmployeeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmployee;
    }
    public string GetCommaSeparatedValues(string xmlData)
    {
        string strEmployeeIds = string.Empty;
        try
        {
            strEmployeeIds = (string)db_Con.ExecuteScalar("Proc_TA_GetCommaSeparatedValues", new object[] { xmlData });
            return strEmployeeIds;
        }
        catch (Exception ex)
        {
            throw ex;
        }        
    }
    //selecting Employees for shift allocation from tempShift Allocation
    public DataSet SelectEmployeeDetails(int loginEmployeeId)
    {
        DataSet ds_EmployeeDetails = new DataSet();
        try
        {
            ds_EmployeeDetails = db_Con.ExecuteDataSet("Proc_TA_SelectDetails", new object[] { loginEmployeeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EmployeeDetails;
    }
    //selecting Shift Pattern details for shift allocation
    public DataSet SelectShiftPattern_ShiftAllocDetails(int PatternID)
    {
        DataSet ds_Details = new DataSet();
        try
        {
            ds_Details = db_Con.ExecuteDataSet("Proc_TA_SelectShiftPattern_ShiftAllocation", new object[] { PatternID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Details;
    }
    public int CheckShiftAllocation(int EmpId, int Year, int Month)
    {
        DataSet ds_ShiftAllocation = new DataSet();
        try
        {
            ds_ShiftAllocation = db_Con.ExecuteDataSet("Proc_TA_CheckShiftAllocation", new object[] { EmpId, Year, Month });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftAllocation.Tables[0].Rows.Count;
    }
    public int CheckTempShiftAllocation(int EmpId, int Year, int Month)
    {
        DataSet ds_TempShiftAllocation = new DataSet();
        try
        {
            ds_TempShiftAllocation = db_Con.ExecuteDataSet("Proc_TA_CheckTempShiftAllocation", new object[] { EmpId, Year, Month });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TempShiftAllocation.Tables[0].Rows.Count;
    }
    public void InsertShiftAllocation(int Year, int Month, int UserId, string EntryDate, string DateShift, string XMLdata)
    {
        try
        {
            DbCommand cmd_InsertShiftAllocation = db_Con.GetStoredProcCommand("Proc_TA_InsertShiftAllocation", new object[] { Year, Month, UserId, EntryDate, DateShift, XMLdata });
            cmd_InsertShiftAllocation.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_InsertShiftAllocation);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void InsertTempShiftAllocation(int EmpId, int Year, int Month, int UserId, string EntryDate, string DateShift)
    {
        try
        {
            DbCommand cmd_InsertTempShiftAllocation = db_Con.GetStoredProcCommand("Proc_TA_InsertTemporaryShiftAllocation", new object[] { EmpId, Year, Month, UserId, EntryDate, DateShift });
            cmd_InsertTempShiftAllocation.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_InsertTempShiftAllocation);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void InsertTempShiftAllocation_Bulk(int Year, int Month, int UserId, string EntryDate, string DateShift, string XMLdata)
    {
        try
        {
            DbCommand cmd_InsertTempShiftAllocation = db_Con.GetStoredProcCommand("Proc_TA_InsertTemporaryShiftAllocation_Bulk", new object[] { Year, Month, UserId, EntryDate, DateShift, XMLdata });
            cmd_InsertTempShiftAllocation.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_InsertTempShiftAllocation);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void UpdateShiftAllocation(string Query)
    {
        try
        {
            DbCommand cmd_UpdateShiftAllocation = db_Con.GetStoredProcCommand("Proc_TA_UpdateShiftAllocation", new object[] { Query });
            cmd_UpdateShiftAllocation.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_UpdateShiftAllocation);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet SelectShiftroaster()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db_Con.ExecuteDataSet("Temp_ShiftRoaster");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet Shiftpattern(int Id)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db_Con.ExecuteDataSet("Temp_ShiftPatternId", new object[] { Id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet UpdateShift(string ColName, int EmpId, int year, int month)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db_Con.ExecuteDataSet("Proc_TA_UpdateShift", new object[] { ColName, EmpId, year, month });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void Update_ShiftAllocation(string ColName, int year, int month, string employeeAutoID)
    {
        try
        {
            DbCommand cmd_UpdateShiftAllocation = db_Con.GetStoredProcCommand("Proc_TA_Update_ShiftAllocation", new object[] { ColName, year, month, employeeAutoID });
            cmd_UpdateShiftAllocation.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_UpdateShiftAllocation);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void ShiftReAllocation(string ColName, int year, int month, string employeeAutoID, string XMLData)
    {
        try
        {
            DbCommand cmd_UpdateShiftAllocation = db_Con.GetStoredProcCommand("Proc_TA_ShiftReAllocation", new object[] { ColName, year, month, employeeAutoID, XMLData });
            cmd_UpdateShiftAllocation.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_UpdateShiftAllocation);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //updating Clock Process Flag in Raw Data Table
    public void UpdateClockProcess(int EmployeeId, DateTime dtmStartDate, DateTime dtmToDate)
    {
        try
        {
            DbCommand cmd_UpdateClockProcess = db_Con.GetStoredProcCommand("Proc_TA_UpdateClockProcess", new object[] { EmployeeId, dtmStartDate, dtmToDate });
            cmd_UpdateClockProcess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_UpdateClockProcess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Select Over Lapped Employee
    public DataSet SelectOverLappedEmployee(int ShiftId, int LoggedInEmployeeId, string XMLData)
    {
        DataSet dsOverlappedEmployees = new DataSet();
        try
        {
            dsOverlappedEmployees = db_Con.ExecuteDataSet("Proc_TA_CheckShiftOverLapping_ForShiftReallocation", new object[] { ShiftId, LoggedInEmployeeId, XMLData });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsOverlappedEmployees;
    }
    //Shift Permanent Shift Details
    public DataSet SelectPermanentShiftForDate(DateTime dtFromDate, string EmployeeId)
    {
        DataSet ds_PermanentShift = new DataSet();
        try
        {
            ds_PermanentShift = db_Con.ExecuteDataSet("Proc_TA_SelectPermanentShiftForDate", new object[] { dtFromDate, EmployeeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermanentShift;
    }
    //Shift Temporary Shift Details
    public DataSet SelectTemporaryShiftForDate(DateTime dtFromDate, string EmployeeId)
    {
        DataSet ds_TemporaryShift = new DataSet();
        try
        {
            ds_TemporaryShift = db_Con.ExecuteDataSet("Proc_TA_SelectTemporaryShiftForDate", new object[] { dtFromDate, EmployeeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TemporaryShift;
    }
    //Shift Permanent Shift Details
    public DataSet SelectPermanentTemporaryShiftDates(DateTime dtFromDate, DateTime dtToDate, string EmployeeId)
    {
        DataSet ds_PermanentTemporaryShift = new DataSet();
        try
        {
            ds_PermanentTemporaryShift = db_Con.ExecuteDataSet("Proc_TA_SelectPermanentAndTemporaryShiftFromAndToDate", new object[] { dtFromDate, dtToDate, EmployeeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermanentTemporaryShift;
    }
    //Shift Temporary Shift Details
    public DataSet SelectTemporarayShiftAllocationForDates(DateTime dtFromDate, DateTime dtToDate, string EmployeeId)
    {
        DataSet ds_TempShift = new DataSet();
        try
        {
            ds_TempShift = db_Con.ExecuteDataSet("Proc_TA_SelectTemporarayShiftAllocationForDates", new object[] { dtFromDate, dtToDate, EmployeeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TempShift;
    }
    //Shift Permanent Shift Details
    public DataSet SelectPermanentShiftAllocationForDates(DateTime dtFromDate, DateTime dtToDate, string EmployeeId)
    {
        DataSet ds_PermanentShift = new DataSet();
        try
        {
            ds_PermanentShift = db_Con.ExecuteDataSet("Proc_TA_SelectPermanentShiftAllocationForDates", new object[] { dtFromDate, dtToDate, EmployeeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermanentShift;
    }
    public DataSet SelectShiftPatternForShiftAllocation(int companyId)
    {
        DataSet dsShiftPattern = new DataSet();
        try
        {
            dsShiftPattern = db_Con.ExecuteDataSet("Proc_TA_SelectShiftPatternForShiftAllocation", new object[] { companyId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsShiftPattern;
    }
    public DataSet SelectShiftRoasterForShiftAllocation(int companyId)
    {
        DataSet dsShiftRoaster = new DataSet();
        try
        {
            dsShiftRoaster = db_Con.ExecuteDataSet("Proc_TA_SelectShiftRosterForShiftAllocation", new object[] { companyId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsShiftRoaster;
    }
    public void ShiftAllocationReprocess(DateTime FromDate, DateTime ToDate, string EmployeeId)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftAllocationReprocess", new object[] { FromDate, ToDate, EmployeeId });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reprocess the processedData table while allocation shift.
    public void ShiftAllocationReprocess_ProcessedData(DateTime FromDate, DateTime ToDate, string LoginEmployeeId)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftAllocReprocess_ProcessedData", new object[] { FromDate, ToDate, LoginEmployeeId });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reprocess the ClockDetails table while allocation shift.
    public void ShiftAllocationReprocess_ClockDetails(DateTime FromDate, DateTime ToDate, string LoginEmployeeId)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftAllocReprocess_ClockDetails", new object[] { FromDate, ToDate, LoginEmployeeId });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reprocess the ManualTimeEntry table while allocation shift.
    public void ShiftAllocationReprocess_ManualEntry(DateTime FromDate, DateTime ToDate, string LoginEmployeeId)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftAllocReprocess_ManualEntry", new object[] { FromDate, ToDate, LoginEmployeeId });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reprocess the RawData table while allocation shift.
    public void ShiftAllocationReprocess_RawData(DateTime FromDate, DateTime ToDate, string LoginEmployeeId)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftAllocReprocess_RawData", new object[] { FromDate, ToDate, LoginEmployeeId });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reprocess the processedData table while allocation shift.
    public void ShiftReAllocation_Reprocess_ProcessedData(DateTime FromDate, DateTime ToDate, string XMLData, int PreviousShiftId)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftReAlloc_Reprocess_ProcessedData", new object[] { FromDate, ToDate, XMLData, PreviousShiftId });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reprocess the ClockDetails table while allocation shift.
    public void ShiftReAllocation_Reprocess_ClockDetails(DateTime FromDate, DateTime ToDate, string XMLData)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftReAlloc_Reprocess_ClockDetails", new object[] { FromDate, ToDate, XMLData });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reprocess the ManualTimeEntry table while allocation shift.
    public void ShiftReAllocation_Reprocess_ManualEntry(DateTime FromDate, DateTime ToDate, string XMLData)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftReAlloc_Reprocess_ManualEntry", new object[] { FromDate, ToDate, XMLData });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reprocess the RawData table while allocation shift.
    public void ShiftReAllocation_Reprocess_RawData(DateTime FromDate, DateTime ToDate, string XMLData)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftReAlloc_Reprocess_RawData", new object[] { FromDate, ToDate, XMLData });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet CheckLeaveAndPermissionWhileDeleteEmpShift(string EmployeeId, string FromDate, string ToDate, string Func)
    {
        DataSet ds_Shift = new DataSet();
        try
        {
            ds_Shift = db_Con.ExecuteDataSet("Proc_TA_CheckLeaveAndPermissionWhileDeleteEmpShift", new object[] { EmployeeId, FromDate, ToDate, Func });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Shift;
    }
    public DataSet EmployeeShiftAllcationImport(string ShiftData, string WeekOff, bool SkipValid)
    {
        DataSet dsShift = new DataSet();
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_ShiftAllcation_Import", new object[] { ShiftData, WeekOff, SkipValid });
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.LoadDataSet(cmd_ShiftAllocationReprocess, dsShift, "Table");
            //dsShift = db_Con.ExecuteDataSet("Proc_TA_ShiftAllcation_Import", new object[] { ShiftData, WeekOff, SkipValid });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsShift;
    }
    public ShiftAllocationEvendata()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db_Con.DbProviderFactory;
        db_Con = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public DataSet EmployeeInformation(string EmployeeCodeId)
    {
        DataSet dsEmployeeInformation = new DataSet();
        try
        {
            dsEmployeeInformation = db_Con.ExecuteDataSet("Proc_TA_GetEmployeeAutoId", new object[] { EmployeeCodeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmployeeInformation;
    }
    public DataSet ReprocessEmployeeData(DateTime FromDate, DateTime ToDate, string EmployeeCodeId)
    {
        DataSet dsEmployeeInformation = new DataSet();
        try
        {
            dsEmployeeInformation = db_Con.ExecuteDataSet("Proc_TA_ReprocessEmpData", new object[] { FromDate, ToDate, EmployeeCodeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmployeeInformation;
    }    
    public void InsertNearestShiftDetails(Int32 empid, DateTime shftDate,int shiftID)
    {
        try
        {
            DbCommand cmd_ShiftAllocationReprocess = db_Con.GetStoredProcCommand("Proc_TA_InsertNearingShiftDetails", new object[] { empid, shftDate, shiftID});
            cmd_ShiftAllocationReprocess.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_ShiftAllocationReprocess);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
}
