using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Security.Cryptography;
/*
 * Created By   :   Manjula.P
 * Created Date :   17-Jul-2014
 * Descriptions :   Adding this class for dataaccess common layer for common functions
 * */
namespace DataAccessLayer
{
    public class DataAccess
    {
        private static string ConnectionString = ConfigurationManager.ConnectionStrings["DBConnection"].ConnectionString;
        SqlDataAdapter da = new SqlDataAdapter();
        public DataAccess()
        {
        }
        public static SqlConnection GetConnection()
        {
            try
            {
                ConnectionString = Cryptographys.Cryptography.GetDecryptedConnectionString();
                SqlConnection sqlCon = new SqlConnection(ConnectionString);
                if (sqlCon.State != ConnectionState.Closed)
                {
                }
                else if (sqlCon.State == ConnectionState.Closed)
                {
                    sqlCon.Open();
                }
                return sqlCon;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public string CheckDatabaseExists(string conString)
        {
            SqlConnection sqlCon;
            string connStr = conString;
            sqlCon = new SqlConnection(connStr);
            try
            {
                sqlCon.Open();
            }
            catch
            {
                return "0";
            }
            sqlCon.Close();
            return "1";
        }
        public void ExecuteTriggerAndTableScript(string Script, string DeviceDB_ConnectionString)
        {
            int timeout = 600;
            try
            {
                OleDbConnection con = new OleDbConnection(DeviceDB_ConnectionString);
                con.Open();
                OleDbCommand cmd = new OleDbCommand(Script, con);
                cmd.CommandText = Script;
                cmd.CommandTimeout = timeout;
                cmd.ExecuteNonQuery();
                con.Close();
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public static SqlCommand GetDataCommand(string sql, Hashtable param)
        {
            try
            {
                SqlCommand sqlCom = new SqlCommand();
                sqlCom.CommandTimeout = 0;
                sqlCom.CommandText = sql;
                sqlCom.CommandType = CommandType.StoredProcedure;
                sqlCom.Connection = GetConnection();
                if (param != null)
                {
                    if (param.Count > 0)
                    {
                        foreach (string hshKey in param.Keys)
                        {
                            sqlCom.Parameters.Add(new SqlParameter(hshKey, param[hshKey]));
                        }
                    }
                }
                return sqlCom;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public static SqlCommand GetDataCommand(string sql)
        {
            try
            {
                SqlCommand sqlCom = new SqlCommand();
                sqlCom.CommandTimeout = 0;
                sqlCom.CommandText = sql;
                sqlCom.CommandType = CommandType.StoredProcedure;
                sqlCom.Connection = GetConnection();
                return sqlCom;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public DataSet GetStoredProcCommand(string sprocedureName, Hashtable sprocedureParameter)
        {
            try
            {
                DataSet dsData = new DataSet();
                SqlDataAdapter sqlAdap = new SqlDataAdapter();
                sqlAdap.SelectCommand = GetDataCommand(sprocedureName, sprocedureParameter);
                sqlAdap.Fill(dsData);
                sqlAdap.SelectCommand.Connection.Close();
                sqlAdap.SelectCommand.Dispose();
                sqlAdap.Dispose();
                return dsData;
            }
            catch
            {
                throw;
            }
        }
        public void GetStoredProcCommand(Hashtable sprocedureParameter, string sprocedureName)
        {
            try
            {
                SqlCommand sqlCom = GetDataCommand(sprocedureName, sprocedureParameter);
                sqlCom.CommandTimeout = 0;
                sqlCom.ExecuteNonQuery();
                sqlCom.Connection.Close();
                sqlCom.Connection.Dispose();
                sqlCom.Dispose();
            }
            catch
            {
                throw;
            }
        }
        public int ExecuteScaler(string sql, Hashtable param)
        {
            try
            {
                int scaleCount = 0;
                SqlCommand sqlCom = GetDataCommand(sql, param);
                sqlCom.CommandTimeout = 0;
                scaleCount = Convert.ToInt16(sqlCom.ExecuteScalar());
                sqlCom.Connection.Close();
                sqlCom.Connection.Dispose();
                sqlCom.Dispose();
                return scaleCount;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public DataSet ExecuteDataSet(string sprocedureName)
        {
            try
            {
                DataSet dsData = new DataSet();
                SqlDataAdapter sqlAdap = new SqlDataAdapter();
                sqlAdap.SelectCommand = GetDataCommand(sprocedureName);
                sqlAdap.Fill(dsData);
                sqlAdap.SelectCommand.Connection.Close();
                sqlAdap.SelectCommand.Dispose();
                sqlAdap.Dispose();
                return dsData;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public DataSet ExecuteDataSet(string sql, Hashtable param)
        {
            try
            {
                DataSet dsData = new DataSet();
                SqlDataAdapter sqlAdap = new SqlDataAdapter();
                sqlAdap.SelectCommand = GetDataCommand(sql, param);
                sqlAdap.Fill(dsData);
                sqlAdap.SelectCommand.Connection.Close();
                sqlAdap.SelectCommand.Dispose();
                sqlAdap.Dispose();
                return dsData;
            }
            catch (Exception Ex)
            {
                throw Ex;
            }
        }
        public void ExecuteNonQuery(string sprocedureName)
        {
            try
            {
                SqlCommand sqlCom = GetDataCommand(sprocedureName);
                sqlCom.CommandTimeout = 0;
                sqlCom.ExecuteNonQuery();
                sqlCom.Connection.Close();
                sqlCom.Connection.Dispose();
                sqlCom.Dispose();
            }
            catch
            {
                throw;
            }
        }
        public int ExecuteScaler(string sql)
        {
            try
            {
                int scaleCount = 0;
                SqlCommand sqlCom = GetDataCommand(sql);
                sqlCom.CommandTimeout = 0;
                scaleCount = Convert.ToInt16(sqlCom.ExecuteScalar());
                sqlCom.Connection.Close();
                sqlCom.Connection.Dispose();
                sqlCom.Dispose();
                return scaleCount;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public int ReturnExecuteNonQuery(string sprocedureName)
        {
            try
            {
                //Get the stored procedure and input values and execute the sqlcommand
                int scaleCount = 0;
                SqlCommand sqlCom = GetDataCommand(sprocedureName);
                sqlCom.CommandTimeout = 0;
                scaleCount = sqlCom.ExecuteNonQuery();
                sqlCom.Connection.Close();
                sqlCom.Connection.Dispose();
                sqlCom.Dispose();
                return scaleCount;
            }
            catch
            {
                throw;
            }
        }
    }
}
